
uint8 lanc_pedone[4][64];

#define TRIANGOLO 0x00000000080c0e0f
#define MARGINE 0x0000000008040201
#define TRI_MAR 0x80c0e0f0f8fcfeff

#define MASSIMO_PILA 1024
#define MASSIMO_FOPEN 64

uint16 inverso_normale_re[462], inverso_pedone_re[1806],
  quad_due_pedone[1128], quad_due_normale[2016];
uint32 quad_tre_pedone[17296], quad_tre_normale[41664];
uint32 quad_quat_pedone[194580], quad_quat_normale[635376];
sint16 RE_normale[4096], RE_pedone[4096];

int STESSO4[64][64][64][64]; /* BUILD */
int STESSO3[64][64][64];
int STESSO2[64][64];

typedef struct
{
  uint8 pezzo[4], qu[4], br, nr, bianco_en_mossa, pedone;
} tipo_pezzo_quad;

typedef struct
{
  uint64 m[4];
  uint8 *sbuf, *data, *mbuf, *vbuf, *pbuf, *MAR, *VIT, *PER;
  uint8 p[4];
  uint64 pro, pezzo_molt, pezzo_molt8, supp;
  int num, massimo_rima;
  uint32 *indici, BLOCCO_PRO, uBWT;
  logico PEDONE, simm, MEMORIA, TIPO;
  FILE *Fdata, *Frima, *Fvit, *Fmar, *Fper, *Fsupp;
  int *rima_pro, *vit_pro, *per_pro, *mar_pro;
  uint32 supp_indice[8];
  char DIR_NOME[1024];
  char string[32];
}
RobboTotalBase;

void RobboTriple_fare (tipo_posizione *, int, int, int, char *);
tipo_lista_mossa *cattura_gen_total (tipo_posizione *, tipo_lista_mossa *);
void load_triple (char *);
void robbo_triple_directory (char *);
void triple_disposto (char *, logico);

#define emarco(A,w) (A[(w) >> 3] & (1 << ((w) & 7)))
#define en_fisso(A,w) (A[(w) >> 3] |= (1 << ((w) & 7)))
#define ex_fisso(A,w) (A[(w) >> 3] &= ~(1 << ((w) & 7)))

int conto_bianco (tipo_posizione *, uint64 *);
void INIZ_ROBBO_TRIPLE ();

void DISCO_FREAD1 (uint8 *, uint64, uint64, FILE *, uint64);
void DISCO_FREAD2 (uint8 *, uint64, uint64, FILE *, uint64);
int DISCO_FWRITE1 (uint8 *, uint64, uint64, FILE *);
int DISCO_FWRITE2 (uint8 *, uint64, uint64, FILE *);

int huffman1 (unsigned char *, unsigned char *, int);
void dehuffman1 (unsigned char *, int);
int huffman2 (unsigned char *, unsigned char *, int);
void dehuffman2 (unsigned char *, int);
void un_windows (char *);


//#define DIV(a,b) ((a)/(b))
#define DIV(X,a,b) \
  { \
    if ((b) == 1) X = (a); \
    else if ((b) == 48) X = (a) / 48; \
    else if ((b) == 64) X = (a) / 64; \
    else if ((b) == 1128) X = (a) / 1128; \
    else if ((b) == 2016) X = (a) / 2016; \
    else if ((b) == 17296) X = (a) / 17296; \
    else if ((b) == 41664) X = (a) / 41664; \
    else if ((b) == 194580) X = (a) / 194580; \
    else if ((b) == 635376) X = (a) / 635376; \
  }

uint8 lanc_oriz[64], lanc_vert[64], lanc_diag[64];

typedef struct
{
  uint8 qu[4], pezzo[4], rip[4], rip_ai[4], br, nr;
  uint64 m[4], re_fetta_molt, doppio, ind, OCCUPATO, PEDONE, re_fetta,
    pedone_en_quarta;
} tipo_fPOS;

void FORZA_POS (RobboTotalBase *, uint64, tipo_fPOS *);

logico tot_ind_ott (tipo_pezzo_quad *, int *, uint64 *, uint64 *, int *);
uint64 fareMARCO (RobboTotalBase *, int, RobboTotalBase *);
uint64 fareRIMA (RobboTotalBase *, int, RobboTotalBase *);
void iniz_una (RobboTotalBase *);
void fine_una ();
void iniz_vario ();
int compressa (unsigned char *, int, int);
int blocco_decompressa (unsigned char *, unsigned char *, int, int);
void iniz_total_cache (uint64);

#define TRIPLE_DIR "RobboTripleBase"
#define conto_alfiere_bianco conto_chiaro_bianco
#define conto_alfiere_nero conto_chiaro_nero

#define MASSIMO_NUMERO 4
int nome_canonico (char *, logico *);
void RobboTotal_sott (char *);

char ROBBO_TOTAL_DIR[1024];
char COMPRESSA_PREFISSO[1024];
int RobboTotal_scop (char *);
void robbo_total_directory (char *);

#define DISCO_COMPRESSO 0x05
#define DISCO_HUFFMAN 0x03

RobboTotalBase *PILA_ROBBO_TOTAL;
int NUM_ROBBO_TOTAL;
int RTB_PILA[16][16][16][16];
int col_scamb[16];
#define DISCO_NON 1

#define SCACCO \
  (POSIZIONE->bianco_en_mossa ? \
   (bitbordo_bianco_re&DINAMICO->attacco_nero) : \
   (bitbordo_nero_re&DINAMICO->attacco_bianco))
#define ILLEGALE \
  (!POSIZIONE->bianco_en_mossa ? \
   (bitbordo_bianco_re&DINAMICO->attacco_nero) : \
   (bitbordo_nero_re&DINAMICO->attacco_bianco))

#define MASSIMO_RIMA 125
#define VALU_ROTTO (MASSIMO_RIMA+1)
#define VALU_INCOG (MASSIMO_RIMA+2)
#define VALU_VITTORIA (MASSIMO_RIMA+3)
#define VALU_PATTA (MASSIMO_RIMA+4)
#define PRIMERA_PERDITA (MASSIMO_RIMA+5)
#define PERD_IN(x) (PRIMERA_PERDITA+(x))
#define eVITTORIA(valu) ((valu)==VALU_VITTORIA)
#define ePATTA(valu) ((valu)==VALU_PATTA)
#define ePERDITA(valu) ((valu)>=PRIMERA_PERDITA)
#define PATTA_PERDITA(valu) ((valu)>=VALU_PATTA)
#define LARGH (240-MASSIMO_RIMA)
#define PERD_FINE ((PRIMERA_PERDITA)+(LARGH))

#define dROTT 0x00
#define dVITT 0x01
#define dPATT 0x02
#define dPERD0 (dPATT+1)
#define DISCO_PATT_PERD(x) ((x)>=dPATT)
#define DISCO_VITTORIA(x) ((x)==dVITT)
#define DISCO_PATTA(x) ((x)==dPATT)
#define DISCO_PERDITA(x) ((x)>=dPERD0)

void ott_indice (tipo_pezzo_quad *, uint64 *, uint64 *, int *);
logico RobboTotal_valu (tipo_posizione *, int *);
int tot_valu (RobboTotalBase *, uint64);
void re_fetta (RobboTotalBase *, int);
void RobboTotal_add (RobboTotalBase *, char *);
logico RobboTotal_registro (char *);
void iniz_robbo_utilita (logico);
void iniz_total_cache ();

#define SCAMB(x,y) { x ^= y; y ^= x; x ^= y; }
#define LANCpez(u,x) x = lanc_pedone[u][x]
#define LANCnor(u,x) x = lanc_norm[u][x]

uint8 oLANC[64][64], lanc_norm[8][64];
