
#include "RobboLito.h"
#include "RobboTripleBase.h"
#include <string.h>
#include "RobboTotalBase.h"

static char ENUMn[65] =
  { A1, A2, B1, B2, A3, A4, B3, B4, C1, C2, D1, D2, C3, C4, D3, D4,
  A8, A7, B8, B7, A6, A5, B6, B5, C8, C7, D8, D7, C6, C5, D6, D5,
  H1, H2, G1, G2, H3, H4, G3, G4, F1, F2, E1, E2, F3, F4, E3, E4,
  H8, H7, G8, G7, H6, H5, G6, G5, F8, F7, E8, E7, F6, F5, E6, E5, -1
};
static char ENUM0[2] = { -2, -1 };

static char ENUM_BI_PED[49] =
  { A2, B2, C2, D2, E2, F2, G2, H2, A3, B3, C3, D3, E3, F3, G3, H3,
  A4, B4, C4, D4, E4, F4, G4, H4, A5, B5, C5, D5, E5, F5, G5, H5,
  A6, B6, C6, D6, E6, F6, G6, H6, A7, B7, C7, D7, E7, F7, G7, H7, -1
};

static char ENUM_NE_PED[49] =
  { A7, B7, C7, D7, E7, F7, G7, H7, A6, B6, C6, D6, E6, F6, G6, H6,
  A5, B5, C5, D5, E5, F5, G5, H5, A4, B4, C4, D4, E4, F4, G4, H4,
  A3, B3, C3, D3, E3, F3, G3, H3, A2, B2, C2, D2, E2, F2, G2, H2, -1
};

static char ENUM_ALF[65] =
  { A1, A3, B2, C1, A5, B4, C3, D2, E1, A7, B6, C5, D4, E3, F2, G1,
  B8, C7, D6, E5, F4, G3, H2, D8, E7, F6, G5, H4, F8, G7, H6, H8,
  H1, H3, G2, F1, H5, G4, F3, E2, D1, H7, G6, F5, E4, D3, C2, B1,
  G8, F7, E6, D5, C4, B3, A2, E8, D7, C6, B5, A4, C8, B7, A6, A8, -1
};

#define fputI(u, a, F) \
 { \
   int j; \
  for (j = 0; j < u; j++) fputc ( (a >> (8 * j)) & 255, file); \
 }

#define MEMORIA_CONTROL(A, pro, c, N) \
 { \
   if (c > pro - 10) \
     { \
       pro += pro / 4; \
       A = realloc (A, pro * N); \
     } \
}

#define SPUT(r, ch) \
 { \
   L[l++] = (r << 2) + ch; \
   MEMORIA_CONTROL(L, Lpr, l, 4); \
 }

#define PROSSIMO(u) \
  E[w++] = u; \
  if ( (w % PROP) == 0) ok = FALSO;

#define BYTEw(r, ff, tr) \
  { \
    uint8 by = r % 32; \
    ok = VERO; \
    if (r >= 32) by += 128; \
    if (tr) by += 64; \
    if (ff) by += 32; \
    PROSSIMO(by); \
    r -= ( r % 32); \
    r >>= 5; \
    while (r && ok) \
      { \
	by = ( r >= 128 ) * 128 + ( r % 128 ); \
	r -= ( r % 128 ); \
	r >>= 7; \
	PROSSIMO(by); \
      } \
}

#define fis(TH, w, MODO) \
  { \
    int qu = w >> 2, re = w & 3; \
    TH[qu] |= (MODO << (2 * re) ); \
    w++; \
}

#define fis2(TH, w, MODO) \
  { \
    int qu = w >> 2, re = w & 3; \
    TH[qu] |= (MODO << ( 2 * re ) ); \
    w++; \
  }

#define ott(TH, i) \
  (((TH[(i) >> 2]) >> (2 * ((i) & 3))) & 3)

#define OTT(i) \
  ch = DINAMICO[i++]; \
  if ( (i % PR) == 0) ok = 0;

static int C[4], p;

static void
rle (char *b, int c, char *NOME, int *C)
{
  int *L, *I, i, l = 0, r = 0, w = 0, id = 0;
  int A[4], AA[4], la = 0, sb = 0, Ii = 0, PROP;
  char FN[32], ok = 0;
  int Epr = 32 + c / 1024, Ipr = 32 + c / 1024, Lpr = 32 + c / 1024;
  uint8 *E;
  logico tr, ff;
  uint8 ch;
  int cu, te;
  FILE *file;
  char TEMP[32];
#ifdef ROBBO_PICCOLO
  if (strlen (NOME) == 3)
    PROP = 32;
  else
    PROP = 16;
#else
  PROP = 16;
#endif
  if (C[1] > C[2])
    {
      if (C[3] > C[1])
	{
	  A[3] = 1;
	  A[1] = 2;
	  A[2] = 3;
	}
      else if (C[3] > C[2])
	{
	  A[1] = 1;
	  A[3] = 2;
	  A[2] = 3;
	}
      else
	{
	  A[1] = 1;
	  A[2] = 2;
	  A[3] = 3;
	}
    }
  else
    {
      if (C[3] > C[2])
	{
	  A[3] = 1;
	  A[2] = 2;
	  A[1] = 3;
	}
      else if (C[3] > C[1])
	{
	  A[2] = 1;
	  A[3] = 2;
	  A[1] = 3;
	}
      else
	{
	  A[2] = 1;
	  A[1] = 2;
	  A[3] = 3;
	}
    }
  for (i = 1; i <= 3; i++)
    AA[A[i]] = i;
  if (C[AA[2]] == 0)
    {
      strcpy(TEMP, NOME);
      if (TEMP[0] == 'K' || TEMP[0] =='k')
	un_windows_triple (TEMP);
      sprintf (FN, "%s/%d/%s%s", TRIPLE_DIR, (int) strlen (TEMP) + 2,
	       TRIPLE_PREFISSO, NOME);
      file = fopen (FN, "w");
      fputc (AA[1], file);
      fputc (0, file);
      fclose (file);
      file = 0;
      load_triple (NOME);
      return;
    }
  E = malloc (Epr);
  I = malloc (Ipr * sizeof (int));
  L = malloc (Lpr * sizeof (int));
  Ii = 1;
  fis (b, c, 0);
  c--;
  cu = ott (b, 0);
  for (i = 1; i <= c; i++)
    {
      te = ott (b, i);
      if (cu == te)
	{
	  r++;
	  continue;
	}
      r++;
      SPUT (r, cu);
      cu = te;
      r = 0;
    }
  i = 0;
  while (i < l)
    {
      r = L[i] >> 2;
      ch = L[i] & 3;
      id += r;
      if (!la)
	{
	  if (ch != AA[1])
	    sb = la = AA[1];
	  else
	    sb = la = AA[2];
	}
      if (la == AA[1])
	{
	  if (ch == AA[2])
	    tr = FALSO;
	  else
	    tr = VERO;
	}
      else
	{
	  if (ch == AA[1])
	    tr = FALSO;
	  else
	    tr = VERO;
	}
      ff = FALSO;
      if (r == 1 && i > 0 && i < l - 1 && (L[i - 1] & 3) == (L[i + 1] & 3)
	  && (w % PROP))
	{
	  ff = VERO;
	  r = L[++i] >> 2;
	  ch = L[i] & 3;
	  id += r;
	}
      else
	la = ch;
      BYTEw (r, ff, tr);
      i++;
      MEMORIA_CONTROL (E, Epr, w, 1);
      if ((w % PROP) == 0)
	{
	  I[Ii++] = (id << 2) + ch;
	  MEMORIA_CONTROL (I, Ipr, Ii, 4);
	}
    }
  free (L);
  for (i = w % PROP; i < PROP; i++)
    {
      E[w++] = 0;
      MEMORIA_CONTROL (E, Epr, w, 1);
    }
  strcpy(TEMP, NOME);
  if (TEMP[0] == 'K' || TEMP[0]=='k')
    un_windows_triple (TEMP);
  sprintf (FN, "%s/%d/%s%s", TRIPLE_DIR, (int) strlen (TEMP) + 2,
	   TRIPLE_PREFISSO, NOME);
  file = fopen (FN, "w");
  I[Ii] = (c << 2); /* ignored */
  I[0] = sb; /* bugfix */
  fputc (AA[1], file);
  fputc (AA[2], file);
  fputc (AA[3], file);
  fputc (0, file);
  fputI (4, w, file);
  fputI (4, c, file);
  fputI (2, PROP, file);
  fputc (0, file);
  fputc (0, file);
  for (i = 0; i < Ii; i++)
    fputI (4, I[i], file);
  free (I);
  for (i = 0; i < w; i++)
    fputc (E[i], file);
  fflush (file);
  fclose (file);
  free (E);
  file = 0;
}

static void
simmetria (char *C, char *SIM)
{
  int i;
  for (i = 0; C[i]; i++)
    SIM[i] = C[i] ^ 32;
  SIM[i] = 0;
}

void
triple_disposto (char *II, logico B)
{
  int i, j, n;
  logico simm = FALSO;
  char C[16], SIM[16], PEZb[4] = "QRBN", PEZn[4] = "qrbn", A[16];
  char PEZZO[4];
  char I[32];
  strcpy(I, II);
  if (I[0] == 'K' || A[0]=='k')
    un_windows_triple (I);
  strcpy (A, I);
  for (n = strlen (A); n < 4; n++)
    A[n] = 0;
  n = nome_canonico (A, &simm);
  strcpy (C, A);
  for (i = 0; i < n; i++)
    {
      if (C[i] == 'P')
	{
	  for (j = 0; j < 4; j++)
	    {
	      C[i] = PEZb[j];
	      if (cog_triple (C) == 0)
		{
		  if (B)
		    {
		      printf ("Recursing %s\n", C);
		      triple_disposto (C, B);
		    }
		  else
		    {
		      printf ("Needed dependency %s unavailable\n", C);
		      return;
		    }
		}
	      simmetria (C, SIM);
	      if (cog_triple (SIM) == 0)
		{
		  if (B)
		    {
		      printf ("Recursing %s\n", SIM);
		      triple_disposto (SIM, B);
		    }
		  else
		    {
		      printf ("Needed dependency %s unavailable\n", SIM);
		      return;
		    }
		}
	    }
	  C[i] = 'P';
	}
      if (C[i] == 'p')
	{
	  for (j = 0; j < 4; j++)
	    {
	      C[i] = PEZn[j];
	      if (cog_triple (C) == 0)
		{
		  if (B)
		    {
		      printf ("Recursing %s\n", C);
		      triple_disposto (C, B);
		    }
		  else
		    {
		      printf ("Needed dependency %s unavailable\n", C);
		      return;
		    }
		}
	    }
	  C[i] = 'p';
	}
    }
  for (i = 0; i < n; i++)
    {
      C[i] = A[n - 1];
      C[n - 1] = 0;
      if (cog_triple (C) == 0)
	{
	  if (B)
	    {
	      printf ("Recursing %s\n", C);
	      triple_disposto (C, B);
	    }
	  else
	    {
	      printf ("Needed dependency %s unavailable\n", C);
	      return;
	    }
	}
      C[i] = A[i];
    }
  for (i = 0; i < 4; i++)
    switch (I[i])
      {
      case 'Q':
	PEZZO[i] = conto_donna_bianca;
	continue;
      case 'q':
	PEZZO[i] = conto_donna_nera;
	continue;
      case 'R':
	PEZZO[i] = conto_torre_bianco;
	continue;
      case 'r':
	PEZZO[i] = conto_torre_nero;
	continue;
      case 'B':
	PEZZO[i] = conto_alfiere_bianco;
	continue;
      case 'b':
	PEZZO[i] = conto_alfiere_nero;
	continue;
      case 'N':
	PEZZO[i] = conto_cavallo_bianco;
	continue;
      case 'n':
	PEZZO[i] = conto_cavallo_nero;
	continue;
      case 'P':
	PEZZO[i] = conto_pedone_bianco;
	continue;
      case 'p':
	PEZZO[i] = conto_pedone_nero;
	continue;
      default:
	PEZZO[i] = 0;
      }
  tipo_posizione POSIZIONE[1];
  POSIZIONE->din_iniz = malloc(abisso_massimo * sizeof(tipo_dinamico));
  POSIZIONE->DIN = POSIZIONE->din_iniz;
  RobboTriple_fare (POSIZIONE, PEZZO[0], PEZZO[1], PEZZO[2], I);
  free (POSIZIONE->din_iniz);
}

#define conto_alfiere_bianco conto_chiaro_bianco
#define conto_alfiere_nero conto_chiaro_nero

void
RobboTriple_fare
 (tipo_posizione *POSIZIONE, int PEZZO1, int PEZZO2, int PEZZO3, char *inome_file)
{
  int sca = 0, u, MODO = vNON, mal = 0, RTB = 0, valu2, va1, va2, va3, w = 0;
  int b, s, cattvi = 0, cattpa = 0;
  int nr, br, mossa, ai, di, pb = 0, c2 = 0, pr, pezzo, cattura;
  const short int *PILA;
  char *TH, *E1, *E2, *E3;
  uint64 O;
  int rip = 0;
  tipo_lista_mossa LISTA[256], *lista;
  int i, j, k;
  char nome_file[256];

#ifdef NOME_WINDOWS
  nome_file[0] = 'K';
  j = 0;
  while (inome_file[j])
    {
      if (inome_file[j] <= 'Z')
	{
	  nome_file[2 * j + 1] = 'w';
	  nome_file[2 * j + 2] = inome_file[j] + 32;
	}
      else
	{
	  nome_file[2 * j + 1] = 'b';
	  nome_file[2 * j + 2] = inome_file[j];
	}
      j++;
    }
  nome_file[2 * j + 1] = 0;
#else
  strcpy(nome_file, inome_file);
#endif

  printf ("RobboTriple_fare %s\n", nome_file);
  POSIZIONE->bianco_en_mossa = VERO;
  p = 0;
  E1 = ENUMn;
  E2 = ENUMn;
  E3 = ENUMn;
  PILA = RE_normale;
  if (PEZZO1 == conto_pedone_bianco || PEZZO1 == conto_pedone_nero)
    PILA = RE_pedone;
  if (PEZZO2 == conto_pedone_bianco || PEZZO2 == conto_pedone_nero)
    PILA = RE_pedone;
  if (PEZZO3 == conto_pedone_bianco || PEZZO3 == conto_pedone_nero)
    PILA = RE_pedone;
  C[0] = C[1] = C[2] = C[3] = 0;
  DINAMICO->mossa50 = 0;
  DINAMICO->en_passant = DINAMICO->arrocco = 0;
  if (!PEZZO1)
    E1 = ENUM0;
  if (PEZZO1 == conto_pedone_bianco)
    E1 = ENUM_BI_PED;
  if (PEZZO1 == conto_pedone_nero)
    E1 = ENUM_NE_PED;
  if (!PEZZO2)
    E2 = ENUM0;
  if (PEZZO2 == conto_pedone_bianco)
    E2 = ENUM_BI_PED;
  if (PEZZO2 == conto_pedone_nero)
    E2 = ENUM_NE_PED;
  if (!PEZZO3)
    E3 = ENUM0;
  if (PEZZO3 == conto_pedone_bianco)
    E3 = ENUM_BI_PED;
  if (PEZZO3 == conto_pedone_nero)
    E3 = ENUM_NE_PED;
  if (PEZZO1 == conto_alfiere_bianco || PEZZO1 == conto_alfiere_nero)
    E1 = ENUM_ALF;
  if (PEZZO2 == conto_alfiere_bianco || PEZZO2 == conto_alfiere_nero)
    E2 = ENUM_ALF;
  if (PEZZO3 == conto_alfiere_bianco || PEZZO3 == conto_alfiere_nero)
    E3 = ENUM_ALF;
  TH = malloc (355100000 / 4);
  for (i = 0; i < 355100000 / 4; i++)
    TH[i] = 0;
  for (u = A1; u <= H8; u++)
    POSIZIONE->qu[u] = 0;
  int rf, RF = (PILA == RE_pedone) ? 1806 : 462;
  for (rf = 0; rf < RF; rf++)
    {
      if (PILA == RE_normale)
	{
	  br = inverso_normale_re[rf] >> 6;
	  nr = inverso_normale_re[rf] & 63;
	}
      if (PILA == RE_pedone)
	{
	  br = inverso_pedone_re[rf] >> 6;
	  nr = inverso_pedone_re[rf] & 63;
	}
      if (PEZZO3 && (PILA[64 * br + nr] & 15) == 0)
	printf ("%c%c %c%c %d %d\n", (br & 7) + 'a', (br / 8) + '1',
		(nr & 7) + 'a', (nr / 8) + '1', w, PILA[64 * br + nr]);
      for (i = 0; (va1 = E1[i]) != -1; i++)
	for (j = 0; (va2 = E2[j]) != -1; j++)
	  for (k = 0; (va3 = E3[k]) != -1; k++)
	    {
	      if (PEZZO1 == PEZZO2 && PEZZO1 && j >= i)
		continue;
	      if (PEZZO2 == PEZZO3 && PEZZO2 && k >= j)
		continue;
	      POSIZIONE->bianco_re_quadretto = br;
	      POSIZIONE->nero_re_quadretto = nr;
	      bitbordo_bianco_re = quadretto_fisso[br];
	      bitbordo_nero_re = quadretto_fisso[nr];
	      bitbordo_bianca_donna = bitbordo_bianco_torre =
		bitbordo_bianco_cavallo = bitbordo_bianco_scuro =
		bitbordo_bianco_chiaro = bitbordo_bianco_pedone = 0;
	      bitbordo_nera_donna = bitbordo_nero_torre =
		bitbordo_nero_cavallo = bitbordo_nero_scuro =
		bitbordo_nero_chiaro = bitbordo_nero_pedone = 0;
	      switch (PEZZO1)
		{
		case conto_donna_bianca:
		  bitbordo_bianca_donna |= quadretto_fisso[va1];
		  break;
		case conto_torre_bianco:
		  bitbordo_bianco_torre |= quadretto_fisso[va1];
		  break;
		case conto_cavallo_bianco:
		  bitbordo_bianco_cavallo |= quadretto_fisso[va1];
		  break;
		case conto_pedone_bianco:
		  bitbordo_bianco_pedone |= quadretto_fisso[va1];
		  break;
		case conto_donna_nera:
		  bitbordo_nera_donna |= quadretto_fisso[va1];
		  break;
		case conto_pedone_nero:
		  bitbordo_nero_pedone |= quadretto_fisso[va1];
		  break;
		case conto_cavallo_nero:
		  bitbordo_nero_cavallo |= quadretto_fisso[va1];
		  break;
		case conto_torre_nero:
		  bitbordo_nero_torre |= quadretto_fisso[va1];
		  break;
		case conto_alfiere_bianco:
		  if (quadretto_fisso[va1] & CHIARO)
		    bitbordo_bianco_chiaro |= quadretto_fisso[va1];
		  else
		    bitbordo_bianco_scuro |= quadretto_fisso[va1];
		  break;
		case conto_alfiere_nero:
		  if (quadretto_fisso[va1] & CHIARO)
		    bitbordo_nero_chiaro |= quadretto_fisso[va1];
		  else
		    bitbordo_nero_scuro |= quadretto_fisso[va1];
		  break;
		}
	      switch (PEZZO2)
		{
		case conto_donna_bianca:
		  bitbordo_bianca_donna |= quadretto_fisso[va2];
		  break;
		case conto_torre_bianco:
		  bitbordo_bianco_torre |= quadretto_fisso[va2];
		  break;
		case conto_cavallo_bianco:
		  bitbordo_bianco_cavallo |= quadretto_fisso[va2];
		  break;
		case conto_pedone_bianco:
		  bitbordo_bianco_pedone |= quadretto_fisso[va2];
		  break;
		case conto_donna_nera:
		  bitbordo_nera_donna |= quadretto_fisso[va2];
		  break;
		case conto_pedone_nero:
		  bitbordo_nero_pedone |= quadretto_fisso[va2];
		  break;
		case conto_cavallo_nero:
		  bitbordo_nero_cavallo |= quadretto_fisso[va2];
		  break;
		case conto_torre_nero:
		  bitbordo_nero_torre |= quadretto_fisso[va2];
		  break;
		case conto_alfiere_bianco:
		  if (quadretto_fisso[va2] & CHIARO)
		    bitbordo_bianco_chiaro |= quadretto_fisso[va2];
		  else
		    bitbordo_bianco_scuro |= quadretto_fisso[va2];
		  break;
		case conto_alfiere_nero:
		  if (quadretto_fisso[va2] & CHIARO)
		    bitbordo_nero_chiaro |= quadretto_fisso[va2];
		  else
		    bitbordo_nero_scuro |= quadretto_fisso[va2];
		  break;
		}
	      switch (PEZZO3)
		{
		case conto_donna_bianca:
		  bitbordo_bianca_donna |= quadretto_fisso[va3];
		  break;
		case conto_torre_bianco:
		  bitbordo_bianco_torre |= quadretto_fisso[va3];
		  break;
		case conto_cavallo_bianco:
		  bitbordo_bianco_cavallo |= quadretto_fisso[va3];
		  break;
		case conto_pedone_bianco:
		  bitbordo_bianco_pedone |= quadretto_fisso[va3];
		  break;
		case conto_donna_nera:
		  bitbordo_nera_donna |= quadretto_fisso[va3];
		  break;
		case conto_pedone_nero:
		  bitbordo_nero_pedone |= quadretto_fisso[va3];
		  break;
		case conto_cavallo_nero:
		  bitbordo_nero_cavallo |= quadretto_fisso[va3];
		  break;
		case conto_torre_nero:
		  bitbordo_nero_torre |= quadretto_fisso[va3];
		  break;
		case conto_alfiere_bianco:
		  if (quadretto_fisso[va3] & CHIARO)
		    bitbordo_bianco_chiaro |= quadretto_fisso[va3];
		  else
		    bitbordo_bianco_scuro |= quadretto_fisso[va3];
		  break;
		case conto_alfiere_nero:
		  if (quadretto_fisso[va3] & CHIARO)
		    bitbordo_nero_chiaro |= quadretto_fisso[va3];
		  else
		    bitbordo_nero_scuro |= quadretto_fisso[va3];
		  break;
		}

	      bitbordo_occupato_bianco =
		bitbordo_bianco_pedone | bitbordo_bianco_cavallo |
		bitbordo_bianco_alfiere | bitbordo_bianco_torre |
		bitbordo_bianca_donna | bitbordo_bianco_re;
	      POSIZIONE->occupato_sinistro90 = POSIZIONE->occupato_sinistro45 =
		POSIZIONE->occupato_retto45 = 0;
	      bitbordo_occupato_nero =
		bitbordo_nero_pedone | bitbordo_nero_cavallo |
		bitbordo_nero_alfiere | bitbordo_nero_torre |
		bitbordo_nera_donna | bitbordo_nero_re;
	      O = bitbordo_occupato_bianco | bitbordo_occupato_nero;
	      POSIZIONE->occupato_nero_bianco = O;
	      if (PEZZO1)
		POSIZIONE->qu[va1] = PEZZO1;
	      if (PEZZO2)
		POSIZIONE->qu[va2] = PEZZO2;
	      if (PEZZO3)
		POSIZIONE->qu[va3] = PEZZO3;
	      if (PEZZO1 == conto_alfiere_bianco
		  && quadretto_fisso[va1] & CHIARO)
		POSIZIONE->qu[va1] = conto_chiaro_bianco;
	      if (PEZZO1 == conto_alfiere_bianco
		  && quadretto_fisso[va1] & SCURO)
		POSIZIONE->qu[va1] = conto_scuro_bianco;
	      if (PEZZO2 == conto_alfiere_bianco
		  && quadretto_fisso[va2] & CHIARO)
		POSIZIONE->qu[va2] = conto_chiaro_bianco;
	      if (PEZZO2 == conto_alfiere_bianco
		  && quadretto_fisso[va2] & SCURO)
		POSIZIONE->qu[va2] = conto_scuro_bianco;
	      if (PEZZO3 == conto_alfiere_bianco
		  && quadretto_fisso[va3] & CHIARO)
		POSIZIONE->qu[va3] = conto_chiaro_bianco;
	      if (PEZZO3 == conto_alfiere_bianco
		  && quadretto_fisso[va3] & SCURO)
		POSIZIONE->qu[va3] = conto_scuro_bianco;
	      if (PEZZO1 == conto_alfiere_nero
		  && quadretto_fisso[va1] & CHIARO)
		POSIZIONE->qu[va1] = conto_chiaro_nero;
	      if (PEZZO1 == conto_alfiere_nero
		  && quadretto_fisso[va1] & SCURO)
		POSIZIONE->qu[va1] = conto_scuro_nero;
	      if (PEZZO2 == conto_alfiere_nero
		  && quadretto_fisso[va2] & CHIARO)
		POSIZIONE->qu[va2] = conto_chiaro_nero;
	      if (PEZZO2 == conto_alfiere_nero
		  && quadretto_fisso[va2] & SCURO)
		POSIZIONE->qu[va2] = conto_scuro_nero;
	      if (PEZZO3 == conto_alfiere_nero
		  && quadretto_fisso[va3] & CHIARO)
		POSIZIONE->qu[va3] = conto_chiaro_nero;
	      if (PEZZO3 == conto_alfiere_nero
		  && quadretto_fisso[va3] & SCURO)
		POSIZIONE->qu[va3] = conto_scuro_nero;
	      POSIZIONE->bianco_en_mossa = VERO;
	      POSIZIONE->qu[POSIZIONE->bianco_re_quadretto] = conto_re_bianco;
	      POSIZIONE->qu[POSIZIONE->nero_re_quadretto] = conto_re_nero;
	      while (O)
		{
		  b = BSF (O);
		  POSIZIONE->occupato_sinistro90 |=
		    quadretto_fisso[sinistro90[b]];
		  POSIZIONE->occupato_sinistro45 |=
		    quadretto_fisso[sinistro45[b]];
		  POSIZIONE->occupato_retto45 |= quadretto_fisso[retto45[b]];
		  bitLIBERO (b, O);
		}
	      POSIZIONE->bianco_en_mossa = VERO;
	      mobilita (POSIZIONE);
#define SCACCO (bitbordo_bianco_re & DINAMICO->attacco_nero)
#ifdef ROBBO_SCACCO
	      if (SCACCO && PEZZO3)
		{
		  sca++;
		  fis2 (TH, w, MODO);
		  goto LACCIO;
		}
#endif

#define ILLEGALE \
	      (POSIZIONE->bianco_en_mossa ? \
	       (bitbordo_nero_re & DINAMICO->attacco_bianco) : \
	       (bitbordo_bianco_re & DINAMICO->attacco_nero) )
#define MALATO \
	      ( (va1==va2 && PEZZO1!=0) || \
		(va1==va3 && PEZZO1!=0) || \
		(va2==va3 && PEZZO2!=0) || \
		(va1==POSIZIONE->bianco_re_quadretto) || \
		(va2==POSIZIONE->bianco_re_quadretto) || \
		(va3==POSIZIONE->bianco_re_quadretto) || \
		(va1==POSIZIONE->nero_re_quadretto) || \
		(va2==POSIZIONE->nero_re_quadretto) || \
		(va3==POSIZIONE->nero_re_quadretto) || ILLEGALE)
	      if (MALATO || !RobboTotal_valu (POSIZIONE, &s) || s == dROTT)
		{
		  mal++;
		  fis2 (TH, w, MODO);
		  goto LACCIO;
		}
	      if (DISCO_PATTA (s) && MODO == ePAT)
		{
		  C[2]++;
		  rip++;
		  fis2 (TH, w, MODO);
		  goto LACCIO;
		}
	      if (DISCO_VITTORIA (s) && MODO == eVIT)
		{
		  C[1]++;
		  rip++;
		  fis2 (TH, w, MODO);
		  goto LACCIO;
		}
	      if (DISCO_PERDITA (s) && MODO == ePER)
		{
		  C[3]++;
		  rip++;
		  fis2 (TH, w, MODO);
		  goto LACCIO;
		}
	      lista = cattura_gen_total (POSIZIONE, LISTA);
	      for (u = 0; u < lista - LISTA; u++)
		{
		  mossa = LISTA[u].mossa;
		  ai = AI (mossa);
		  di = DI (mossa);
		  cattura = POSIZIONE->qu[ai];
		  pr = mossa_promozione (mossa);
		  pezzo = POSIZIONE->qu[di];
		  switch (cattura)
		    {
		    case conto_cavallo_nero:
		      bitbordo_nero_cavallo ^= quadretto_fisso[ai];
		      break;
		    case conto_torre_nero:
		      bitbordo_nero_torre ^= quadretto_fisso[ai];
		      break;
		    case conto_chiaro_nero:
		      bitbordo_nero_chiaro ^= quadretto_fisso[ai];
		      break;
		    case conto_scuro_nero:
		      bitbordo_nero_scuro ^= quadretto_fisso[ai];
		      break;
		    case conto_pedone_nero:
		      bitbordo_nero_pedone ^= quadretto_fisso[ai];
		      break;
		    case conto_donna_nera:
		      bitbordo_nera_donna ^= quadretto_fisso[ai];
		      break;
		    }
		  switch (pezzo)
		    {
		    case conto_re_bianco:
		      POSIZIONE->bianco_re_quadretto = ai;
		      bitbordo_bianco_re = quadretto_fisso[ai];
		      break;
		    case conto_torre_bianco:
		      bitbordo_bianco_torre ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_donna_bianca:
		      bitbordo_bianca_donna ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_chiaro_bianco:
		      bitbordo_bianco_chiaro ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_scuro_bianco:
		      bitbordo_bianco_scuro ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_cavallo_bianco:
		      bitbordo_bianco_cavallo ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_pedone_bianco:
		      bitbordo_bianco_pedone ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    }
		  bitbordo_occupato_bianco ^=
		    quadretto_fisso[ai] ^ quadretto_fisso[di];
		  if (cattura)
		    bitbordo_occupato_nero ^= quadretto_fisso[ai];
		  POSIZIONE->occupato_nero_bianco =
		    bitbordo_occupato_bianco | bitbordo_occupato_nero;
		  POSIZIONE->occupato_sinistro90 ^=
		    quadretto_fisso[sinistro90[di]];
		  POSIZIONE->occupato_sinistro45 ^=
		    quadretto_fisso[sinistro45[di]];
		  POSIZIONE->occupato_retto45 ^= quadretto_fisso[retto45[di]];
		  if (!cattura)
		    {
		      POSIZIONE->occupato_sinistro90 ^=
			quadretto_fisso[sinistro90[ai]];
		      POSIZIONE->occupato_sinistro45 ^=
			quadretto_fisso[sinistro45[ai]];
		      POSIZIONE->occupato_retto45 ^=
			quadretto_fisso[retto45[ai]];
		    }
		  if (pr && ((mossa >> 12) & 7) == 7)
		    {
		      bitbordo_bianco_pedone ^= quadretto_fisso[ai];
		      bitbordo_bianca_donna ^= quadretto_fisso[ai];
		    }
		  POSIZIONE->qu[ai] = pezzo;
		  if (pr)
		    POSIZIONE->qu[ai] = conto_donna_bianca;
		  POSIZIONE->bianco_en_mossa = FALSO;
		  mobilita (POSIZIONE);
		  if (!ILLEGALE && RobboTotal_valu (POSIZIONE, &valu2))
		    pb++;
		  else
		    valu2 = 1000;
		  c2++;
		  POSIZIONE->bianco_en_mossa = VERO;
		  switch (cattura)
		    {
		    case conto_cavallo_nero:
		      bitbordo_nero_cavallo ^= quadretto_fisso[ai];
		      break;
		    case conto_torre_nero:
		      bitbordo_nero_torre ^= quadretto_fisso[ai];
		      break;
		    case conto_chiaro_nero:
		      bitbordo_nero_chiaro ^= quadretto_fisso[ai];
		      break;
		    case conto_scuro_nero:
		      bitbordo_nero_scuro ^= quadretto_fisso[ai];
		      break;
		    case conto_pedone_nero:
		      bitbordo_nero_pedone ^= quadretto_fisso[ai];
		      break;
		    case conto_donna_nera:
		      bitbordo_nera_donna ^= quadretto_fisso[ai];
		      break;
		    }
		  switch (pezzo)
		    {
		    case conto_re_bianco:
		      POSIZIONE->bianco_re_quadretto = di;
		      bitbordo_bianco_re = quadretto_fisso[di];
		      break;
		    case conto_torre_bianco:
		      bitbordo_bianco_torre ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_donna_bianca:
		      bitbordo_bianca_donna ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_chiaro_bianco:
		      bitbordo_bianco_chiaro ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_scuro_bianco:
		      bitbordo_bianco_scuro ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_cavallo_bianco:
		      bitbordo_bianco_cavallo ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    case conto_pedone_bianco:
		      bitbordo_bianco_pedone ^=
			quadretto_fisso[ai] ^ quadretto_fisso[di];
		      break;
		    }
		  POSIZIONE->qu[di] = pezzo;
		  POSIZIONE->qu[ai] = cattura;
		  bitbordo_occupato_bianco ^=
		    quadretto_fisso[ai] ^ quadretto_fisso[di];
		  if (cattura)
		    bitbordo_occupato_nero ^= quadretto_fisso[ai];
		  POSIZIONE->occupato_nero_bianco =
		    bitbordo_occupato_bianco | bitbordo_occupato_nero;
		  POSIZIONE->occupato_sinistro90 ^=
		    quadretto_fisso[sinistro90[di]];
		  POSIZIONE->occupato_sinistro45 ^=
		    quadretto_fisso[sinistro45[di]];
		  POSIZIONE->occupato_retto45 ^= quadretto_fisso[retto45[di]];
		  if (!cattura)
		    {
		      POSIZIONE->occupato_sinistro90 ^=
			quadretto_fisso[sinistro90[ai]];
		      POSIZIONE->occupato_sinistro45 ^=
			quadretto_fisso[sinistro45[ai]];
		      POSIZIONE->occupato_retto45 ^=
			quadretto_fisso[retto45[ai]];
		    }
		  if (pr && ((mossa >> 12) & 7) == 7)
		    {
		      bitbordo_bianco_pedone ^= quadretto_fisso[ai];
		      bitbordo_bianca_donna ^= quadretto_fisso[ai];
		    }
		  if (pr && ((mossa >> 12) & 7) == 4)
		    {
		      bitbordo_bianco_pedone ^= quadretto_fisso[ai];
		      bitbordo_bianco_cavallo ^= quadretto_fisso[ai];
		    }
		  if (valu2 != 1000 && DISCO_PERDITA (valu2))
		    {
		      cattvi++;
		      fis2 (TH, w, MODO);
		      goto LACCIO;
		    }
		  if (valu2 != 1000 && DISCO_PATTA (valu2) && DISCO_PATTA (s)
		      && ott (TH, w - 1) != eVIT && ott (TH, w - 1) != vNON)
		    {
		      cattpa++;
		      fis2 (TH, w, MODO);
		      goto LACCIO;
		    }
		}
	      POSIZIONE->bianco_en_mossa = VERO;
	      if (DISCO_PATTA (s))
		{
		  C[2]++;
		  MODO = ePAT;
		}
	      if (DISCO_VITTORIA (s))
		{
		  C[1]++;
		  MODO = eVIT;
		}
	      if (DISCO_PERDITA (s))
		{
		  C[3]++;
		  MODO = ePER;
		}
	      fis2 (TH, w, MODO);
	      RTB++;
	    LACCIO:if (PEZZO1)
		POSIZIONE->qu[va1] = 0;
	      if (PEZZO2)
		POSIZIONE->qu[va2] = 0;
	      if (PEZZO3)
		POSIZIONE->qu[va3] = 0;
	      POSIZIONE->qu[POSIZIONE->bianco_re_quadretto] = 0;
	      POSIZIONE->qu[POSIZIONE->nero_re_quadretto] = 0;
	    }
    }
  printf ("s%d 210:%d/%d/%d\nmal:%d sc:%d cat:%d/%d"
	  " rip:%d RTB:%d\ntot:%d/%d pb:%d/%d\n",
	  C[0], C[1], C[2], C[3], mal,
	  sca, cattvi, cattpa, rip, RTB,
	  mal + sca + cattvi + cattpa + rip + RTB, w, pb, c2);
  i = 0;
  while (ott (TH, i) == vNON)
    i++;
  s = ott (TH, i);
  j = 0;
  while (j <= i)
    fis2 (TH, j, s);
  rle (TH, w, nome_file, C);
  free (TH);
}
