
#include "RobboLito.h"
#include "RobboTotalBase.h"
#include "RobboTripleBase.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>


#define V FALSO

static uint64 bytesTRIPLE = 0, indTRIPLE = 0, indTRIPLEx = 0;
void
load_triple (char *fnin)
{
  int u, i, by, n, j, PR, ni, s;
  char FN[64], NOME[64];
  RobboTripleBase *triple;
  FILE *file;
  char TEMP[64];
  strcpy (NOME, fnin);
  strcpy (TEMP, fnin);
  if (TEMP[0] == 'K' || TEMP[0] == 'k')
    un_windows_triple (TEMP);
  s = strlen (TEMP);
  triple = PILA_ROBBO_TRIPLE + NUM_ROBBO_TRIPLE;
  sprintf (FN, "%s/%d/%s%s", TRIPLE_DIR, s + 2, TRIPLE_PREFISSO, NOME);
  file = fopen (FN, "r");
  if (file == NULL)
    {
      printf ("No file %s\n", FN);
      return;
    }
  if (V)
    printf ("RobboTriple %d %s ", NUM_ROBBO_TRIPLE, FN);
  for (i = 1; i <= 4; i++)
    TEMP[s + i] = 0;
  robbo_triple_utilita (triple, TEMP);
  for (i = 1; i <= 3; i++)
    {
      u = fgetc (file);
      triple->w[i] = u;
    }
  if (triple->w[2] == 0)
    {
      triple->w[3] = 0;
      fclose (file);
      file = 0;
      NUM_ROBBO_TRIPLE++;
      if (V)
	printf ("una resulta %d\n", triple->w[1]);
      return;
    }
  fgetc (file);
  for (i = 1; i <= 3; i++)
    triple->wi[triple->w[i]] = i;
  if (V)
    printf ("w: %d/%d/%d  ", triple->w[1], triple->w[2], triple->w[3]);
  by = 0;
  for (i = 0; i < 4; i++)
    by += (fgetc (file) << (8 * i));
  if (V)
    printf ("%d by  ", by);
  n = 0;
  for (i = 0; i < 4; i++)
    n += (fgetc (file) << (8 * i));
  if (V)
    printf ("%d arch  ", n);
  PR = 0;
  for (i = 0; i < 2; i++)
    PR += (fgetc (file) << (8 * i));
  if (V)
    printf ("PR %d  ", PR);
  for (i = 0; i < 2; i++)
    fgetc (file);
  ni = by / PR;
  triple->prop_ind = PR;
  NUM_ROBBO_TRIPLE++;
  u = ni;
  i = 0;
  while (u >>= 1)
    i++;
  triple->bs = i - 1;
  triple->indice = (2 << i) - 1;
  triple->ind = malloc ((triple->indice + 1) * sizeof (int));
  for (i = 0; i < ni; i++)
    {
      u = 0;
      for (j = 0; j < 4; j++)
	{
	  u += (fgetc (file) << (8 * j));
	}
      triple->ind[i] = u;
    }
  for (i = ni; i < triple->indice + 1; i++)
    triple->ind[i] = (n * 4);
  triple->by = by;
  bytesTRIPLE += by;
  indTRIPLE += triple->indice + 1;
  indTRIPLEx += ni;
  triple->data = malloc (PR * ni);
  triple->cnt = n;
  fread (triple->data, 1, PR * ni, file);
  if (V)
    {
      printf ("data: ");
      for (i = 0; i < 10; i++)
	printf ("%x ", triple->data[i]);
    }
  if (V)
    printf ("\n");
  fclose (file);
  file = 0;
}

void
triple_statistica ()
{
  printf
    ("%d RobboTripleBases (%dmb): %lld data %lld+%lld indici\n",
     NUM_ROBBO_TRIPLE,
     1 + (NUM_ROBBO_TRIPLE / 256) +
     (int) ((bytesTRIPLE + (indTRIPLE * 4)) >> 20),
     bytesTRIPLE, indTRIPLE, indTRIPLEx);
}

#define WINDOWS_TRIPLE_PREFISSO "triple."
static void
add_nome_triple (char *NOME)
{
  int n = strlen (TRIPLE_PREFISSO);
  if (memcmp (NOME, TRIPLE_PREFISSO, n) && memcmp (NOME, WINDOWS_TRIPLE_PREFISSO,n))
    return;
  load_triple (NOME + n);
}

void
robbo_triple_directory (char *A)
{
  DIR *DIR;
  struct dirent *DE;
  printf ("Reading directory %s\n", A);
  DIR = opendir (A);
  if (!DIR)
    {
      printf ("Directory %s not found\n", A);
      return;
    }
  while ((DE = readdir (DIR)))
    add_nome_triple (DE->d_name);
  closedir (DIR);
}
