
#include "RobboLito.h"
#include "RobboTotalBase.h"
#include "Robbo_gen_mossa.h"

static void
BITBORDO (tipo_posizione *POSIZIONE, int br, int nr, tipo_pezzo_quad * PQ)
{
  uint8 *quad = PQ->qu;
  int i;
  POSIZIONE->bianco_re_quadretto = br;
  POSIZIONE->nero_re_quadretto = nr;
  bitbordo_bianco_re = quadretto_fisso[br];
  bitbordo_nero_re = quadretto_fisso[nr];
  bitbordo_bianco_torre = bitbordo_bianca_donna = bitbordo_bianco_cavallo =
    bitbordo_bianco_chiaro = bitbordo_bianco_scuro = bitbordo_bianco_pedone =
    0;
  bitbordo_nero_torre = bitbordo_nera_donna = bitbordo_nero_cavallo =
    bitbordo_nero_chiaro = bitbordo_nero_scuro = bitbordo_nero_pedone = 0;
  PQ->pedone = FALSO;
  for (i = 0; i < 4; i++)
    {
      if (PQ->pezzo[i] == conto_alfiere_bianco
	  && quadretto_fisso[quad[i]] & SCURO)
	{
	  bitbordo_bianco_scuro |= quadretto_fisso[quad[i]];
	  continue;
	}
      if (PQ->pezzo[i] == conto_alfiere_nero
	  && quadretto_fisso[quad[i]] & SCURO)
	{
	  bitbordo_nero_scuro |= quadretto_fisso[quad[i]];
	  continue;
	}
      if (PQ->pezzo[i] == conto_pedone_nero || PQ->pezzo[i] == conto_pedone_bianco)
	PQ->pedone = VERO;
      POSIZIONE->bitbordo[PQ->pezzo[i]] |= quadretto_fisso[quad[i]];
    }
}

#define sotto_promozione(x) \
 { \
   annullare (POSIZIONE, mossa); \
   mossa = (mossa & 07777) + ( x << 12 ); \
   fare_bianco (POSIZIONE, mossa); \
   RobboTotal_valu (POSIZIONE, &valu); \
   if (DISCO_PERDITA (valu)) \
     { \
       MARCO (RTB->mbuf, posizione_numero, d); \
       annullare_bianco (POSIZIONE, mossa); \
       return; \
     } \
   if (DISCO_PATTA (valu) ) \
   { \
     fisso_patta (RTB, posizione_numero, d); \
     RIMA++; \
   } \
}

#define bitbordo_due(x,y) ( ( (uint64) 1) << (x) ) | ( ( (uint64) 1) << (y) )

static const uint64 ep_en_passant[8] =
  { bitbordo_due (B4, B4), bitbordo_due (A4, C4),
  bitbordo_due (B4, D4), bitbordo_due (C4, E4),
  bitbordo_due (D4, F4), bitbordo_due (E4, G4),
  bitbordo_due (F4, H4), bitbordo_due (G4, G4)
};

static void
rtb_iniz_fisso (RobboTotalBase * RTB, uint64 posizione_numero, uint64 d)
{
  RTB->sbuf[posizione_numero] = VALU_INCOG;
  if (d != -1)
    RTB->sbuf[d] = VALU_INCOG;
}

static void
fisso_patta (RobboTotalBase * RTB, uint64 posizione_numero, uint64 d)
{
  RTB->sbuf[posizione_numero] = VALU_PATTA;
  if (d != -1)
    RTB->sbuf[d] = VALU_PATTA;
}

static void
ROTTO (RobboTotalBase * RTB, uint64 posizione_numero, uint64 d)
{
  RTB->sbuf[posizione_numero] = VALU_ROTTO;
  ex_fisso (RTB->mbuf, posizione_numero);
  en_fisso (RTB->vbuf, posizione_numero);
  if (d == -1)
    return;
  RTB->sbuf[d] = VALU_ROTTO;
  ex_fisso (RTB->mbuf, d);
  en_fisso (RTB->vbuf, d);
}

#define MARCO(ptr, A, B) \
  { \
    en_fisso (ptr, A); \
    if (B != -1) \
      en_fisso (ptr, B); \
  }

static void
inizRIMA (RobboTotalBase * RTB, uint64 posizione_numero, uint64 d, int RIMA)
{
  if (RIMA > MASSIMO_RIMA)
    {
      printf ("MASSIMO RIMA\n");
      exit (1);
    }
  if (RIMA == 0)
    RIMA = PRIMERA_PERDITA;
  RTB->sbuf[posizione_numero] = RIMA;
  if (RIMA == PRIMERA_PERDITA)
    {
      en_fisso (RTB->pbuf, posizione_numero);
      if (d != -1)
	en_fisso (RTB->pbuf, d);
    }
  if (d != -1)
    RTB->sbuf[d] = RIMA;
}

static void
iniz_posizione
 (tipo_posizione *POSIZIONE, RobboTotalBase * RTB, tipo_pezzo_quad * PQ)
{
  tipo_lista_mossa LISTA[256], *lista;
  int mossa, i, valu, RIMA, rf;
  uint64 posizione_numero, d, en_passant;
  logico NON = VERO;
  uint64 A;
  int b;
  uint32 mossa2;
  int valu2;

  ott_indice (PQ, &posizione_numero, &d, &rf);
  if (ILLEGALE)
    {
      ROTTO (RTB, posizione_numero, d);
      return;
    }
  lista = cattura_bianca (POSIZIONE, LISTA, bitbordo_occupato_nero);
  RIMA = 0;
  rtb_iniz_fisso (RTB, posizione_numero, d);
  for (i = 0; i < lista - LISTA; i++)
    {
      mossa = LISTA[i].mossa;
      if (((mossa & 070000) >> 12) == 4)
	continue;
      fare_bianco (POSIZIONE, mossa);
      mobilita (POSIZIONE);
      if (ILLEGALE)
	{
	  annullare_bianco (POSIZIONE, mossa);
	  continue;
	}
      RobboTotal_valu (POSIZIONE, &valu);
      NON = FALSO;
      if (DISCO_PERDITA (valu))
	{
	  MARCO (RTB->mbuf, posizione_numero, d);
	  annullare_bianco (POSIZIONE, mossa);
	  return;
	}
      if (DISCO_PATTA (valu))
	{
	  fisso_patta (RTB, posizione_numero, d);
	  RIMA++;
	}
      if (((mossa & 070000) >> 12) == 7)
	{
	  sotto_promozione (6);
	  sotto_promozione (5);
	  sotto_promozione (4);
	}
      annullare_bianco (POSIZIONE, mossa);
    }
  RIMA += conto_bianco (POSIZIONE, &en_passant);
  if (en_passant == -1)
    {
      ROTTO (RTB, posizione_numero, d);
      return;
    }
  while (en_passant)
    {
      b = BSF (en_passant);
      bitLIBERO (b, en_passant);
      mossa = ((b - 16) << 6) | b;
      fare_bianco (POSIZIONE, mossa);
      A =
	ep_en_passant[COLONNA (DINAMICO->en_passant)] & bitbordo_nero_pedone;
      while (A)
	{
	  b = BSF (A);
	  bitLIBERO (b, A);
	  mossa2 = pietra_en_passant | (b << 6) | (DINAMICO->en_passant);
	  fare (POSIZIONE, mossa2);
	  RobboTotal_valu (POSIZIONE, &valu2);
	  annullare_bianco (POSIZIONE, mossa2);
	  if (DISCO_PERDITA (valu2))
	    {
	      RIMA--;
	      break;
	    }
	}
      annullare_bianco (POSIZIONE, mossa);
    }
  if (NON && !RIMA && !SCACCO)
    fisso_patta (RTB, posizione_numero, d);
  else
    inizRIMA (RTB, posizione_numero, d, RIMA);
  return;
}

static void
LOAD_re_fetta (RobboTotalBase * TotalBase, int br, int nr, int rf)
{
  int w, i, v, u;
  for (u = 0; u < 4; u++)
    if (TotalBase->p[u] == conto_pedone_bianco)
      break;
  if (u == 4)
    return;
  int a[4];
  for (i = 0; i < 4; i++)
    a[i] = TotalBase->p[i];
  logico PEDONE = FALSO;
  a[u] = conto_donna_bianca;
  for (i = 0; i < 4; i++)
    if (a[i] == conto_pedone_bianco || a[i] == conto_pedone_nero)
      PEDONE = VERO;
  if (PEDONE)
    {
      w = 2 * (COLONNA (br) >= CE) + 1;
      LANCpez (w, br);
      LANCpez (w, nr);
      rf = RE_pedone[64 * nr + br];
    }
  else
    {
      w = oLANC[nr][br];
      LANCnor (w, br);
      LANCnor (w, nr);
      rf = RE_normale[64 * nr + br];
    }
  v = RTB_PILA[a[0]][a[1]][a[2]][a[3]];
  re_fetta (PILA_ROBBO_TOTAL + (v % 65536), rf);
  a[u] = conto_torre_bianco;
  v = RTB_PILA[a[0]][a[1]][a[2]][a[3]];
  re_fetta (PILA_ROBBO_TOTAL + (v % 65536), rf);
  a[u] = conto_alfiere_bianco;
  v = RTB_PILA[a[0]][a[1]][a[2]][a[3]];
  re_fetta (PILA_ROBBO_TOTAL + (v % 65536), rf);
  a[u] = conto_cavallo_bianco;
  v = RTB_PILA[a[0]][a[1]][a[2]][a[3]];
  re_fetta (PILA_ROBBO_TOTAL + (v % 65536), rf);
}

static void
popolare (tipo_posizione *POSIZIONE, int *pezzo, RobboTotalBase * RTB1)
{
  int i, br, nr, quad1, quad2, quad3, quad4, QUAD1, QUAD2, QUAD3, QUAD4, TER1,
    TER2, TER3, TER4, PEDONE_PIETRA = FALSO;
  uint64 ci, d, pro;
  uint64 oro = orologio ();
  char NOME_FILE[1024];
  int rf, RF, re_fetta;

  for (br = A1; br <= H8; br++)
    POSIZIONE->qu[br] = 0;
  QUAD1 = QUAD2 = QUAD3 = QUAD4 = A1;
  TER1 = TER2 = TER3 = TER4 = H8;
  if (pezzo[0] == 0)
    QUAD1 = TER1 = -1;
  if (pezzo[1] == 0)
    QUAD2 = TER2 = -1;
  DINAMICO->mossa50 = DINAMICO->arrocco = DINAMICO->en_passant = 0;
  if (pezzo[2] == 0)
    QUAD3 = TER3 = -1;
  if (pezzo[3] == 0)
    QUAD4 = TER4 = -1;
  if (pezzo[0] == conto_pedone_bianco || pezzo[0] == conto_pedone_nero)
    {
      QUAD1 = A2;
      TER1 = H7;
      PEDONE_PIETRA = VERO;
    }
  if (pezzo[1] == conto_pedone_bianco || pezzo[1] == conto_pedone_nero)
    {
      QUAD2 = A2;
      TER2 = H7;
      PEDONE_PIETRA = VERO;
    }
  if (pezzo[2] == conto_pedone_bianco || pezzo[2] == conto_pedone_nero)
    {
      QUAD3 = A2;
      TER3 = H7;
      PEDONE_PIETRA = VERO;
    }
  if (pezzo[3] == conto_pedone_bianco || pezzo[3] == conto_pedone_nero)
    {
      QUAD4 = A2;
      TER4 = H7;
      PEDONE_PIETRA = VERO;
    }
  if (!PEDONE_PIETRA)
    pro = 462;
  else
    pro = 1806;
  RF = PEDONE_PIETRA ? 1806 : 462;
  for (i = 0; i < 4; i++)
    pro *= RTB1->m[i];
  for (i = 0; i < 8; i++)
    RTB1->supp_indice[i] = 0xffffffff;
  RTB1->pro = pro;
  RTB1->pezzo_molt8 = (RTB1->pezzo_molt + 7) >> 3;
  RTB1->Fsupp = NULL;

  if (!RTB1->MEMORIA)
    {
      sprintf (NOME_FILE, "%sRIMA.%s", RTB1->DIR_NOME, RTB1->string);
      RTB1->Frima = fopen (NOME_FILE, "w+");
      sprintf (NOME_FILE, "%sMARC.%s", RTB1->DIR_NOME, RTB1->string);
      RTB1->Fmar = fopen (NOME_FILE, "w+");
      sprintf (NOME_FILE, "%sPERD.%s", RTB1->DIR_NOME, RTB1->string);
      RTB1->Fper = fopen (NOME_FILE, "w+");
      sprintf (NOME_FILE, "%sVITT.%s", RTB1->DIR_NOME, RTB1->string);
      RTB1->Fvit = fopen (NOME_FILE, "w+");
      RTB1->MAR = RTB1->VIT = RTB1->PER = NULL;
      RTB1->sbuf = malloc (RTB1->pezzo_molt);
      RTB1->vbuf = malloc (RTB1->pezzo_molt8);
      RTB1->mbuf = malloc (RTB1->pezzo_molt8);
      RTB1->pbuf = malloc (RTB1->pezzo_molt8);
      RTB1->rima_pro = malloc (1806 * sizeof (int));
      RTB1->vit_pro = malloc (1806 * sizeof (int));
      RTB1->per_pro = malloc (1806 * sizeof (int));
      RTB1->mar_pro = malloc (1806 * sizeof (int));
    }
  else
    {
      RTB1->data = malloc (RTB1->pro);
      int PR = RF * RTB1->pezzo_molt8;
      posix_memalign ((void *) &RTB1->MAR, 64, PR);
      posix_memalign ((void *) &RTB1->VIT, 64, PR);
      posix_memalign ((void *) &RTB1->PER, 64, PR);
      for (i = 0; i < PR; i++)
	RTB1->MAR[i] = RTB1->VIT[i] = RTB1->PER[i] = 0;
    }

  for (rf = 0; rf < RF; rf++)
    {
      int re = PEDONE_PIETRA ? inverso_pedone_re[rf] : inverso_normale_re[rf];
      br = re >> 6;
      nr = re & 63;
      if (PEDONE_PIETRA)
	LOAD_re_fetta (RTB1, br, nr, rf);
      if (RTB1->MEMORIA)
	{
	  RTB1->sbuf = RTB1->data + (rf * RTB1->pezzo_molt);
	  RTB1->mbuf = RTB1->MAR + (rf * RTB1->pezzo_molt8);
	  RTB1->vbuf = RTB1->VIT + (rf * RTB1->pezzo_molt8);
	  RTB1->pbuf = RTB1->PER + (rf * RTB1->pezzo_molt8);
	}
      else
	for (i = 0; i < RTB1->pezzo_molt8; i++)
	  RTB1->mbuf[i] = RTB1->vbuf[i] = RTB1->pbuf[i] = 0;
      for (i = 0; i < RTB1->pezzo_molt; i++)
	RTB1->sbuf[i] = VALU_INCOG;
      for (quad1 = QUAD1; quad1 <= TER1; quad1++)
	for (quad2 = QUAD2; quad2 <= TER2; quad2++)
	  for (quad3 = QUAD3; quad3 <= TER3; quad3++)
	    for (quad4 = QUAD4; quad4 <= TER4; quad4++)
	      {
		tipo_pezzo_quad PQ[1];
		if (pezzo[0] == pezzo[1] && quad1 <= quad2 && pezzo[0])
		  continue;
		if (pezzo[1] == pezzo[2] && quad2 <= quad3 && pezzo[1])
		  continue;
		if (pezzo[2] == pezzo[3] && quad3 <= quad4 && pezzo[2])
		  continue;
		PQ->qu[0] = quad1;
		PQ->qu[1] = quad2;
		PQ->qu[2] = quad3;
		PQ->qu[3] = quad4;
		PQ->pezzo[0] = pezzo[0];
		PQ->pezzo[1] = pezzo[1];
		PQ->pezzo[2] = pezzo[2];
		PQ->pezzo[3] = pezzo[3];
		PQ->br = br;
		PQ->nr = nr;
		PQ->bianco_en_mossa = VERO;
		if (br == quad1 || br == quad2 || nr == quad1 || nr == quad2 ||
		    br == quad3 || nr == quad3 || br == quad4 || nr == quad4
		    || (pezzo[1] && quad1 == quad2)
		    || (pezzo[2] && quad1 == quad3)
		    || (pezzo[2] && quad2 == quad3)
		    || (pezzo[3] && quad1 == quad4)
		    || (pezzo[3] && quad2 == quad4)
		    || (pezzo[3] && quad3 == quad4)
		    || ((attaco_re[br] | quadretto_fisso[br]) &
		        quadretto_fisso[nr]))
		  {
		    BITBORDO (POSIZIONE, br, nr, PQ);
		    POSIZIONE->bianco_en_mossa = VERO;
		    PQ->bianco_en_mossa = VERO;
		    ott_indice (PQ, &ci, &d, &re_fetta);
		    ROTTO (RTB1, ci, d);
		    goto ANCORA;
		  }
		if (pezzo[0])
		  POSIZIONE->qu[quad1] = pezzo[0];
		if (pezzo[1])
		  POSIZIONE->qu[quad2] = pezzo[1];
		if (pezzo[2])
		  POSIZIONE->qu[quad3] = pezzo[2];
		if (pezzo[3])
		  POSIZIONE->qu[quad4] = pezzo[3];
		if (pezzo[0] == conto_alfiere_bianco
		    && quadretto_fisso[quad1] & SCURO)
		  POSIZIONE->qu[quad1] = conto_scuro_bianco;
		if (pezzo[1] == conto_alfiere_bianco
		    && quadretto_fisso[quad2] & SCURO)
		  POSIZIONE->qu[quad2] = conto_scuro_bianco;
		if (pezzo[2] == conto_alfiere_bianco
		    && quadretto_fisso[quad3] & SCURO)
		  POSIZIONE->qu[quad3] = conto_scuro_bianco;
		if (pezzo[3] == conto_alfiere_bianco
		    && quadretto_fisso[quad4] & SCURO)
		  POSIZIONE->qu[quad4] = conto_scuro_bianco;
		if (pezzo[0] == conto_alfiere_nero
		    && quadretto_fisso[quad1] & SCURO)
		  POSIZIONE->qu[quad1] = conto_scuro_nero;
		if (pezzo[1] == conto_alfiere_nero
		    && quadretto_fisso[quad2] & SCURO)
		  POSIZIONE->qu[quad2] = conto_scuro_nero;
		if (pezzo[2] == conto_alfiere_nero
		    && quadretto_fisso[quad3] & SCURO)
		  POSIZIONE->qu[quad3] = conto_scuro_nero;
		if (pezzo[3] == conto_alfiere_nero
		    && quadretto_fisso[quad4] & SCURO)
		  POSIZIONE->qu[quad4] = conto_scuro_nero;
		POSIZIONE->qu[br] = conto_re_bianco;
		POSIZIONE->qu[nr] = conto_re_nero;
		POSIZIONE->bianco_en_mossa = VERO;
		BITBORDO (POSIZIONE, br, nr, PQ);
		PQ->bianco_en_mossa = VERO;
		bitbordo_occupato_bianco =
		  bitbordo_bianco_re | bitbordo_bianca_donna |
		  bitbordo_bianco_torre | bitbordo_bianco_alfiere |
		  bitbordo_bianco_cavallo | bitbordo_bianco_pedone;
		bitbordo_occupato_nero =
		  bitbordo_nero_re | bitbordo_nera_donna | bitbordo_nero_torre
		  | bitbordo_nero_alfiere | bitbordo_nero_cavallo |
		  bitbordo_nero_pedone;
		POSIZIONE->occupato_nero_bianco =
		  bitbordo_occupato_bianco | bitbordo_occupato_nero;
		POSIZIONE->occupato_sinistro90 =
		  quadretto_fisso[sinistro90[br]] |
		  quadretto_fisso[sinistro90[nr]];
		POSIZIONE->occupato_sinistro45 =
		  quadretto_fisso[sinistro45[br]] |
		  quadretto_fisso[sinistro45[nr]];
		POSIZIONE->occupato_retto45 =
		  quadretto_fisso[retto45[br]] | quadretto_fisso[retto45[nr]];
		if (pezzo[0])
		  {
		    POSIZIONE->occupato_sinistro90 |=
		      quadretto_fisso[sinistro90[quad1]];
		    POSIZIONE->occupato_sinistro45 |=
		      quadretto_fisso[sinistro45[quad1]];
		    POSIZIONE->occupato_retto45 |=
		      quadretto_fisso[retto45[quad1]];
		  }
		if (pezzo[1])
		  {
		    POSIZIONE->occupato_sinistro90 |=
		      quadretto_fisso[sinistro90[quad2]];
		    POSIZIONE->occupato_sinistro45 |=
		      quadretto_fisso[sinistro45[quad2]];
		    POSIZIONE->occupato_retto45 |=
		      quadretto_fisso[retto45[quad2]];
		  }
		if (pezzo[2])
		  {
		    POSIZIONE->occupato_sinistro90 |=
		      quadretto_fisso[sinistro90[quad3]];
		    POSIZIONE->occupato_sinistro45 |=
		      quadretto_fisso[sinistro45[quad3]];
		    POSIZIONE->occupato_retto45 |=
		      quadretto_fisso[retto45[quad3]];
		  }
		if (pezzo[3])
		  {
		    POSIZIONE->occupato_sinistro90 |=
		      quadretto_fisso[sinistro90[quad4]];
		    POSIZIONE->occupato_sinistro45 |=
		      quadretto_fisso[sinistro45[quad4]];
		    POSIZIONE->occupato_retto45 |=
		      quadretto_fisso[retto45[quad4]];
		  }
		mobilita (POSIZIONE);
		iniz_posizione (POSIZIONE, RTB1, PQ);
	      ANCORA:POSIZIONE->qu[br] = POSIZIONE->qu[nr] = 0;
		if (pezzo[0])
		  POSIZIONE->qu[quad1] = 0;
		if (pezzo[1])
		  POSIZIONE->qu[quad2] = 0;
		if (pezzo[2])
		  POSIZIONE->qu[quad3] = 0;
		if (pezzo[3])
		  POSIZIONE->qu[quad4] = 0;
	      }
      if (!RTB1->MEMORIA)
	{
	  int df;
	  fseek (RTB1->Frima, rf * RTB1->pezzo_molt, 0);
	  df = DISCO_FWRITE1 (RTB1->sbuf, 1, RTB1->pezzo_molt, RTB1->Frima);
	  RTB1->rima_pro[rf] = df;
	  fseek (RTB1->Fvit, rf * RTB1->pezzo_molt8, 0);
	  df = DISCO_FWRITE2 (RTB1->vbuf, 1, RTB1->pezzo_molt8, RTB1->Fvit);
	  RTB1->vit_pro[rf] = df;
	  fseek (RTB1->Fper, rf * RTB1->pezzo_molt8, 0);
	  df = DISCO_FWRITE2 (RTB1->pbuf, 1, RTB1->pezzo_molt8, RTB1->Fper);
	  RTB1->per_pro[rf] = df;
	  fseek (RTB1->Fmar, rf * RTB1->pezzo_molt8, 0);
	  df = DISCO_FWRITE2 (RTB1->mbuf, 1, RTB1->pezzo_molt8, RTB1->Fmar);
	  RTB1->mar_pro[rf] = df;
	}
    }
  if (!RTB1->MEMORIA)
    {
      free (RTB1->sbuf);
      fflush (RTB1->Frima);
      fflush (RTB1->Fvit);
      fflush (RTB1->Fper);
      fflush (RTB1->Fmar);
    }
  printf ("INIZ %s [%.2fs]\n",
	  RTB1->string, ((double) (orologio () - oro)) / 1000000.0);
}

static logico MEMORIA = FALSO;
static void
RobboBUILD (RobboTotalBase * RTB1, RobboTotalBase * RTB2, int *pezzos)
{
  int i, num;
  tipo_posizione POSIZIONE[1];
  POSIZIONE->din_iniz = malloc(abisso_massimo * sizeof(tipo_dinamico));
  POSIZIONE->DIN = POSIZIONE->din_iniz;
  popolare (POSIZIONE, pezzos, RTB1);
  if (!MEMORIA)
    iniz_una (RTB1);
  for (i = 0; i < 4; i++)
    if (pezzos[i])
      pezzos[i] ^= 8;
  popolare (POSIZIONE, pezzos, RTB2);
  RTB1->simm = RTB2->simm = FALSO;
  for (num = 0;; num++)
    {
      if (!fareRIMA (RTB2, num, RTB1) && 0)
	break;
      if (!fareMARCO (RTB1, num, RTB2))
	break;
    }
  for (num = 0;; num++)
    {
      if (!fareRIMA (RTB1, num, RTB2) && 0)
	break;
      if (!fareMARCO (RTB2, num, RTB1))
	break;
    }
  free (POSIZIONE->din_iniz);
}

static void
RobboBUILD_stesso (RobboTotalBase * RTB1, int *pezzos)
{
  int num;
  tipo_posizione POSIZIONE[1];
  POSIZIONE->din_iniz = malloc(abisso_massimo * sizeof(tipo_dinamico));
  POSIZIONE->DIN = POSIZIONE->din_iniz;
  popolare (POSIZIONE, pezzos, RTB1);
  RTB1->simm = VERO;
  if (!MEMORIA)
    iniz_una (RTB1);
  for (num = 0;; num++)
    {
      if (!fareRIMA (RTB1, num, RTB1) && 0)
	break;
      if (!fareMARCO (RTB1, num, RTB1))
	break;
    }
  free (POSIZIONE->din_iniz);
}

static logico
eVIT (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    return emarco (TotalBase->VIT,
		   fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
  return emarco (TotalBase->vbuf, posizione_numero);
}

#define ZOBRIST(rf, posizione_numero) \
   ( ( (rf) * 123456789 + (posizione_numero) * 98764321 + \
     ( (rf) * (posizione_numero) ) ) & CELARE)

uint64 *RICERCA, CELARE;

static void
nuovo_archivio (uint64 ip, uint64 br)
{
  int ok = ZOBRIST ((ip >> 32), (ip & 0xffffffff)), k = ok;
  while (RICERCA[k])
    {
      k++;
      if (k == (CELARE + 1))
	k = 0;
    }
  RICERCA[k] = ip | (br << 48);
}

static void
iniz_supp (FILE * F, uint64 pro)
{
  uint64 i;
  uint64 br = 0, ip;
  pro = 3 * (pro + 10) / 2;
  pro = (1 << (1 + BSR (pro)));
  CELARE = pro - 1;
  RICERCA = malloc (pro * 8);
  for (i = 0; i < pro; i++)
    RICERCA[i] = 0;
  for (i = 0; ; i++)
    {
      if (!fread (&ip, 8, 1, F))
	break;
      if (BSR (ip) > 56)
	{
	  br = (ip >> 32) & 65535;
	  continue;
	}
      nuovo_archivio (ip, br);
    }
}

static int
ric (int rf, int posizione_numero)
{
  int k = ZOBRIST (rf, posizione_numero);
  uint64 n = posizione_numero + (((uint64) rf) << 32);
  while (1)
    {
      uint64 v = RICERCA[k];
      if ((v & 0xffffffffffff) == n)
	return (v >> 48);
      if (v == 0)
	{
	  printf ("MALATO (supp)\n");
	  exit (1);
	}
      k = k + 1;
      if (k == (CELARE + 1))
	k = 0;
    }
}

#define BLOCCO_PRO 65536
#define uBWT 5

static void
supp_42_iniz (RobboTotalBase * TotalBase, uint64 * supp_conto)
{
  uint64 n = ftell (TotalBase->Fsupp) >> 3;
  uint64 ip;
  FILE *file[42];
  int i, j, L = TotalBase->PEDONE ? 43 : 11;
  char NOME_FILE[1024];
  fseek (TotalBase->Fsupp, 0, 0);
  for (j = 0; j < 42; j++)
    {
      sprintf (NOME_FILE, "%sSUPP%d.%s", TotalBase->DIR_NOME, j, TotalBase->string);
      file[j] = fopen (NOME_FILE, "w");
      supp_conto[j] = 0;
    }
  for (i = 0; i < n; i++)
    {
      fread (&ip, 8, 1, TotalBase->Fsupp);
      if (BSR (ip) > 56)
	{
	  for (j = 0; j < 42; j++)
	    fwrite (&ip, 8, 1, file[j]);
	  continue;
	}
      fwrite (&ip, 8, 1, file[(ip >> 32) / L]);
      supp_conto[(ip >> 32) / L]++;
    }
  for (j = 0; j < 42; j++)
    fclose (file[j]);
  fclose (TotalBase->Fsupp);
  sprintf (NOME_FILE, "%sSUPP.%s", TotalBase->DIR_NOME, TotalBase->string);
  remove (NOME_FILE);
}

static void
fine_rtb_memoria (RobboTotalBase * TotalBase)
{
  uint64 u = 0, posizione_numero;
  int rf, RF = TotalBase->PEDONE ? 1806 : 462;
  FILE *F;
  uint64 LIMITE = RF * TotalBase->pezzo_molt;
  uint32 v = 0;
  char NOME_FILE[1024];
  uint32 n = BLOCCO_PRO | (uBWT << 28);
  int L = TotalBase->PEDONE ? 43 : 11;
  uint64 supp_conto[42];
  logico SUPP = (TotalBase->Fsupp != NULL);
  if (SUPP)
    supp_42_iniz (TotalBase, supp_conto);
  for (rf = 0; rf < RF; rf++)
  {
    if (SUPP && (rf % L) == 0)
      {
	sprintf (NOME_FILE, "%sSUPP%d.%s", TotalBase->DIR_NOME, rf / L, TotalBase->string);
	F = fopen (NOME_FILE, "r");
	if (rf != 0)
	  free (RICERCA);
	iniz_supp (F, supp_conto[rf / L]);
	fclose (F);
	remove (NOME_FILE);
      }
    for (posizione_numero = 0; posizione_numero < TotalBase->pezzo_molt;
	 posizione_numero++, u++)
      {
	if (TotalBase->data[u] == VALU_ROTTO)
	  TotalBase->data[u] = dROTT;
	else if (eVIT (TotalBase, rf, posizione_numero))
	  TotalBase->data[u] = dVITT;
	else if (TotalBase->data[u] <= MASSIMO_RIMA)
	  TotalBase->data[u] = dPATT;
	else if (TotalBase->data[u] == PERD_FINE)
	  TotalBase->data[u] = ric (rf, posizione_numero) + dPERD0;
	else
	  TotalBase->data[u] -= PRIMERA_PERDITA - dPERD0;
      }
  }
  if (SUPP)
    free (RICERCA);
  TotalBase->indici = malloc (sizeof (uint32) * (2 + LIMITE / BLOCCO_PRO));
  for (u = 0; u < LIMITE; u += BLOCCO_PRO)
    TotalBase->indici[++v] =
      compressa (TotalBase->data + u, MINIMO (BLOCCO_PRO, LIMITE - u), uBWT);
  TotalBase->indici[0] = 0;
  for (u = 0; u < v; u++)
    TotalBase->indici[u + 1] += TotalBase->indici[u];
  v++;
  sprintf (NOME_FILE, "%s%s%s", TotalBase->DIR_NOME, COMPRESSA_PREFISSO,
	   TotalBase->string);
  F = fopen (NOME_FILE, "w");
  fputc (0xca, F);
  fputc (0x7f, F);
  fputc (0x0b, F);
  fputc (0xaa, F);
  fputc (n & 255, F);
  fputc ((n >> 8) & 255, F);
  fputc ((n >> 16) & 255, F);
  fputc ((n >> 24) & 255, F);
  fputc (0, F);
  fputc (0, F);
  fputc (0, F);
  fputc (0, F);
  fputc (v & 255, F);
  fputc ((v >> 8) & 255, F);
  fputc ((v >> 16) & 255, F);
  fputc ((v >> 24) & 255, F);
  fwrite (TotalBase->indici, sizeof (uint32), v, F);
  fclose (F);
  v = 0;
  sprintf (NOME_FILE, "%s%s%s", TotalBase->DIR_NOME, COMPRESSA_PREFISSO + 1,
	   TotalBase->string);
  F = fopen (NOME_FILE, "w");
  for (u = 0; u < LIMITE; u += BLOCCO_PRO, v++)
    fwrite (TotalBase->data + u, 1,
	    TotalBase->indici[v + 1] - TotalBase->indici[v], F);
  free (TotalBase->data);
  free (TotalBase->VIT);
  free (TotalBase->PER);
  free (TotalBase->MAR);
  fclose (F);
  free (TotalBase->indici);
}

#define fff(RTB, x) ric ( (x) / RTB->pezzo_molt, (x) % RTB->pezzo_molt )
static void
fine_disco (RobboTotalBase * TotalBase)
{
  char NOME_FILE[1024];
  FILE *F;
  uint64 w, v = 0, i, t, u;
  uint64 LIMITE = TotalBase->pezzo_molt * (TotalBase->PEDONE ? 1806 : 462);
  uint32 n = BLOCCO_PRO | (uBWT << 28);
  fclose (TotalBase->Fper);
  fclose (TotalBase->Fmar);
  free (TotalBase->mbuf);
  free (TotalBase->pbuf);
  free (TotalBase->vbuf);
  sprintf (NOME_FILE, "%sPERD.%s", TotalBase->DIR_NOME, TotalBase->string);
  remove (NOME_FILE);
  sprintf (NOME_FILE, "%sMARC.%s", TotalBase->DIR_NOME, TotalBase->string);
  remove (NOME_FILE);
  TotalBase->sbuf = malloc (TotalBase->pezzo_molt + 65536);
  TotalBase->vbuf = malloc (TotalBase->pezzo_molt8 + 8192);
  for (i = 0; i < TotalBase->pezzo_molt8 + 8192; i++)
    TotalBase->vbuf[i] = 0;
  fseek (TotalBase->Frima, 0, 0);
  fseek (TotalBase->Fvit, 0, 0);
  TotalBase->indici = malloc (sizeof (uint32) * (2 + LIMITE / BLOCCO_PRO));
  sprintf (NOME_FILE, "%s%s%s", TotalBase->DIR_NOME, COMPRESSA_PREFISSO + 1,
	   TotalBase->string);
  F = fopen (NOME_FILE, "w");
  logico SUPP = (TotalBase->Fsupp != NULL);
  uint64 supp_conto[42];
  if (SUPP)
    supp_42_iniz (TotalBase, supp_conto);
  int L = TotalBase->PEDONE ? 43 : 11;
  int ss = 0, rf = 0;
  FILE *F2;
  for (u = 0; u < LIMITE; u += TotalBase->pezzo_molt, rf++)
    {
      if (SUPP && (rf % L) == 0)
      {
	sprintf (NOME_FILE, "%sSUPP%d.%s", TotalBase->DIR_NOME, rf / L, TotalBase->string);
	F2 = fopen (NOME_FILE, "r");
	if (rf != 0)
	  free (RICERCA);
	iniz_supp (F2, supp_conto[rf / L]);
	fclose (F2);
	remove (NOME_FILE);
      }
      fseek (TotalBase->Frima, u, 0);
      DISCO_FREAD1
	(ss + TotalBase->sbuf, 1, TotalBase->pezzo_molt, TotalBase->Frima,
	 TotalBase->rima_pro[u / TotalBase->pezzo_molt] );
      fseek (TotalBase->Fvit, u / 8, 0);
      DISCO_FREAD2
	(ss / 8 + TotalBase->vbuf, 1, TotalBase->pezzo_molt8, TotalBase->Fvit,
	 TotalBase->vit_pro[u / TotalBase->pezzo_molt]);
      w = v;
      for (i = 0; i < TotalBase->pezzo_molt; i++)
	{
	  if (TotalBase->sbuf[ss + i] == VALU_ROTTO)
	    TotalBase->sbuf[ss + i] = dROTT;
	  else if (eVIT (TotalBase, 0, ss + i))
	    TotalBase->sbuf[ss + i] = dVITT;
	  else if (TotalBase->sbuf[ss + i] <= MASSIMO_RIMA)
	    TotalBase->sbuf[ss + i] = dPATT;
	  else if (TotalBase->sbuf[ss + i] == PERD_FINE)
	    TotalBase->sbuf[ss + i] = fff (TotalBase, u + i) + dPERD0;
	  else
	    TotalBase->sbuf[ss + i] -= PRIMERA_PERDITA - dPERD0;
	}
      for (t = 0; t + BLOCCO_PRO <= ss + TotalBase->pezzo_molt; t += BLOCCO_PRO)
	TotalBase->indici[++v] =
	  compressa (TotalBase->sbuf + t, BLOCCO_PRO, uBWT);
      ss = (ss + TotalBase->pezzo_molt) - t;
      for (t = 0; w < v; t += BLOCCO_PRO, w++)
	fwrite (TotalBase->sbuf + t, 1, TotalBase->indici[w + 1], F);
      for (i = 0; i < ss; i++)
	TotalBase->sbuf[i] = TotalBase->sbuf[t + i];
      for (i = 0; i < ss / 8; i++)
	TotalBase->vbuf[i] = TotalBase->vbuf[t / 8 + i];
    }
  if (ss)
    {
      TotalBase->indici[++v] =
	compressa (TotalBase->sbuf + t, ss, uBWT);
      fwrite (TotalBase->sbuf + t, 1, TotalBase->indici[v], F);
    }

  fclose (TotalBase->Frima);
  fclose (TotalBase->Fvit);
  fclose (F);
  if (SUPP)
    free (RICERCA);
  free (TotalBase->sbuf);
  free (TotalBase->vbuf);
  sprintf (NOME_FILE, "%sRIMA.%s", TotalBase->DIR_NOME, TotalBase->string);
  remove (NOME_FILE);
  sprintf (NOME_FILE, "%sVITT.%s", TotalBase->DIR_NOME, TotalBase->string);
  remove (NOME_FILE);
  TotalBase->indici[0] = 0;
  for (u = 0; u < v; u++)
    TotalBase->indici[u + 1] += TotalBase->indici[u];
  v++;
  sprintf (NOME_FILE, "%s%s%s", TotalBase->DIR_NOME, COMPRESSA_PREFISSO,
	   TotalBase->string);
  F = fopen (NOME_FILE, "w");
  fputc (0xca, F);
  fputc (0x7f, F);
  fputc (0x0b, F);
  fputc (0xaa, F);
  fputc (n & 255, F);
  fputc ((n >> 8) & 255, F);
  fputc ((n >> 16) & 255, F);
  fputc ((n >> 24) & 255, F);
  fputc (0, F);
  fputc (0, F);
  fputc (0, F);
  fputc (0, F);
  fputc (v & 255, F);
  fputc ((v >> 8) & 255, F);
  fputc ((v >> 16) & 255, F);
  fputc ((v >> 24) & 255, F);
  fwrite (TotalBase->indici, sizeof (uint32), v, F);
  free (TotalBase->indici);
  fclose (F);
  free (TotalBase->rima_pro);
  free (TotalBase->vit_pro);
  free (TotalBase->per_pro);
  free (TotalBase->mar_pro);
}

static void
Robbo_fare (RobboTotalBase * RTB1, RobboTotalBase * RTB2, int *pezzo)
{
  RTB1->MEMORIA = RTB2->MEMORIA = MEMORIA;
  if (RTB1 == RTB2)
    RobboBUILD_stesso (RTB1, pezzo);
  else
    RobboBUILD (RTB1, RTB2, pezzo);
  if (!MEMORIA)
    fine_una ();
  else
    {
      fine_rtb_memoria (RTB1);
      if (RTB1 != RTB2)
	fine_rtb_memoria (RTB2);
      return;
    }
  fine_disco (RTB1);
  if (RTB1 != RTB2)
    fine_disco (RTB2);
}

void
NOME_INVERSO (char *I, char *O)
{
  int i;
  logico x;
  for (i = 0; i < 4; i++)
    O[i] = (I[i] == '0' || !I[i]) ? I[i] : I[i] ^ 32;
  nome_canonico (O, &x);
}

void
RTBfare (char *nome, logico simm)
{
  int n, i, rt1, rt2, PEZZO[4];
  char inverso_nome[64];
  uint64 oro = orologio ();
  logico x;
  n = nome_canonico (nome, &x);
  RobboTotal_sott (nome);
  RobboTotal_add (PILA_ROBBO_TOTAL + NUM_ROBBO_TOTAL, nome);
  NOME_INVERSO (nome, inverso_nome);
  inverso_nome[n] = 0;
  if (!simm)
    {
      RobboTotal_sott (inverso_nome);
      RobboTotal_add (PILA_ROBBO_TOTAL + NUM_ROBBO_TOTAL, inverso_nome);
    }
  rt2 = NUM_ROBBO_TOTAL - 1;
  if (simm)
    rt1 = NUM_ROBBO_TOTAL - 1;
  else
    rt1 = NUM_ROBBO_TOTAL - 2;
  for (i = 0; i < 4; i++)
    switch (nome[i])
      {
      case 'Q':
	PEZZO[i] = conto_donna_bianca;
	break;
      case 'q':
	PEZZO[i] = conto_donna_nera;
	break;
      case 'R':
	PEZZO[i] = conto_torre_bianco;
	break;
      case 'r':
	PEZZO[i] = conto_torre_nero;
	break;
      case 'B':
	PEZZO[i] = conto_alfiere_bianco;
	break;
      case 'b':
	PEZZO[i] = conto_alfiere_nero;
	break;
      case 'N':
	PEZZO[i] = conto_cavallo_bianco;
	break;
      case 'n':
	PEZZO[i] = conto_cavallo_nero;
	break;
      case 'P':
	PEZZO[i] = conto_pedone_bianco;
	break;
      case 'p':
	PEZZO[i] = conto_pedone_nero;
	break;
      default:
	PEZZO[i] = 0;
      }
  Robbo_fare (PILA_ROBBO_TOTAL + rt1, PILA_ROBBO_TOTAL + rt2, PEZZO);
  RobboTotal_sott (nome);
  if (!simm)
    RobboTotal_sott (inverso_nome);
  RobboTotal_registro (nome);
  if (!simm)
    RobboTotal_registro (inverso_nome);
  printf ("Fine %s: %.2fs\n", nome,
	  ((double) (orologio () - oro)) / 1000000.0);
  fflush (stdout);
}

void
robbo_iniz ()
{
  int pez1, pez2, pez3, pez4;
  int i;
  iniz_robbo_utilita (VERO);
  NUM_ROBBO_TOTAL = 0;
  for (pez1 = 0; pez1 < 16; pez1++)
    for (pez2 = 0; pez2 < 16; pez2++)
      for (pez3 = 0; pez3 < 16; pez3++)
	for (pez4 = 0; pez4 < 16; pez4++)
	  RTB_PILA[pez1][pez2][pez3][pez4] = -1;
  PILA_ROBBO_TOTAL = malloc (MASSIMO_PILA * sizeof (RobboTotalBase));
  for (i = 0; i < MASSIMO_PILA; i++)
    (PILA_ROBBO_TOTAL + i)->Fdata = NULL;
  iniz_total_cache (64);
}

#include <strings.h>
#define MASSIMO_NUMERO 4

static void
simmetria (char *C, char *SIM)
{
  int i;
  for (i = 0; C[i]; i++)
    SIM[i] = C[i] ^ 32;
  SIM[i] = 0;
}

static void
robbo_total_iniz (char *AA, logico B)
{
  int i, j, n;
  logico simm = FALSO;
  char A[16], C[16], SIM[16], PEZb[4] = "QRBN", PEZn[4] = "qrbn";
  strcpy (A, AA);
  if (A[0] == 'K' || A[0] == 'k')
    un_windows (A);
  n = nome_canonico (A, &simm);
  strcpy (C, A);
  for (i = 0; i < n; i++)
    {
      if (C[i] == 'P')
	{
	  for (j = 0; j < 4; j++)
	    {
	      C[i] = PEZb[j];
	      if (RobboTotal_scop (C) == -1)
		{
		  if (B)
		    {
		      printf ("Recursing %s\n", C);
		      robbo_total_iniz (C, B);
		    }
		  else
		    {
		      printf ("Needed dependency %s unavailable\n", C);
		      return;
		    }
		}
	      simmetria (C, SIM);
	      if (RobboTotal_scop (SIM) == -1)
		{
		  if (B)
		    {
		      printf ("Recursing %s\n", SIM);
		      robbo_total_iniz (SIM, B);
		    }
		  else
		    {
		      printf ("Needed dependency %s unavailable\n", SIM);
		      return;
		    }
		}
	    }
	  C[i] = 'P';
	}
      if (C[i] == 'p')
	{
	  for (j = 0; j < 4; j++)
	    {
	      C[i] = PEZn[j];
	      if (RobboTotal_scop (C) == -1)
		{
		  if (B)
		    {
		      printf ("Recursing %s\n", C);
		      robbo_total_iniz (C, B);
		    }
		  else
		    {
		      printf ("Needed dependency %s unavailable\n", C);
		      return;
		    }
		}
	      simmetria (C, SIM);
	      if (RobboTotal_scop (SIM) == -1)
		{
		  if (B)
		    {
		      printf ("Recursing %s\n", SIM);
		      robbo_total_iniz (SIM, B);
		    }
		  else
		    {
		      printf ("Needed dependency %s unavailable\n", SIM);
		      return;
		    }
		}
	    }
	  C[i] = 'p';
	}
    }
  for (i = 0; i < n; i++)
    {
      C[i] = A[n - 1];
      C[n - 1] = 0;
      if (RobboTotal_scop (C) == -1)
	{
	  if (B)
	    {
	      printf ("Recursing %s\n", C);
	      robbo_total_iniz (C, B);
	    }
	  else
	    {
	      printf ("Needed dependency %s unavailable\n", C);
	      return;
	    }
	}
      simmetria (C, SIM);
      if (RobboTotal_scop (SIM) == -1)
	{
	  if (B)
	    {
	      printf ("Recursing %s\n", SIM);
	      robbo_total_iniz (SIM, B);
	    }
	  else
	    {
	      printf ("Needed dependency %s unavailable\n", SIM);
	      return;
	    }
	}
      C[i] = A[i];
    }
  RTBfare (A, simm);
}

void
stats (char *A)
{
  char C[16];
  logico B = FALSO;
  strcpy (C, A);
  if (C[0] == 'K' || C[0] == 'k')
    un_windows (C);
  nome_canonico (C, &B);
  RobboTotal_registro (C);
  int i, k, v = RobboTotal_scop (C);
  if (v == -1)
    {
      printf("File not found %s\n", A);
      return;
    }
  uint64 c[256];
  for (i = 0; i < 256; i++)
    c[i] = 0;
  uint64 rf = (PILA_ROBBO_TOTAL + v)->PEDONE ? 1806 : 462;
  uint64 pr = (PILA_ROBBO_TOTAL + v)->pezzo_molt;
  uint64 PR = pr * rf;
  uint8 *Y, *Z;
  Y = malloc(65536);
  Z = malloc(65536);
  int j, J = (PR && 65535) + (PR >> 16);

  uint32 *p;
  p = (PILA_ROBBO_TOTAL + v)->indici;
  char STR[1024];
  sprintf (STR, "%s%s%s", (PILA_ROBBO_TOTAL + v)->DIR_NOME,
	   COMPRESSA_PREFISSO + 1, (PILA_ROBBO_TOTAL + v)->string);
  (PILA_ROBBO_TOTAL + v)->Fdata = fopen (STR, "r");
  for (j = 0; j < J; j++)
    {
      int w = p[j+1] - p[j];
      fread (Z, 1, w, (PILA_ROBBO_TOTAL + v)->Fdata);
      int d = blocco_decompressa (Y, Z, w, (PILA_ROBBO_TOTAL + v)->TIPO);
      for (k = 0; k < d; k++)
	c[Y[k]]++;
    }
  for (j = 0; j < 256; j++)
    if (c[j])
      printf ("%d %lld\n", j, c[j]);
  fclose ((PILA_ROBBO_TOTAL + v)->Fdata);
}

void
argomenti_lavora (int n, char **A)
{
  int i, b = 0;
  char STRUT[1024][16], OTT[1024];
  logico LOAD3 = VERO, LOAD4 = VERO, LOAD5 = VERO, LOAD6 = VERO,
    LOAD = VERO, RECURSE = FALSO;
  logico TRIPLE_LOAD3 = VERO, TRIPLE_LOAD4 = VERO,
    TRIPLE_LOAD5 = VERO, TRIPLE_LOAD6 = VERO, TRIPLE_LOAD = VERO;
  logico RobboTripleBase = FALSO, STATS = FALSO;
  for (i = 1; i < n; i++)
    {
      if (!strcmp (A[i], "--mem"))
	{
	  MEMORIA = VERO;
	  continue;
	}
      if (!strcmp (A[i], "--stats"))
	{
	  STATS = VERO;
	  continue;
	}
      if (!strcmp (A[i], "--RobboTripleBase"))
	{
	  RobboTripleBase = VERO;
	  continue;
	}
      if (!strcmp (A[i], "--recurse"))
	{
	  RECURSE = VERO;
	  continue;
	}
      if (!strcmp (A[i], "--noload"))
	{
	  LOAD = FALSO;
	  continue;
	}
      if (!strcmp (A[i], "--noload-triple"))
	{
	  TRIPLE_LOAD = FALSO;
	  continue;
	}
      if (!strcmp (A[i], "--noload3"))
	{
	  LOAD3 = FALSO;
	  continue;
	}
      if (!strcmp (A[i], "--noload4"))
	{
	  LOAD4 = FALSO;
	  continue;
	}
      if (!strcmp (A[i], "--noload5"))
	{
	  LOAD5 = FALSO;
	  continue;
	}
      if (!strcmp (A[i], "--noload6"))
	{
	  LOAD6 = FALSO;
	  continue;
	}
      strcpy (STRUT[b++], A[i]);
    }
  if (LOAD)
    {
      if (LOAD3)
	{
	  sprintf (OTT, "%s/3", ROBBO_TOTAL_DIR);
	  robbo_total_directory (OTT);
	}
      if (LOAD4)
	{
	  sprintf (OTT, "%s/4", ROBBO_TOTAL_DIR);
	  robbo_total_directory (OTT);
	}
      if (LOAD5)
	{
	  sprintf (OTT, "%s/5", ROBBO_TOTAL_DIR);
	  robbo_total_directory (OTT);
	}
      if (LOAD6)
	{
	  sprintf (OTT, "%s/6", ROBBO_TOTAL_DIR);
	  robbo_total_directory (OTT);
	}
    }
  if (TRIPLE_LOAD)
    {
      if (TRIPLE_LOAD3)
	{
	  sprintf (OTT, "%s/2", TRIPLE_DIR);
	  robbo_triple_directory (OTT);
	}
      if (TRIPLE_LOAD3)
	{
	  sprintf (OTT, "%s/3", TRIPLE_DIR);
	  robbo_triple_directory (OTT);
	}
      if (TRIPLE_LOAD4)
	{
	  sprintf (OTT, "%s/4", TRIPLE_DIR);
	  robbo_triple_directory (OTT);
	}
      if (TRIPLE_LOAD5)
	{
	  sprintf (OTT, "%s/5", TRIPLE_DIR);
	  robbo_triple_directory (OTT);
	}
      if (TRIPLE_LOAD6)
	{
	  sprintf (OTT, "%s/6", TRIPLE_DIR);
	  robbo_triple_directory (OTT);
	}
    }
  if (RobboTripleBase)
    {
      for (i = 0; i < b; i++)
	triple_disposto (STRUT[i], RECURSE);
      return;
    }
  if (STATS)
    {
      for (i = 0; i < b; i++)
	stats (STRUT[i]);
      return;
    }
  for (i = 0; i < b; i++)
    robbo_total_iniz (STRUT[i], RECURSE);
}


int
main (int argc, char **argv)
{
  pila_inizializzazione ();
  robbo_iniz ();
  //  DINAMICO = dinamico_inizio;
  iniz_vario ();
  INIZ_ROBBO_TRIPLE ();
  argomenti_lavora (argc, argv);
  exit (0);
}
