
#include "RobboLito.h"
#include "RobboTotalBase.h"

#define TOTAL_CACHE_PER 65536
static uint8 ***ROBBO_CACHE;
uint8 *BLOCCO;
static uint64 *CACHE_INFORMAZIONE[4];
static uint64 CONTO_CACHE = 0;

void
iniz_total_cache (uint64 mb)
{
  int i, j;
  ROBBO_CACHE = malloc (4 * sizeof (uint8 **));
  BLOCCO = malloc (TOTAL_CACHE_PER);
  if (mb < 64)
    mb = 64;
  mb = 1 << BSR (mb);
  CONTO_CACHE = mb << 2;
  CACHE_INFORMAZIONE[0] = malloc (CONTO_CACHE * sizeof (uint64));
  CACHE_INFORMAZIONE[1] = malloc (CONTO_CACHE * sizeof (uint64));
  CACHE_INFORMAZIONE[2] = malloc (CONTO_CACHE * sizeof (uint64));
  CACHE_INFORMAZIONE[3] = malloc (CONTO_CACHE * sizeof (uint64));
  ROBBO_CACHE[0] = malloc (CONTO_CACHE * sizeof (uint8 *));
  ROBBO_CACHE[1] = malloc (CONTO_CACHE * sizeof (uint8 *));
  ROBBO_CACHE[2] = malloc (CONTO_CACHE * sizeof (uint8 *));
  ROBBO_CACHE[3] = malloc (CONTO_CACHE * sizeof (uint8 *));
  for (j = 0; j < 4; j++)
    for (i = 0; i < CONTO_CACHE; i++)
      ROBBO_CACHE[j][i] = NULL;
  for (j = 0; j < 4; j++)
    for (i = 0; i < CONTO_CACHE; i++)
      CACHE_INFORMAZIONE[j][i] = 0xffffffff;
}

#define CACHE0(a,b) ( (123 * (a) + 321 * (b) ) & ( CONTO_CACHE - 1) )
#define CACHE1(a,b) ( (179 * (a) + 557 * (b) ) & ( CONTO_CACHE - 1) )
#define CACHE2(a,b) ( (671 * (a) + 409 * (b) ) & ( CONTO_CACHE - 1) )
#define CACHE3(a,b) ( (773 * (a) + 187 * (b) ) & ( CONTO_CACHE - 1) )

static uint32 espul_conto = 0;
static int fc = 0;
static uint8 *
scopPILA (RobboTotalBase * TotalBase, uint64 posizione_conto)
{
  uint64 v, n = TotalBase->num, zo = posizione_conto / TOTAL_CACHE_PER, ci =
    (n << 32) | zo;
  int h[4], e;
  h[0] = CACHE0 (n, zo);
  if (CACHE_INFORMAZIONE[0][h[0]] == ci)
    return ROBBO_CACHE[0][h[0]];
  h[1] = CACHE1 (n, zo);
  if (CACHE_INFORMAZIONE[1][h[1]] == ci)
    return ROBBO_CACHE[1][h[1]];
  h[2] = CACHE2 (n, zo);
  if (CACHE_INFORMAZIONE[2][h[2]] == ci)
    return ROBBO_CACHE[2][h[2]];
  h[3] = CACHE3 (n, zo);
  if (CACHE_INFORMAZIONE[3][h[3]] == ci)
    return ROBBO_CACHE[3][h[3]];
  espul_conto++;
  e = 0;
  int i;
  for (i = 0; i < 16; i++)
    e += (espul_conto >> i);
  e = e & 3;
  if (ROBBO_CACHE[e][h[e]])
    v = CACHE_INFORMAZIONE[e][h[e]];
  else
    ROBBO_CACHE[e][h[e]] = malloc (TOTAL_CACHE_PER);
  CACHE_INFORMAZIONE[e][h[e]] = ci;
  if (TotalBase->TIPO == DISCO_NON)
    {
      fseek (TotalBase->Fdata, zo * TOTAL_CACHE_PER, SEEK_SET);
      fread (ROBBO_CACHE[e][h[e]], 1, TOTAL_CACHE_PER, TotalBase->Fdata);
    }
  if (TotalBase->TIPO == DISCO_COMPRESSO || TotalBase->TIPO == DISCO_HUFFMAN)
    {
      uint32 ba = TotalBase->indici[zo];
      int lun = TotalBase->indici[zo + 1] - ba;
      uint64 f = 0;
      uint64 pr = ba;
      while (zo >= TotalBase->supp_indice[f])
	f++;
      pr += (f << 32);
      if (!TotalBase->Fdata)
	{
	  fc++;
	  if (fc==MASSIMO_FOPEN)
	    {
	      for (i = 0; i < MASSIMO_PILA; i++)
		if ((PILA_ROBBO_TOTAL + i)->Fdata)
		  {
		    fclose ((PILA_ROBBO_TOTAL + i)->Fdata);
		    (PILA_ROBBO_TOTAL + i)->Fdata = NULL;
		  }
	      fc = 1;
	    }
	  char STR[1024];
	  sprintf (STR, "%s%s%s", TotalBase->DIR_NOME,
		   COMPRESSA_PREFISSO + 1, TotalBase->string);
	  TotalBase->Fdata = fopen (STR, "r");
	}
      fseek (TotalBase->Fdata, pr, 0);
      fread (BLOCCO, 1, lun, TotalBase->Fdata);
      blocco_decompressa (ROBBO_CACHE[e][h[e]], BLOCCO, lun, TotalBase->TIPO);
    }
  return ROBBO_CACHE[e][h[e]];
}

int
tot_valu (RobboTotalBase * TotalBase, uint64 posizione_conto)
{
  uint8 *A;
  A = scopPILA (TotalBase, posizione_conto);
  return A[posizione_conto % TOTAL_CACHE_PER];
}

void
re_fetta (RobboTotalBase * TotalBase, int rf)
{
  uint8 *A;
  uint64 r, u = rf * TotalBase->pezzo_molt, v = u + TotalBase->pezzo_molt;
  for (r = u; r < v; r += TOTAL_CACHE_PER)
    A = scopPILA (TotalBase, r);
}
