
#ifndef ROBBO_CONTO
#define ROBBO_CONTO
#include "RobboLito.h"

#include "Robbo_conto.c"
#include "bianco.h"
#else
#include "nero.h"
#endif

static int
mio_conto_fuggio (tipo_posizione *POSIZIONE, uint64 * en_passant)
{
  int re, conto, pezzo, qu;
  uint64 attacco, ip, T, fuggio, U;
  *en_passant = 0;
  re = mio_quadretto_re;
  attacco = mio_re_scacco;
  qu = BSF (attacco);
  pezzo = POSIZIONE->qu[qu];
  fuggio =
    (~tuo_attaco) &
    (((pezzo == conto_tuo_pedone
       || pezzo ==
       conto_tuo_re) ? attaco_re[re] : 0) | EVASIONE[re][qu]) &
    (~POSIZIONE->occupato_nero_bianco);
  bitLIBERO (qu, attacco);
  if (attacco)
    {
      qu = BSF (attacco);
      pezzo = POSIZIONE->qu[qu];
      bitLIBERO (qu, attacco);
      if (attacco)
	{
	  *en_passant = -1;
	  return 0;
	}
      return POPCNT (fuggio &
		     (((pezzo == conto_tuo_pedone
			|| pezzo ==
			conto_tuo_re) ? attaco_re[re] : 0) |
		      EVASIONE[re][qu]));
    }
  conto = POPCNT (fuggio);
  ip = INTERPOSIZIONE[re][qu] & ~POSIZIONE->occupato_nero_bianco;
  if (!ip)
    return conto;
  T =
    bitbordo_mio_pedone & ~bitbordo_traversa_settima &
    indietro_turno ((ip & tuo_occupato) ^ ip) & ~tuo_xray;
  conto += POPCNT (T);
  T =
    bitbordo_mio_pedone & indietro_turno_due ((ip & tuo_occupato) ^ ip) &
    TRAVERSA_SECONDA & indietro_turno (~POSIZIONE->occupato_nero_bianco) &
    ~tuo_xray;
  T = avanti_turno (avanti_turno (T));
  conto += POPCNT (T);
  *en_passant =
    T & (((bitbordo_tuo_pedone & bitbordo_traversa_quarta) << 1) |
	 ((bitbordo_tuo_pedone & bitbordo_traversa_quarta) >> 1));
  for (U = bitbordo_mio_cavallo & ~tuo_xray; U; bitLIBERO (qu, U))
    conto += POPCNT (attaco_cavallo[BSF (U)] & ip);
  for (U = bitbordo_mio_alfiere & ~tuo_xray; U; bitLIBERO (qu, U))
    conto += POPCNT (attaco_alfiere (BSF (U)) & ip);
  for (U = bitbordo_mio_torre & ~tuo_xray; U; bitLIBERO (qu, U))
    conto += POPCNT (attaco_torre (BSF (U)) & ip);
  for (U = bitbordo_mio_donna & ~tuo_xray; U; bitLIBERO (qu, U))
    conto += POPCNT (attaco_donna (BSF (U)) & ip);
  return conto;
}

int
mio_conto (tipo_posizione *POSIZIONE, uint64 * en_passant)
{
  uint64 vuoto = ~POSIZIONE->occupato_nero_bianco, U, A, T;
  int b, conto = 0;
  mobilita (POSIZIONE);
  if (SCACCO)
    return mio_conto_fuggio (POSIZIONE, en_passant);
  for (U = bitbordo_mio_cavallo; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      if (tuo_xray & quadretto_fisso[b])
	continue;
      A = attaco_cavallo[b] & vuoto;
      conto += POPCNT (A);
    }
  for (U = bitbordo_mio_alfiere; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_alfiere (b) & vuoto;
      if (tuo_xray & quadretto_fisso[b])
	A &= INTERPOSIZIONE[mio_quadretto_re][tuo_xray_lista[b]];
      conto += POPCNT (A);
    }
  for (U = bitbordo_mio_torre; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_torre (b) & vuoto;
      if (tuo_xray & quadretto_fisso[b])
	A &= INTERPOSIZIONE[mio_quadretto_re][tuo_xray_lista[b]];
      conto += POPCNT (A);
    }
  for (U = bitbordo_mio_donna; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_donna (b) & vuoto;
      if (tuo_xray & quadretto_fisso[b])
	A &= INTERPOSIZIONE[mio_quadretto_re][tuo_xray_lista[b]];
      conto += POPCNT (A);
    }
  conto += POPCNT (attaco_re[mio_quadretto_re] & vuoto & ~tuo_attaco);
  conto +=
    POPCNT (bitbordo_mio_pedone & (~bitbordo_traversa_settima) &
	    indietro_turno (vuoto) & (pila_colonna[COLONNA (mio_quadretto_re)]
				      | ~tuo_xray));
  T =
    bitbordo_mio_pedone & TRAVERSA_SECONDA & indietro_turno (vuoto) &
    indietro_turno_due (vuoto) & (pila_colonna[COLONNA (mio_quadretto_re)] |
				  ~tuo_xray);
  T = avanti_turno (avanti_turno (T));
  conto += POPCNT (T);
  *en_passant =
    T & (((bitbordo_tuo_pedone & bitbordo_traversa_quarta) << 1) |
	 ((bitbordo_tuo_pedone & bitbordo_traversa_quarta) >> 1));
  return conto;
}
