
#include "RobboLito.h"
#include "RobboTotalBase.h"

#include <sys/time.h>
uint64
orologio ()
{
  uint64 x;
  struct timeval tv;
  gettimeofday (&tv, NULL);
  x = tv.tv_sec;
  x *= 1000000;
  x += tv.tv_usec;
  return x;
}

static uint64 RAGGIO_NO[64], RAGGIO_SE[64], RAGGIO_SO[64], RAGGIO_NE[64];
static uint64 RAGGIO_N[64], RAGGIO_S[64], RAGGIO_O[64], RAGGIO_E[64];

#define NUOVO_F1 VERO
#define NUOVO_F2 VERO

void DISCO_FREAD1 (uint8 *A, uint64 s, uint64 pro, FILE *F, uint64 fpro)
{
#if !NUOVO_F1
  fread (A, s, pro, F);
#else
  fread (A, s, fpro, F);
  dehuffman1 (A, pro);
#endif
}

void DISCO_FREAD2 (uint8 *A, uint64 s, uint64 pro, FILE *F, uint64 fpro)
{
#if !NUOVO_F2
  fread (A, s, pro, F);
#else
  fread (A, s, fpro, F);
  if (pro != fpro)
    dehuffman2 (A, pro);
#endif
}

int DISCO_FWRITE1 (uint8 *A, uint64 s, uint64 pro, FILE *F)
{
#if !NUOVO_F1
  return fwrite (A, s, pro, F);
#else
  uint8 *B;
  B = malloc (pro);
  int w = huffman1 (A, B, pro);
  fwrite (B, s, w, F);
  free (B);
  return w;
#endif
}

int DISCO_FWRITE2 (uint8 *A, uint64 s, uint64 pro, FILE *F)
{
#if !NUOVO_F2
  return fwrite (A, s, pro, F);
#else
  uint8 *B;
  B = malloc (2 * pro);
  int w = huffman2 (A, B, pro);
  fwrite (B, s, w, F);
  free (B);
  return w;
#endif
}

static void
iniz_raggio ()
{
  int qu, tr, co, TR, CO;
  for (qu = A1; qu <= H8; qu++)
    {
      TR = TRAVERSA (qu);
      CO = COLONNA (qu);
      RAGGIO_NE[qu] = 0;
      for (tr = TR, co = CO; tr <= T8 && co <= CH; tr++, co++)
	RAGGIO_NE[qu] |= quadretto_fisso[8 * tr + co];
      RAGGIO_NO[qu] = 0;
      for (tr = TR, co = CO; tr <= T8 && co >= CA; tr++, co--)
	RAGGIO_NO[qu] |= quadretto_fisso[8 * tr + co];
      RAGGIO_SO[qu] = 0;
      for (tr = TR, co = CO; tr >= T1 && co >= CA; tr--, co--)
	RAGGIO_SO[qu] |= quadretto_fisso[8 * tr + co];
      RAGGIO_SE[qu] = 0;
      for (tr = TR, co = CO; tr >= T1 && co <= CH; tr--, co++)
	RAGGIO_SE[qu] |= quadretto_fisso[8 * tr + co];
      RAGGIO_N[qu] = 0;
      for (tr = TR; tr <= T8; tr++)
	RAGGIO_N[qu] |= quadretto_fisso[8 * tr + CO];
      RAGGIO_S[qu] = 0;
      for (tr = TR; tr >= T1; tr--)
	RAGGIO_S[qu] |= quadretto_fisso[8 * tr + CO];
      RAGGIO_O[qu] = 0;
      for (co = CO; co >= CA; co--)
	RAGGIO_O[qu] |= quadretto_fisso[8 * TR + co];
      RAGGIO_E[qu] = 0;
      for (co = CO; co <= CH; co++)
	RAGGIO_E[qu] |= quadretto_fisso[8 * TR + co];
      RAGGIO_NE[qu] &= ~quadretto_fisso[qu];
      RAGGIO_SO[qu] &= ~quadretto_fisso[qu];
      RAGGIO_N[qu] &= ~quadretto_fisso[qu];
      RAGGIO_S[qu] &= ~quadretto_fisso[qu];
      RAGGIO_SE[qu] &= ~quadretto_fisso[qu];
      RAGGIO_NO[qu] &= ~quadretto_fisso[qu];
      RAGGIO_E[qu] &= ~quadretto_fisso[qu];
      RAGGIO_O[qu] &= ~quadretto_fisso[qu];
    }
}

void
FORZA_POS (RobboTotalBase * RTB, uint64 posizione_conto, tipo_fPOS * fpos)
{
  int i, rf, m, br, nr, v, x;
  uint64 n = posizione_conto, q, r, qu;
  logico PEDONE = FALSO;
  int PEZZO[4] = { 0, 0, 0, 0 }, quad[4] =
  {
  0, 0, 0, 0};

  for (i = 3; i >= 0; i--)
    {
      if (RTB->p[i] == conto_pedone_bianco || RTB->p[i] == conto_pedone_nero)
	PEDONE = VERO;
      DIV (q, n, RTB->m[i]);
      r = n - q * RTB->m[i];
      qu = r;
      n = q;
#if 1
      if (RTB->p[i] && i < 1 && (RTB->p[i]) == (RTB->p[i + 3]))
	{
	  if (RTB->p[i] == conto_pedone_bianco
	      || RTB->p[i] == conto_pedone_nero)
	    m = quad_quat_pedone[qu];
	  else
	    m = quad_quat_normale[qu];
	  quad[i] = m & 63;
	  quad[i + 1] = (m >> 6) & 63;
	  quad[i + 2] = (m >> 12) & 63;
	  quad[i + 3] = m >> 18;
	}
#endif
      else if (RTB->p[i] && i < 2 && (RTB->p[i]) == (RTB->p[i + 2]))
	{
	  if (RTB->p[i] == conto_pedone_bianco
	      || RTB->p[i] == conto_pedone_nero)
	    m = quad_tre_pedone[qu];
	  else
	    m = quad_tre_normale[qu];
	  quad[i] = m & 63;
	  quad[i + 1] = (m >> 6) & 63;
	  quad[i + 2] = m >> 12;
	}
      else if (RTB->p[i] && i < 3 && (RTB->p[i]) == (RTB->p[i + 1])
	       && RTB->m[i] != 1)
	{
	  if (RTB->p[i] == conto_pedone_bianco
	      || RTB->p[i] == conto_pedone_nero)
	    m = quad_due_pedone[qu];
	  else
	    m = quad_due_normale[qu];
	  quad[i] = m & 63;
	  quad[i + 1] = m >> 6;
	}
      else if (RTB->m[i] != 1)
	{
	  if (RTB->m[i] == 48)
	    qu += 8;
	  quad[i] = qu;
	}
    }
  if (PEDONE)
    rf = inverso_pedone_re[n];
  else
    rf = inverso_normale_re[n];
  for (i = 0; i < 4; i++)
    PEZZO[i] = col_scamb[RTB->p[i]];
  br = rf & 63;
  nr = rf >> 6;
  fpos->PEDONE = PEDONE;
  if (PEDONE)
    {
      int w = 2 * (COLONNA (nr) >= CE) + 1;
      for (i = 0; i < 4; i++)
	LANCpez (w, quad[i]);
      LANCpez (w, br);
      LANCpez (w, nr);
      rf = RE_pedone[64 * br + nr];
    }
  else
    {
      uint8 w = oLANC[br][nr];
      for (i = 0; i < 4; i++)
	LANCnor (w, quad[i]);
      LANCnor (w, nr);
      LANCnor (w, br);
      rf = RE_normale[64 * br + nr];
    }
  fpos->re_fetta = rf;
  fpos->br = br;
  fpos->nr = nr;
  fpos->OCCUPATO = quadretto_fisso[br] | quadretto_fisso[nr];
  v = RTB_PILA[PEZZO[0]][PEZZO[1]][PEZZO[2]][PEZZO[3]];
  for (i = 0; i < 4; i++)
    {
      x = (v >> (16 + 2 * i)) & 3;
      fpos->qu[i] = quad[x];
      fpos->pezzo[i] = PEZZO[x];
      if (PEZZO[i])
	fpos->OCCUPATO |= quadretto_fisso[quad[x]];
    }
  fpos->pedone_en_quarta = 0;
  for (i = 0; i < 4; i++)
    if (fpos->pezzo[i] == conto_pedone_nero && TRAVERSA (fpos->qu[i]) == T4)
      fpos->pedone_en_quarta |= quadretto_fisso[fpos->qu[i]];
  fpos->m[3] = 1;

  for (i = 0; i < 4; i++)
    fpos->rip[i] = 0;
  if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[3])
    {
      fpos->rip[0] = fpos->rip[1] = fpos->rip[2] = fpos->rip[3] = 4;
      fpos->rip_ai[0] = 1;
      fpos->rip_ai[1] = 2;
      fpos->rip_ai[2] = 3;
      fpos->rip_ai[3] = 4;
    }
  else if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[2])
    {
      fpos->rip[0] = fpos->rip[1] = fpos->rip[2] = 3;
      fpos->rip_ai[0] = 1;
      fpos->rip_ai[1] = 2;
      fpos->rip_ai[2] = 3;
    }
  else if (fpos->pezzo[1] && fpos->pezzo[1] == fpos->pezzo[3])
    {
      fpos->rip[1] = fpos->rip[2] = fpos->rip[3] = 3;
      fpos->rip_ai[1] = 1;
      fpos->rip_ai[2] = 2;
      fpos->rip_ai[3] = 3;
    }
  else
    {
      if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[1])
	{
	  fpos->rip[0] = fpos->rip[1] = 2;
	  fpos->rip_ai[0] = 1;
	  fpos->rip_ai[1] = 2;
	}
      if (fpos->pezzo[1] && fpos->pezzo[1] == fpos->pezzo[2])
	{
	  fpos->rip[1] = fpos->rip[2] = 2;
	  fpos->rip_ai[1] = 1;
	  fpos->rip_ai[2] = 2;
	}
      if (fpos->pezzo[2] && fpos->pezzo[2] == fpos->pezzo[3])
	{
	  fpos->rip[2] = fpos->rip[3] = 2;
	  fpos->rip_ai[2] = 1;
	  fpos->rip_ai[3] = 2;
	}
    }

  for (i = 2; i >= 0; i--)
    fpos->m[i] =
      fpos->m[i + 1] * ((PILA_ROBBO_TOTAL + (v & 65535))->m[i + 1]);
  fpos->re_fetta_molt = fpos->m[0] * (PILA_ROBBO_TOTAL + (v & 65535))->m[0];
  for (i = 0; i < 4; i++)
    quad[i] = fpos->qu[i] - 8 * (fpos->pezzo[i] == conto_pedone_bianco
				 || fpos->pezzo[i] == conto_pedone_nero);


  if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[3])
    {
      quad[0] = STESSO4[quad[0]][quad[1]][quad[2]][quad[3]];
      quad[1] = quad[2] = quad[3] = 0;
    }
  else if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[2])
    {
      quad[0] = STESSO3[quad[0]][quad[1]][quad[2]];
      quad[1] = quad[2] = 0;
    }
  else if (fpos->pezzo[1] && fpos->pezzo[1] == fpos->pezzo[3])
    {
      quad[1] = STESSO3[quad[1]][quad[2]][quad[3]];
      quad[2] = quad[3] = 0;
    }
  else
    {
      if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[1])
	{
	  quad[0] = STESSO2[quad[0]][quad[1]];
	  quad[1] = 0;
	}
      if (fpos->pezzo[1] && fpos->pezzo[1] == fpos->pezzo[2])
	{
	  quad[1] = STESSO2[quad[1]][quad[2]];
	  quad[2] = 0;
	}
      if (fpos->pezzo[2] && fpos->pezzo[2] == fpos->pezzo[3])
	{
	  quad[2] = STESSO2[quad[2]][quad[3]];
	  quad[3] = 0;
	}
    }
  fpos->ind = 0;
  for (i = 0; i < 4; i++)
    if (PEZZO[i])
      fpos->ind += fpos->m[i] * quad[i];
  fpos->doppio = -1;
  if ((!PEDONE) && TRAVERSA (br) == COLONNA (br)
      && TRAVERSA (nr) == COLONNA (nr))
    {
      for (i = 0; i < 4; i++)
	quad[i] = lanc_norm[1][fpos->qu[i]];
      if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[2])
	{
	  quad[0] = STESSO4[quad[0]][quad[1]][quad[2]][quad[3]];
	  quad[1] = quad[2] = quad[3] = 0;
	}
      else if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[2])
	{
	  quad[0] = STESSO3[quad[0]][quad[1]][quad[2]];
	  quad[1] = quad[2] = 0;
	}
      else if (fpos->pezzo[1] && fpos->pezzo[1] == fpos->pezzo[3])
	{
	  quad[1] = STESSO3[quad[1]][quad[2]][quad[3]];
	  quad[2] = quad[3] = 0;
	}
      else
	{
	  if (fpos->pezzo[0] && fpos->pezzo[0] == fpos->pezzo[1])
	    {
	      quad[0] = STESSO2[quad[0]][quad[1]];
	      quad[1] = 0;
	    }
	  if (fpos->pezzo[1] && fpos->pezzo[1] == fpos->pezzo[2])
	    {
	      quad[1] = STESSO2[quad[1]][quad[2]];
	      quad[2] = 0;
	    }
	  if (fpos->pezzo[2] && fpos->pezzo[2] == fpos->pezzo[3])
	    {
	      quad[2] = STESSO2[quad[2]][quad[3]];
	      quad[3] = 0;
	    }
	}
      fpos->doppio = 0;
      for (i = 0; i < 4; i++)
	if (PEZZO[i])
	  fpos->doppio += fpos->m[i] * quad[i];
    }
}

static char AMMET[64][64];
static void
ammet_iniz ()
{
  int qu, ai;
  for (qu = A1; qu <= H8; qu++)
    for (ai = A1; ai <= H8; ai++)
      {
	AMMET[qu][ai] =
	  (((TRAVERSA (ai) > TRAVERSA (qu)) || (COLONNA (ai) < COLONNA (qu)))
	   && (ai - qu) != 10 && (ai - qu) != -17);
	if ((TRAVERSA (ai) - TRAVERSA (qu)) == (COLONNA (ai) - COLONNA (qu))
	    && TRAVERSA (qu) > COLONNA (qu))
	  AMMET[qu][ai] = 0;
      }
}


#define DIAGa1h8 (0x8040201008040201)
#define DIAGh1a8 (0x0102040810204080)

#include <time.h>
#include <pthread.h>
static void
nano (int ns)
{
  struct timespec TS[1];
  TS->tv_sec = 0;
  TS->tv_nsec = ns;
  nanosleep (TS, NULL);
}

typedef struct
{
  uint32 quo, rem;
} tipo_QUO_REM;

static tipo_QUO_REM **BUFFER, *BUF_DEST;
#define BUF_CONTO 4
static int buf_conto[BUF_CONTO], BUF_CHE;
static int BUF_DENSO[BUF_CONTO], BUF_LINDO[BUF_CONTO];
static int MARCO_FINE;
#define BUF_PROP 1048576

static int BUF_FINE, IO_FINE;
static uint32 DEST_LIB;
static uint8 *PILA_DEST[1806];
static uint8 *DESTRA[32];
static int DES_RICER[1806];
static uint8 oDES[1806], hDES[1806], fDES[1806], lDES[1806];

static int BUF_UTIL[1806][BUF_CONTO];

static int ott_dest (RobboTotalBase * TotalBase, int x);
static int NUMERO_DI_ITERAZIONE = 0;

static uint8 *DEST_BITS[1806];
static uint8 *des_bit_pila[32];
static uint32 dbp_libero;
static int DES_NUM_FETTA[1806];

static int SPECCHIO[1806];
static void
iniz_iterazione ()
{
  int i, j;
  DEST_LIB = 0xffffffff;
  MARCO_FINE = FALSO;
  for (i = 0; i < 1806; i++)
    {
      PILA_DEST[i] = NULL;
      DES_RICER[i] = -1;
    }
  for (i = 0; i < 1806; i++)
    oDES[i] = hDES[i] = fDES[i] = lDES[i] = 0;
  for (i = 0; i < 1806; i++)
    SPECCHIO[i] = -1;
  for (i = 0; i < BUF_CONTO; i++)
    buf_conto[i] = BUF_DENSO[i] = 0;
  for (i = 0; i < BUF_CONTO; i++)
    BUF_LINDO[i] = 1;
  for (i = 0; i < 1806; i++)
    for (j = 0; j < BUF_CONTO; j++)
      BUF_UTIL[i][j] = 0;
  BUF_CHE = 0;
  BUF_DEST = BUFFER[BUF_CHE];
  BUF_LINDO[BUF_CHE] = 0;
}

static pthread_mutex_t PROIB_FSEEK[1];

void
iniz_una (RobboTotalBase * TotalBase)
{
  int i;
  BUFFER = malloc (BUF_CONTO * sizeof (tipo_QUO_REM *));
  pthread_mutex_init (PROIB_FSEEK, NULL);
  for (i = 0; i < BUF_CONTO; i++)
    BUFFER[i] = malloc (BUF_PROP * sizeof (tipo_QUO_REM));
  for (i = 0; i < 32; i++)
    {
      DESTRA[i] = malloc (TotalBase->pezzo_molt);
      des_bit_pila[i] = malloc (TotalBase->pezzo_molt8);
    }
}

void
fine_una ()
{
  int i;
  for (i = 0; i < BUF_CONTO; i++)
    free (BUFFER[i]);
  free (BUFFER);
  for (i = 0; i < 32; i++)
    {
      free (DESTRA[i]);
      free (des_bit_pila[i]);
    }
}

static logico
aMARCO (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    return emarco (TotalBase->MAR,
		   fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
  return emarco (TotalBase->mbuf, posizione_numero);
}

static void
aDESbits (RobboTotalBase * TotalBase, int fetta, FILE * F, logico w)
{
  if (!dbp_libero)
    {
      printf ("DESTRO BITS!\n");
      exit (1);
    }
  int r = BSF (dbp_libero);
  dbp_libero &= ~(1 << r);
  DES_NUM_FETTA[fetta] = r;
  fseek (F, fetta * TotalBase->pezzo_molt8, 0);
  if (w)
    DISCO_FREAD2 (des_bit_pila[r], 1, TotalBase->pezzo_molt8, F,
		  TotalBase->per_pro[fetta]);
  else 
    DISCO_FREAD2 (des_bit_pila[r], 1, TotalBase->pezzo_molt8, F,
		  TotalBase->mar_pro[fetta]);
  DEST_BITS[fetta] = des_bit_pila[r];
}

static void
zDESbits (RobboTotalBase * TotalBase, int fetta, FILE * F, logico w)
{
  int r = DES_NUM_FETTA[fetta];
  if (r == -1)
    return;
  DES_NUM_FETTA[fetta] = -1;
  dbp_libero |= (1 << r);
  fseek (F, fetta * TotalBase->pezzo_molt8, 0);
  int df = DISCO_FWRITE2 (des_bit_pila[r], 1, TotalBase->pezzo_molt8, F);
  if (w) TotalBase->per_pro[fetta] = df;
  else TotalBase->mar_pro[fetta] = df;
  DEST_BITS[fetta] = NULL;
}

static void
MARCO (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    {
      en_fisso (TotalBase->MAR,
		fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
      return;
    }
  if (!DEST_BITS[fetta])
    aDESbits (TotalBase, fetta, TotalBase->Fmar, FALSO);
  en_fisso (DEST_BITS[fetta], posizione_numero);
}

static void
nonMARCO (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    ex_fisso (TotalBase->MAR,
	      fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
  else
    ex_fisso (TotalBase->mbuf, posizione_numero);
}

static logico
eVIT (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    return emarco (TotalBase->VIT,
		   fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
  return emarco (TotalBase->vbuf, posizione_numero);
}

static void
aVIT (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    en_fisso (TotalBase->VIT,
	      fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
  else
    en_fisso (TotalBase->vbuf, posizione_numero);
}

static logico
ePERD (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    return emarco (TotalBase->PER,
		   fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
  return emarco (TotalBase->pbuf, posizione_numero);
}

static void
aPERD (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    {
      en_fisso (TotalBase->PER,
		fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
      return;
    }
  en_fisso (DEST_BITS[fetta], posizione_numero);
}

static void
zPERD (RobboTotalBase * TotalBase, int fetta, uint64 posizione_numero)
{
  if (TotalBase->MEMORIA)
    ex_fisso (TotalBase->PER,
	      fetta * TotalBase->pezzo_molt8 * 8 + posizione_numero);
  else
    ex_fisso (TotalBase->pbuf, posizione_numero);
}

static void
buf_limp (tipo_QUO_REM * BUF_QUO_REM, int PROP, RobboTotalBase * TotalBase)
{
  int b, valu, fetta, spos;
  for (b = 0; b < PROP; b++)
    {
      fetta = BUF_QUO_REM[b].quo;
      if (fetta == 0xbad)
	continue;
      spos = BUF_QUO_REM[b].rem;
      if (PILA_DEST[fetta] == NULL)
	while (!ott_dest (TotalBase, fetta))
	  nano (1000);
      oDES[fetta] = 1;
      valu = PILA_DEST[fetta][spos];
      if (valu >= PRIMERA_PERDITA)
	{
	  printf ("MALATO z:%d %d/%d\n", valu, fetta, spos);
	  exit (1);
	}
      if (valu == 1)
	{
	  aPERD (TotalBase, fetta, spos);
	  if (NUMERO_DI_ITERAZIONE >= LARGH)
	    {
	      uint64 n = (((uint64) fetta) << 32) | spos;
	      PILA_DEST[fetta][spos] = PERD_FINE;
	      TotalBase->supp++;
	      fwrite (&n, 8, 1, TotalBase->Fsupp);
	    }
	  else
	    PILA_DEST[fetta][spos] = PERD_IN (NUMERO_DI_ITERAZIONE);
	}
      else if (valu <= MASSIMO_RIMA)
	PILA_DEST[fetta][spos] = valu - 1;
    }
}

static void
buf_scan (RobboTotalBase * TotalBase)
{
  int i, j, pro = TotalBase->PEDONE ? 1806 : 462;
  while (!MARCO_FINE)
    {
      for (i = 0; i < BUF_CONTO; i++)
	if (BUF_DENSO[i])
	  {
	    buf_limp (BUFFER[i], buf_conto[i], TotalBase);
	    buf_conto[i] = 0;
	    for (j = 0; j < pro; j++)
	      BUF_UTIL[j][i] = 0;
	    BUF_DENSO[i] = 0;
	    BUF_LINDO[i] = 1;
	  }
      if (TotalBase->p[2])
	nano (10000);
    }
  if (TotalBase->p[1])
    nano (10000);
  for (i = 0; i < BUF_CONTO; i++)
    if (BUF_DENSO[i])
      {
	buf_limp (BUFFER[i], buf_conto[i], TotalBase);
	buf_conto[i] = 0;
	for (j = 0; j < pro; j++)
	  BUF_UTIL[j][i] = 0;
	BUF_DENSO[i] = 0;
	BUF_LINDO[i] = 1;
      }
  if (TotalBase->p[1])
    nano (10000);
  for (i = 0; i < BUF_CONTO; i++)
    if (BUF_DENSO[i])
      {
	buf_limp (BUFFER[i], buf_conto[i], TotalBase);
	buf_conto[i] = 0;
	for (j = 0; j < pro; j++)
	  BUF_UTIL[j][i] = 0;
	BUF_DENSO[i] = 0;
	BUF_LINDO[i] = 1;
      }
}

typedef struct
{
  RobboTotalBase *sinRTB, *desRTB;
} tipo_due_RTB;

static void *
pthread_buf (void *x)
{
  tipo_due_RTB *u;
  u = (tipo_due_RTB *) x;
  buf_scan (u->desRTB);
  BUF_FINE = VERO;
  return NULL;
}

#define LOCK(x) pthread_mutex_lock(x)
#define UNLOCK(x) pthread_mutex_unlock(x)

static int
ott_dest (RobboTotalBase * TotalBase, int x)
{
  LOCK (PROIB_FSEEK);
  if (PILA_DEST[x] != NULL)
    {
      UNLOCK (PROIB_FSEEK);
      return 1;
    }
  if (!DEST_LIB)
    {
      UNLOCK (PROIB_FSEEK);
      return 0;
    }
  int r = BSF (DEST_LIB);
  DEST_LIB ^= (1 << r);
  aDESbits (TotalBase, x, TotalBase->Fper, VERO);
  fseek (TotalBase->Frima, x * TotalBase->pezzo_molt, 0);
  DISCO_FREAD1 (DESTRA[r], 1, TotalBase->pezzo_molt, TotalBase->Frima,
		TotalBase->rima_pro[x]);
  PILA_DEST[x] = DESTRA[r];
  DES_RICER[x] = r;
  lDES[x] = 0;
  hDES[x] = 1;
  UNLOCK (PROIB_FSEEK);
  return 3;
}

static int
DESlim (RobboTotalBase * TotalBase, int x)
{
  LOCK (PROIB_FSEEK);
  int b, r = DES_RICER[x];
  uint8 LIMP = 0;
  if (r == -1)
    {
      lDES[x] = 1;
      UNLOCK (PROIB_FSEEK);
      return 1;
    }
  if (lDES[x])
    {
      UNLOCK (PROIB_FSEEK);
      return 2;
    }
  while (1)
    {
      LIMP = 0;
      for (b = 0; b < BUF_CONTO; b++)
	if (BUF_UTIL[x][b] && BUF_DENSO[b])
	  LIMP |= (1 << b);
      if (!LIMP)
	break;
      UNLOCK (PROIB_FSEEK);
      return 0;
    }
  if (SPECCHIO[x] == -1)
    {
      if (r == 0xadd)
	{
	  DES_RICER[x] = -1;
	}
      else
	{
	  SPECCHIO[x] = -1;
	  DEST_LIB ^= (1 << r);
	  DES_RICER[x] = -1;
	}
    }
  else
    {
      SPECCHIO[x] = -1;
      if (r == 0xadd)
	DES_RICER[x] = -1;
    }
  fseek (TotalBase->Frima, x * TotalBase->pezzo_molt, 0);
  int df =
    DISCO_FWRITE1 (PILA_DEST[x], 1, TotalBase->pezzo_molt, TotalBase->Frima);
  TotalBase->rima_pro[x] = df;
  zDESbits (TotalBase, x, TotalBase->Fper, VERO);
  PILA_DEST[x] = NULL;
  lDES[x] = 1;
  UNLOCK (PROIB_FSEEK);
  return 3;
}

static void
io_scan (RobboTotalBase * sinRTB, RobboTotalBase * desRTB)
{
  int i, pro = sinRTB->PEDONE ? 1806 : 462;
  while (!BUF_FINE)
    {
      for (i = 0; i < pro; i++)
	if (hDES[i] && fDES[i] && !lDES[i])
	  DESlim (desRTB, i);
      for (i = 0; i < pro; i++)
	if (oDES[i] && !hDES[i])
	  ott_dest (desRTB, i);
    }
  for (i = 0; i < pro; i++)
    if (fDES[i] && !lDES[i])
      DESlim (desRTB, i);
}

static void *
io_thread (void *x)
{
  tipo_due_RTB *u;
  u = (tipo_due_RTB *) x;
  io_scan (u->sinRTB, u->desRTB);
  IO_FINE = VERO;
  fflush (u->sinRTB->Frima);
  fflush (u->desRTB->Frima);
  if (DEST_LIB != 0xffffffff)
    {
      printf ("MALATO DESTRO\n");
      exit (1);
    }
  return NULL;
}

static void
nuovo_iterazione (RobboTotalBase * sinRTB, RobboTotalBase * desRTB)
{
  iniz_iterazione ();
  pthread_t thr1[1], thr2[1];
  tipo_due_RTB u[1], v[1];
  v->sinRTB = u->sinRTB = sinRTB;
  v->desRTB = u->desRTB = desRTB;
  IO_FINE = FALSO;
  BUF_FINE = FALSO;
  pthread_create (thr1, NULL, io_thread, (void *) u);
  pthread_create (thr2, NULL, pthread_buf, (void *) v);
}

#define BUFDES(x, y) \
 { \
   BUF_DEST[buf_conto[BUF_CHE]].quo = x; \
   BUF_DEST[buf_conto[BUF_CHE]++].rem = y; \
 }

#define PREPDES(x) oDES[x] = 1;

#define PROSSIMO_BUF() \
 { \
   BUF_DENSO[BUF_CHE] = 1; \
   BUF_CHE += 1; \
   BUF_CHE &= ( BUF_CONTO - 1 ); \
   while (!BUF_LINDO[BUF_CHE]) nano(1000); \
   BUF_LINDO[BUF_CHE] = 0; \
   BUF_DEST = BUFFER[BUF_CHE]; \
 }

#define DIAGa1h8SOPRA (0xff7f3f1f0f070301)
#define DIAGa1h8SOTTO (0x80c0e0f0f8fcfeff)
#define DIAGa1h8 (0x8040201008040201)

static void
sottRIMA (RobboTotalBase * desRTB, uint64 fet, uint64 ind)
{
  uint8 valu = desRTB->data[ind + fet * desRTB->pezzo_molt];
  if (valu >= PRIMERA_PERDITA)
    {
      printf ("MALATO z:%d %lld/%lld\n", valu, fet, ind);
      exit (1);
    }
  if (valu == 1)
    {
      aPERD (desRTB, fet, ind);
      if (NUMERO_DI_ITERAZIONE >= LARGH)
	{
	  uint64 n = (((uint64) fet) << 32) | ind;
	  desRTB->data[ind + fet * desRTB->pezzo_molt] = PERD_FINE;
	  desRTB->supp++;
	  fwrite (&n, 8, 1, desRTB->Fsupp);
	}
      else
	desRTB->data[ind + fet * desRTB->pezzo_molt] =
	  PERD_IN (NUMERO_DI_ITERAZIONE);
    }
  else if (valu <= MASSIMO_RIMA)
    desRTB->data[ind + fet * desRTB->pezzo_molt] = valu - 1;
}

static void
indice_sini (uint64 fet, uint64 ind, RobboTotalBase * sinRTB,
	     RobboTotalBase * desRTB)
{
  if (desRTB->MEMORIA)
    {
      sottRIMA (desRTB, fet, ind);
      return;
    }
  PREPDES (fet);
  BUFDES (fet, ind);
  BUF_UTIL[fet][BUF_CHE] = 1;
  if (buf_conto[BUF_CHE] == BUF_PROP)
    {
      PROSSIMO_BUF ();
    }
}

static void
indice_DES (uint64 fet, uint64 ind, RobboTotalBase * sinRTB,
	    RobboTotalBase * desRTB)
{
  MARCO (sinRTB, fet, ind);
}

static void
mossaPROCi (int qu, int b, int i, tipo_fPOS * fpos,
	    RobboTotalBase * sinRTB, RobboTotalBase * desRTB, logico simm,
	    void (*INDICE) (uint64, uint64, RobboTotalBase *,
			    RobboTotalBase *))
{
  uint64 indice, doppio;
  int ai, a1, a2, a3;
  if (simm && !AMMET[qu][b])
    return;
  if (!fpos->rip[i])
    {
      indice = fpos->ind + (b - qu) * fpos->m[i];
      doppio = 0;
      INDICE (fpos->re_fetta, indice, sinRTB, desRTB);
      if (!fpos->PEDONE && quadretto_fisso[fpos->br] & DIAGa1h8
	  && quadretto_fisso[fpos->nr] & DIAGa1h8)
	{
	  doppio =
	    fpos->doppio + (lanc_norm[1][b] - lanc_norm[1][qu]) * fpos->m[i];
	  if (doppio != indice || !simm)
	    INDICE (fpos->re_fetta, doppio, sinRTB, desRTB);
	}
    }
  if (fpos->rip[i] == 2)
    {
      if (fpos->rip_ai[i] == 1)
	ai = 1;
      else
	ai = -1;
      indice =
	fpos->ind + fpos->m[i] * (STESSO2[b][fpos->qu[i + ai]] -
				  STESSO2[qu][fpos->qu[i + ai]]);
      doppio = 0;
      INDICE (fpos->re_fetta, indice, sinRTB, desRTB);
      if (!fpos->PEDONE && quadretto_fisso[fpos->br] & DIAGa1h8
	  && quadretto_fisso[fpos->nr] & DIAGa1h8)
	{
	  doppio = fpos->doppio + fpos->m[i] *
	    (STESSO2[lanc_norm[1][b]][lanc_norm[1][fpos->qu[i + ai]]] -
	     STESSO2[lanc_norm[1][qu]][lanc_norm[1][fpos->qu[i + ai]]]);
	  if (doppio != indice || !simm)
	    INDICE (fpos->re_fetta, doppio, sinRTB, desRTB);
	}
    }
  if (fpos->rip[i] == 3)
    {
      if (fpos->rip_ai[i] == 1)
	{
	  a1 = 1;
	  a2 = 2;
	}
      if (fpos->rip_ai[i] == 2)
	{
	  a1 = -1;
	  a2 = 1;
	}
      if (fpos->rip_ai[i] == 3)
	{
	  a1 = -2;
	  a2 = -1;
	}
      indice =
	fpos->ind +
	fpos->m[i] * (STESSO3[b][fpos->qu[i + a1]][fpos->qu[i + a2]] -
		      STESSO3[qu][fpos->qu[i + a1]][fpos->qu[i + a2]]);
      doppio = 0;
      INDICE (fpos->re_fetta, indice, sinRTB, desRTB);
      if (!fpos->PEDONE && quadretto_fisso[fpos->br] & DIAGa1h8
	  && quadretto_fisso[fpos->nr] & DIAGa1h8)
	{
	  doppio = fpos->doppio + fpos->m[i] *
	    (STESSO3[lanc_norm[1][b]][lanc_norm[1][fpos->qu[i + a1]]]
	     [lanc_norm[1][fpos->qu[i + a2]]] -
	     STESSO3[lanc_norm[1][qu]][lanc_norm[1][fpos->qu[i + a1]]]
	     [lanc_norm[1][fpos->qu[i + a2]]]);
	  if (doppio != indice || !simm)
	    INDICE (fpos->re_fetta, doppio, sinRTB, desRTB);
	}
    }
  if (fpos->rip[i] == 4)
    {
      if (fpos->rip_ai[i] == 1)
	{
	  a1 = 1;
	  a2 = 2;
	  a3 = 3;
	}
      if (fpos->rip_ai[i] == 2)
	{
	  a1 = -1;
	  a2 = 1;
	  a3 = 2;
	}
      if (fpos->rip_ai[i] == 3)
	{
	  a1 = -2;
	  a2 = -1;
	  a3 = 1;
	}
      if (fpos->rip_ai[i] == 4)
	{
	  a1 = -3;
	  a2 = -2;
	  a3 = -1;
	}
      indice =
	fpos->ind +
	fpos->m[i] *
	(STESSO4[b][fpos->qu[i + a1]][fpos->qu[i + a2]][fpos->qu[i + a3]] -
	 STESSO4[qu][fpos->qu[i + a1]][fpos->qu[i + a2]][fpos->qu[i + a3]]);
      doppio = 0;
      INDICE (fpos->re_fetta, indice, sinRTB, desRTB);
      if (!fpos->PEDONE && quadretto_fisso[fpos->br] & DIAGa1h8
	  && quadretto_fisso[fpos->nr] & DIAGa1h8)
	{
	  doppio = fpos->doppio + fpos->m[i] *
	    (STESSO4[lanc_norm[1][b]][lanc_norm[1][fpos->qu[i + a1]]]
	     [lanc_norm[1][fpos->qu[i + a2]]][lanc_norm[1][fpos->qu[i + a3]]] -
	     STESSO4[lanc_norm[1][qu]][lanc_norm[1][fpos->qu[i + a1]]]
	     [lanc_norm[1][fpos->qu[i + a2]]][lanc_norm[1][fpos->qu[i + a3]]]);
	  if (doppio != indice || !simm)
	    INDICE (fpos->re_fetta, doppio, sinRTB, desRTB);
	}
    }
}

static void
iMOSSA_PEDONE (int qu, int b, int i, tipo_fPOS * fpos,
	       RobboTotalBase * sinRTB, RobboTotalBase * desRTB,
	       void (*INDICE) (uint64, uint64, RobboTotalBase *,
			       RobboTotalBase *))
{
  int ai, a1, a2, a3;
  uint64 indice;
  if (!fpos->rip[i])
    {
      indice = fpos->ind + (b - qu) * fpos->m[i];
      INDICE (fpos->re_fetta, indice, sinRTB, desRTB);
    }
  if (fpos->rip[i] == 2)
    {
      if (fpos->rip_ai[i] == 1)
	ai = 1;
      else
	ai = -1;
      indice =
	fpos->ind + fpos->m[i] * (STESSO2[b - 8][fpos->qu[i + ai] - 8] -
				  STESSO2[qu - 8][fpos->qu[i + ai] - 8]);
      INDICE (fpos->re_fetta, indice, sinRTB, desRTB);
    }
  if (fpos->rip[i] == 3)
    {
      if (fpos->rip_ai[i] == 1)
	{
	  a1 = 1;
	  a2 = 2;
	}
      if (fpos->rip_ai[i] == 2)
	{
	  a1 = -1;
	  a2 = 1;
	}
      if (fpos->rip_ai[i] == 3)
	{
	  a1 = -2;
	  a2 = -1;
	}
      indice =
	fpos->ind +
	fpos->m[i] *
	(STESSO3[(b) - 8][fpos->qu[i + a1] - 8][fpos->qu[i + a2] - 8] -
	 STESSO3[(qu) - 8][fpos->qu[i + a1] - 8][fpos->qu[i + a2] - 8]);
      INDICE (fpos->re_fetta, indice, sinRTB, desRTB);
    }
  if (fpos->rip[i] == 4)
    {
      if (fpos->rip_ai[i] == 1)
	{
	  a1 = 1;
	  a2 = 2;
	  a3 = 3;
	}
      if (fpos->rip_ai[i] == 2)
	{
	  a1 = -1;
	  a2 = 1;
	  a3 = 2;
	}
      if (fpos->rip_ai[i] == 3)
	{
	  a1 = -2;
	  a2 = -1;
	  a3 = 1;
	}
      if (fpos->rip_ai[i] == 4)
	{
	  a1 = -3;
	  a2 = -2;
	  a3 = -1;
	}
      indice =
	fpos->ind +
	fpos->m[i] *
	(STESSO4[(b) - 8][fpos->qu[i + a1] - 8]
                [fpos->qu[i + a2] - 8][fpos->qu[i + a3] - 8] -
	 STESSO4[(qu) - 8][fpos->qu[i + a1] - 8]
	        [fpos->qu[i + a2] - 8][fpos->qu[i + a3] - 8]);
      INDICE (fpos->re_fetta, indice, sinRTB, desRTB);
    }
}

static void
iMOSSA_RE (uint64 TARGA, tipo_fPOS * fpos,
	   RobboTotalBase * sinRTB, RobboTotalBase * desRTB, logico simm,
	   void (*INDICE) (uint64, uint64, RobboTotalBase *,
			   RobboTotalBase *))
{
  int j;
  uint64 doppio, indice;
  while (TARGA)
    {
      int b = BSF (TARGA);
      bitLIBERO (b, TARGA);
      doppio = 0;
      if (fpos->PEDONE)
	{
	  INDICE (RE_pedone[64 * b + fpos->nr], fpos->ind, sinRTB, desRTB);
	}
      else
	{
	  if (simm && !AMMET[fpos->br][b])
	    continue;
	  if (quadretto_fisso[fpos->nr] & DIAGa1h8
	      && quadretto_fisso[b] & DIAGa1h8SOPRA)
	    {
	      if (quadretto_fisso[b] & DIAGa1h8)
		{
		  INDICE (RE_normale[64 * b + fpos->nr], fpos->ind, sinRTB,
			  desRTB);
		  for (j = 0; j < 4; j++)
		    if (fpos->pezzo[j])
		      {
			if (!fpos->rip[j])
			  doppio += fpos->m[j] * lanc_norm[1][fpos->qu[j]];
			if (fpos->rip[j] == 2 && fpos->rip_ai[j] == 2)
			  doppio +=
			    fpos->m[j] *
			    STESSO2[lanc_norm[1][fpos->qu[j]]]
			           [lanc_norm[1][fpos->qu[j - 1]]];
			if (fpos->rip[j] == 3 && fpos->rip_ai[j] == 3)
			  doppio +=
			    fpos->m[j] *
			    STESSO3[lanc_norm[1][fpos->qu[j]]]
			           [lanc_norm[1][fpos->qu[j - 1]]]
			           [lanc_norm[1][fpos->qu[j - 2]]];
			if (fpos->rip[j] == 4 && fpos->rip_ai[j] == 4)
			  doppio +=
			    fpos->m[j] *
			    STESSO4[lanc_norm[1][fpos->qu[j]]]
			           [lanc_norm[1][fpos->qu[j - 1]]]
			           [lanc_norm[1][fpos->qu[j - 2]]]
			           [lanc_norm[1][fpos->qu[j - 3]]];
		      }
		  if (doppio != fpos->ind || !simm)
		    INDICE (RE_normale[64 * b + fpos->nr], doppio, sinRTB,
			    desRTB);
		}
	      else
		{
		  indice = 0;
		  for (j = 0; j < 4; j++)
		    if (fpos->pezzo[j])
		      {
			if (!fpos->rip[j])
			  indice += fpos->m[j] * lanc_norm[1][fpos->qu[j]];
			if (fpos->rip[j] == 2 && fpos->rip_ai[j] == 2)
			  indice += fpos->m[j] *
			    STESSO2[lanc_norm[1][fpos->qu[j]]]
			            [lanc_norm[1][fpos->qu[j - 1]]];
			if (fpos->rip[j] == 3 && fpos->rip_ai[j] == 3)
			  indice += fpos->m[j] *
			    STESSO3[lanc_norm[1][fpos->qu[j]]]
			           [lanc_norm[1][fpos->qu[j - 1]]]
			           [lanc_norm[1][fpos->qu[j - 2]]];
			if (fpos->rip[j] == 4 && fpos->rip_ai[j] == 4)
			  indice += fpos->m[j] *
			    STESSO4[lanc_norm[1][fpos->qu[j]]]
			           [lanc_norm[1][fpos->qu[j - 1]]]
			           [lanc_norm[1][fpos->qu[j - 2]]]
			           [lanc_norm[1][fpos->qu[j - 3]]];
		      }
		  INDICE (RE_normale
			  [64 * lanc_norm[1][b] + lanc_norm[1][fpos->nr]],
			  indice, sinRTB, desRTB);
		}
	    }
	  else
	    {
	      INDICE (RE_normale[64 * b + fpos->nr], fpos->ind, sinRTB,
		      desRTB);
	    }
	}
    }
}

#define mossaPROC(qu,b) mossaPROCi(qu,b,i,fpos,RTB1,RTB2,simm,indice_sini)
#define MOSSA_PEDONE(qu,b) iMOSSA_PEDONE(qu,b,i,fpos,RTB1,RTB2,indice_sini)
#define MOSSA_RE(TARGA) iMOSSA_RE(TARGA,fpos,RTB1,RTB2,simm,indice_sini)

#define LACCIO(TARGA, pros_bit, O) \
 { \
   uint64 T = TARGA; \
   while (T) \
     { \
       int b = pros_bit(T); \
       if (quadretto_fisso[b] & O) break; \
       T &= ~quadretto_fisso[b]; \
       mossaPROC(qu,b); \
     } \
}

#define eSTRUTvalu(A,x) A[x]
#define aSTRUTvalu(A,x,y) A[x] = y

static sint16 FINE_DES_NORMALE[462][8], FINE_DES_PEDONE[1806][8];
static uint16 RIMAP_NORMALE[462], RIMAP_PEDONE[1806];

static sint64
processo_MARCO (RobboTotalBase * RTB1, int num, RobboTotalBase * RTB2)
{
  sint64 conto = 0;
  int i, j;
  logico simm;
  uint64 oro = orologio ();
  tipo_fPOS fpos[1];
  uint64 rf, refet, RF = RTB1->PEDONE ? 1806 : 462;
  uint64 posizione_numero, LIMITE = RTB1->pezzo_molt;
  printf ("Mossa %d\n", num);
  for (i = 0; i < RF; i++)
    {
      DEST_BITS[i] = NULL;
      DES_NUM_FETTA[i] = -1;
    }
  dbp_libero = 0xffffffff;
  for (refet = 0; refet < RF; refet++)
    {
      rf = RTB1->PEDONE ? RIMAP_PEDONE[refet] : RIMAP_NORMALE[refet];
      if (!RTB1->MEMORIA)
	{
	  fseek (RTB1->Fmar, rf * RTB1->pezzo_molt8, 0);
	  DISCO_FREAD2 (RTB1->mbuf, 1, RTB1->pezzo_molt8, RTB1->Fmar,
			RTB1->mar_pro[rf]);
	  fseek (RTB1->Fvit, rf * RTB1->pezzo_molt8, 0);
	  DISCO_FREAD2 (RTB1->vbuf, 1, RTB1->pezzo_molt8, RTB1->Fvit,
			RTB1->vit_pro[rf]);
	}
      for (posizione_numero = 0; posizione_numero < LIMITE;
	   posizione_numero++)
	{
	  if (!aMARCO (RTB1, rf, posizione_numero))
	    continue;
	  if (eVIT (RTB1, rf, posizione_numero))
	    {
	      nonMARCO (RTB1, rf, posizione_numero);
	      continue;
	    }
	  aVIT (RTB1, rf, posizione_numero);
	  FORZA_POS (RTB1, rf * LIMITE + posizione_numero, fpos);
	  uint64 OCCUPATO = fpos->OCCUPATO;
	  int qu, pezzo;
	  nonMARCO (RTB1, rf, posizione_numero);
	  simm = FALSO;
	  if (fpos->doppio != -1)
	    {
	      if (fpos->ind < fpos->doppio)
		continue;
	      if (fpos->ind == fpos->doppio)
		simm = VERO;
	    }
	  conto++;
	  for (i = 0; i < 4 && fpos->pezzo[i]; i++)
	    {
	      if (fpos->pezzo[i] >= 8)
		continue;
	      qu = fpos->qu[i];
	      pezzo = fpos->pezzo[i];
	      if (pezzo == conto_pedone_bianco)
		{
		  if (qu >= A3 && !(OCCUPATO & quadretto_fisso[qu - 8]))
		    {
		      MOSSA_PEDONE (qu, qu - 8);
		      if (TRAVERSA (qu) == T4
			  && !(OCCUPATO & quadretto_fisso[qu - 16]))
			{
			  if (COLONNA (qu) != CA
			      && fpos->pedone_en_quarta & quadretto_fisso[qu -
									  1])
			    {
			      tipo_pezzo_quad PQ[1];
			      int w = 0;
			      PQ->br = fpos->br;
			      PQ->nr = fpos->nr;
			      PQ->bianco_en_mossa = VERO;
			      PQ->pedone = VERO;
			      for (j = 0; j < 4; j++)
				{
				  if (fpos->qu[j] == (qu - 1))
				    {
				      PQ->pezzo[w] = fpos->pezzo[j];
				      PQ->qu[w++] = qu - 8;
				    }
				  else if (fpos->qu[j] != qu)
				    {
				      PQ->pezzo[w] = fpos->pezzo[j];
				      PQ->qu[w++] = fpos->qu[j];
				    }
				}
			      for (j = w; j < 4; j++)
				PQ->pezzo[j] = PQ->qu[j] = 0;
			      int tb, rf;
			      uint64 ind, doppio;
			      tot_ind_ott (PQ, &tb, &ind, &doppio, &rf);
			      if (DISCO_PERDITA
				  (tot_valu
				   (PILA_ROBBO_TOTAL + tb,
				    rf * (PILA_ROBBO_TOTAL + tb)->pezzo_molt + ind)))
				continue;
			    }
			  if (COLONNA (qu) != CH
			      && fpos->pedone_en_quarta & quadretto_fisso[qu +
									  1])
			    {
			      tipo_pezzo_quad PQ[1];
			      int w = 0;
			      PQ->br = fpos->br;
			      PQ->nr = fpos->nr;
			      PQ->bianco_en_mossa = VERO;
			      PQ->pedone = VERO;
			      for (j = 0; j < 4; j++)
				{
				  if (fpos->qu[j] == (qu + 1))
				    {
				      PQ->pezzo[w] = fpos->pezzo[j];
				      PQ->qu[w++] = qu - 8;
				    }
				  else if (fpos->qu[j] != qu)
				    {
				      PQ->pezzo[w] = fpos->pezzo[j];
				      PQ->qu[w++] = fpos->qu[j];
				    }
				}
			      for (j = w; j < 4; j++)
				PQ->pezzo[j] = PQ->qu[j] = 0;
			      int tb, rf;
			      uint64 ind, doppio;
			      tot_ind_ott (PQ, &tb, &ind, &doppio, &rf);
			      if (DISCO_PERDITA
				  (tot_valu
				   (PILA_ROBBO_TOTAL + tb,
				    rf * (PILA_ROBBO_TOTAL + tb)->pezzo_molt + ind)))
				continue;
			    }
			  MOSSA_PEDONE (qu, qu - 16);
			}
		    }
		}
	      if (pezzo == conto_cavallo_bianco)
		LACCIO (attaco_cavallo[qu] & ~fpos->OCCUPATO, BSF, 0);
	      if (pezzo == conto_alfiere_bianco
		  || pezzo == conto_donna_bianca)
		{
		  LACCIO (RAGGIO_NO[qu], BSF, OCCUPATO);
		  if (!simm)
		    LACCIO (RAGGIO_SE[qu], BSR, OCCUPATO);
		  if (!simm || quadretto_fisso[qu] & DIAGa1h8SOTTO)
		    {
		      LACCIO (RAGGIO_SO[qu], BSR, OCCUPATO);
		      LACCIO (RAGGIO_NE[qu], BSF, OCCUPATO);
		    }
		}
	      if (pezzo == conto_torre_bianco || pezzo == conto_donna_bianca)
		{
		  LACCIO (RAGGIO_N[qu], BSF, OCCUPATO);
		  LACCIO (RAGGIO_O[qu], BSR, OCCUPATO);
		  if (!simm)
		    {
		      LACCIO (RAGGIO_S[qu], BSR, OCCUPATO);
		      LACCIO (RAGGIO_E[qu], BSF, OCCUPATO);
		    }
		}
	    }
	  uint64 RE_TARGA =
	    attaco_re[fpos->br] & ~attaco_re[fpos->nr] & ~OCCUPATO;
	  MOSSA_RE (RE_TARGA);
	}
      if (RTB1->MEMORIA)
	continue;
      PROSSIMO_BUF ();
      int df;
      fseek (RTB1->Fmar, rf * RTB1->pezzo_molt8, 0);
      df = DISCO_FWRITE2 (RTB1->mbuf, 1, RTB1->pezzo_molt8, RTB1->Fmar);
      RTB1->mar_pro[rf] = df;
      fseek (RTB1->Fvit, rf * RTB1->pezzo_molt8, 0);
      df = DISCO_FWRITE2 (RTB1->vbuf, 1, RTB1->pezzo_molt8, RTB1->Fvit);
      RTB1->vit_pro[rf] = df;
      if (RTB1->PEDONE)
	for (i = 0; FINE_DES_PEDONE[refet][i] != -1; i++)
	  fDES[FINE_DES_PEDONE[refet][i]] = 1;
      else
	for (i = 0; FINE_DES_NORMALE[refet][i] != -1; i++)
	  fDES[FINE_DES_NORMALE[refet][i]] = 1;
    }
  printf ("MARCO %lld [%.2fs]\n", conto,
	  ((double) (orologio () - oro)) / 1000000.0);
  if (RTB1->MEMORIA)
    return conto;
  return conto;
}

#define MOSSA_PEDONE(qu, b) \
  iMOSSA_PEDONE(qu, b, i, fpos, RTB2, RTB1, indice_DES)
#define MOSSA_RE(TARGA) \
  iMOSSA_RE(TARGA, fpos, RTB2, RTB1, simm, indice_DES)
#define mossaPROC(qu, b) \
  mossaPROCi(qu, b, i, fpos, RTB2, RTB1, simm, indice_DES)

static sint64
procRIMA (RobboTotalBase * RTB1, RobboTotalBase * RTB2)
{
  sint64 conto = 0;
  int i, j;
  uint64 posizione_numero, oro = orologio ();
  tipo_fPOS fpos[1];
  int refet, rf, RF = RTB1->PEDONE ? 1806 : 462;
  for (i = 0; i < RF; i++)
    {
      DEST_BITS[i] = NULL;
      DES_NUM_FETTA[i] = -1;
    }
  dbp_libero = 0xffffffff;
  for (refet = 0; refet < RF; refet++)
    {
      rf = RTB1->PEDONE ? RIMAP_PEDONE[refet] : RIMAP_NORMALE[refet];
      if (!RTB1->MEMORIA)
	{
	  fseek (RTB1->Fper, rf * RTB1->pezzo_molt8, 0);
	  DISCO_FREAD2 (RTB1->pbuf, 1, RTB1->pezzo_molt8, RTB1->Fper,
			RTB1->per_pro[rf]);
	}
      for (posizione_numero = 0; posizione_numero < RTB1->pezzo_molt;
	   posizione_numero++)
	{
	  if (!ePERD (RTB1, rf, posizione_numero))
	    continue;
	  zPERD (RTB1, rf, posizione_numero);
	  FORZA_POS (RTB1, rf * RTB1->pezzo_molt + posizione_numero, fpos);
	  uint64 OCCUPATO = fpos->OCCUPATO;
	  int qu, pezzo;
	  logico simm = FALSO;
	  if (fpos->doppio != -1)
	    {
	      if (fpos->ind < fpos->doppio)
		continue;
	      if (fpos->ind == fpos->doppio)
		simm = VERO;
	    }
	  conto++;
	  for (i = 0; i < 4 && fpos->pezzo[i]; i++)
	    {
	      if (fpos->pezzo[i] >= 8)
		continue;
	      qu = fpos->qu[i];
	      pezzo = fpos->pezzo[i];
	      if (pezzo == conto_pedone_bianco)
		{
		  if (qu >= A3 && !(OCCUPATO & quadretto_fisso[qu - 8]))
		    {
		      MOSSA_PEDONE (qu, qu - 8);
		      if (TRAVERSA (qu) == T4
			  && !(OCCUPATO & quadretto_fisso[qu - 16]))
			{
			  if (COLONNA (qu) != CA
			      && fpos->pedone_en_quarta & quadretto_fisso[qu -
									  1])
			    {
			      tipo_pezzo_quad PQ[1];
			      int w = 0;
			      PQ->br = fpos->br;
			      PQ->nr = fpos->nr;
			      PQ->bianco_en_mossa = VERO;
			      PQ->pedone = VERO;
			      for (j = 0; j < 4; j++)
				{
				  if (fpos->qu[j] == (qu - 1))
				    {
				      PQ->pezzo[w] = fpos->pezzo[j];
				      PQ->qu[w++] = qu - 8;
				    }
				  else if (fpos->qu[j] != qu)
				    {
				      PQ->pezzo[w] = fpos->pezzo[j];
				      PQ->qu[w++] = fpos->qu[j];
				    }
				}
			      for (j = w; j < 4; j++)
				PQ->pezzo[j] = PQ->qu[j] = 0;
			      int tb, rf;
			      uint64 ind, doppio;
			      tot_ind_ott (PQ, &tb, &ind, &doppio, &rf);
			      if (DISCO_PATT_PERD
				  (tot_valu
				   ((PILA_ROBBO_TOTAL + tb),
				    rf * (PILA_ROBBO_TOTAL +
					  tb)->pezzo_molt + ind)))
				continue;
			    }
			  if (COLONNA (qu) != CH
			      && fpos->pedone_en_quarta & quadretto_fisso[qu +
									  1])
			    {
			      tipo_pezzo_quad PQ[1];
			      int w = 0;
			      PQ->br = fpos->br;
			      PQ->nr = fpos->nr;
			      PQ->bianco_en_mossa = VERO;
			      PQ->pedone = VERO;
			      for (j = 0; j < 4; j++)
				{
				  if (fpos->qu[j] == (qu + 1))
				    {
				      PQ->pezzo[w] = fpos->pezzo[j];
				      PQ->qu[w++] = qu - 8;
				    }
				  else if (fpos->qu[j] != qu)
				    {
				      PQ->pezzo[w] = fpos->pezzo[j];
				      PQ->qu[w++] = fpos->qu[j];
				    }
				}
			      for (j = w; j < 4; j++)
				PQ->pezzo[j] = PQ->qu[j] = 0;
			      int tb, rf;
			      uint64 ind, doppio;
			      tot_ind_ott (PQ, &tb, &ind, &doppio, &rf);
			      if (DISCO_PATT_PERD
				  (tot_valu
				   (PILA_ROBBO_TOTAL + tb,
				    rf * (PILA_ROBBO_TOTAL + tb)->pezzo_molt + ind)))
				continue;
			    }
			  MOSSA_PEDONE (qu, qu - 16);
			}
		    }
		}
	      if (pezzo == conto_cavallo_bianco)
		LACCIO (attaco_cavallo[qu] & ~fpos->OCCUPATO, BSF, 0);
	      if (pezzo == conto_alfiere_bianco
		  || pezzo == conto_donna_bianca)
		{
		  LACCIO (RAGGIO_NO[qu], BSF, OCCUPATO);
		  if (!simm)
		    LACCIO (RAGGIO_SE[qu], BSR, OCCUPATO);
		  if (!simm || quadretto_fisso[qu] & DIAGa1h8SOTTO)
		    {
		      LACCIO (RAGGIO_SO[qu], BSR, OCCUPATO);
		      LACCIO (RAGGIO_NE[qu], BSF, OCCUPATO);
		    }
		}
	      if (pezzo == conto_torre_bianco || pezzo == conto_donna_bianca)
		{
		  LACCIO (RAGGIO_N[qu], BSF, OCCUPATO);
		  LACCIO (RAGGIO_O[qu], BSR, OCCUPATO);
		  if (!simm)
		    {
		      LACCIO (RAGGIO_S[qu], BSR, OCCUPATO);
		      LACCIO (RAGGIO_E[qu], BSF, OCCUPATO);
		    }
		}
	    }
	  uint64 RE_TARGA =
	    attaco_re[fpos->br] & ~attaco_re[fpos->nr] & ~OCCUPATO;
	  MOSSA_RE (RE_TARGA);
	}
      if (RTB1->MEMORIA)
	continue;
      fseek (RTB1->Fper, rf * RTB1->pezzo_molt8, 0);
      int df = DISCO_FWRITE2 (RTB1->pbuf, 1, RTB1->pezzo_molt8, RTB1->Fper);
      RTB1->per_pro[rf] = df;
      if (RTB1->PEDONE)
	for (i = 0; FINE_DES_PEDONE[refet][i] != -1; i++)
	  zDESbits (RTB2, FINE_DES_PEDONE[refet][i], RTB2->Fmar, FALSO);
      else
	for (i = 0; FINE_DES_NORMALE[refet][i] != -1; i++)
	  zDESbits (RTB2, FINE_DES_NORMALE[refet][i], RTB2->Fmar, FALSO);
    }
  printf ("NON RIMA %lld [%.2fs]\n", conto,
	  ((double) (orologio () - oro)) / 1000000.0);
  return conto;
}

uint64
fareMARCO (RobboTotalBase * RTB1, int iter, RobboTotalBase * RTB2)
{
  if (!RTB1->MEMORIA)
    nuovo_iterazione (RTB1, RTB2);
  NUMERO_DI_ITERAZIONE = iter + 1;
  if (NUMERO_DI_ITERAZIONE == LARGH)
    {
      char FN[1024];
      sprintf (FN, "%sSUPP.%s", RTB2->DIR_NOME, RTB2->string);
      RTB2->Fsupp = fopen (FN, "w+");
    }
  if (NUMERO_DI_ITERAZIONE >= LARGH)
    {
      fputc (0xff, RTB2->Fsupp);
      fputc (0xff, RTB2->Fsupp);
      fputc (0xff, RTB2->Fsupp);
      fputc (0xff, RTB2->Fsupp);
      fputc (NUMERO_DI_ITERAZIONE & 255, RTB2->Fsupp);
      fputc ((NUMERO_DI_ITERAZIONE >> 8) & 255, RTB2->Fsupp);
      fputc (0xff, RTB2->Fsupp);
      fputc (0xff, RTB2->Fsupp);
    }
  uint64 marco = processo_MARCO (RTB1, iter, RTB2);
  if (RTB1->MEMORIA)
    return marco;
  MARCO_FINE = VERO;
  while (!IO_FINE || !BUF_FINE)
    nano (1000);
  return marco;
}

uint64
fareRIMA (RobboTotalBase * RTB1, int iter, RobboTotalBase * RTB2)
{
  return procRIMA (RTB1, RTB2);
}

typedef struct
{
  int w, massimo, minimo;
  sint16 data[10];
} tipo_re_pedone;

static int
qsort_RE_PEDONE (const void *x, const void *y)
{
  tipo_re_pedone *a, *b;
  a = (tipo_re_pedone *) x;
  b = (tipo_re_pedone *) y;
  if (a->minimo < b->minimo)
    return -1;
  if (a->minimo > b->minimo)
    return 1;
  if (a->w < b->w)
    return -1;
  if (a->w > b->w)
    return 1;
  return 0;
}

static void
iniz_fine_des ()
{
  int c, j, br, nr, b, rf, i, t, w, massimo, minimo, FINE[1806];
  tipo_re_pedone RE_PEDONE[1806], RE_NORMALE[462];
  for (br = A1; br <= H8; br++)
    for (nr = A1; nr <= H8; nr++)
      {
	rf = RE_pedone[64 * br + nr];
	if (rf == -1)
	  continue;
	uint64 U = (attaco_re[nr] & ~attaco_re[br]) | quadretto_fisso[nr];
	c = 0;
	massimo = 0;
	minimo = 2000;
	while (U)
	  {
	    b = BSF (U);
	    bitLIBERO (b, U);
	    w = 1 + 2 * (COLONNA (br) >= CE);
	    t = RE_pedone[lanc_pedone[w][b] * 64 + lanc_pedone[w][br]];
	    if (t < minimo)
	      minimo = t;
	    if (t > massimo)
	      massimo = t;
	    RE_PEDONE[rf].data[c++] = t;
	  }
	RE_PEDONE[rf].massimo = massimo;
	RE_PEDONE[rf].minimo = minimo;
	RE_PEDONE[rf].w = rf;
	RE_PEDONE[rf].data[c] = -1;
      }
  qsort (RE_PEDONE, 1806, sizeof (tipo_re_pedone), qsort_RE_PEDONE);
  for (i = 0; i < 1806; i++)
    RIMAP_PEDONE[i] = RE_PEDONE[i].w;
  for (i = 0; i < 1806; i++)
    for (j = 0; RE_PEDONE[i].data[j] != -1; j++)
      FINE[RE_PEDONE[i].data[j]] = i;
  for (i = 0; i < 1806; i++)
    for (j = 0; j < 8; j++)
      FINE_DES_PEDONE[i][j] = -1;
  for (i = 0; i < 1806; i++)
    {
      int u = FINE[i];
      for (j = 0; FINE_DES_PEDONE[u][j] != -1; j++);
      FINE_DES_PEDONE[u][j] = i;
    }

  for (br = A1; br <= H8; br++)
    for (nr = A1; nr <= H8; nr++)
      {
	uint64 U = (attaco_re[nr] & ~attaco_re[br]) | quadretto_fisso[nr];
	rf = RE_normale[64 * br + nr];
	if (rf == -1)
	  continue;
	c = 0;
	massimo = 0;
	minimo = 500;
	while (U)
	  {
	    b = BSF (U);
	    bitLIBERO (b, U);
	    w = oLANC[b][br];
	    t = RE_normale[lanc_norm[w][b] * 64 + lanc_norm[w][br]];
	    if (t < minimo)
	      minimo = t;
	    if (t > massimo)
	      massimo = t;
	    RE_NORMALE[rf].data[c++] = t;
	  }
	RE_NORMALE[rf].massimo = massimo;
	RE_NORMALE[rf].minimo = minimo;
	RE_NORMALE[rf].w = rf;
	RE_NORMALE[rf].data[c] = -1;
      }
  qsort (RE_NORMALE, 462, sizeof (tipo_re_pedone), qsort_RE_PEDONE);
  for (i = 0; i < 462; i++)
    RIMAP_NORMALE[i] = RE_NORMALE[i].w;
  for (i = 0; i < 462; i++)
    for (j = 0; RE_NORMALE[i].data[j] != -1; j++)
      FINE[RE_NORMALE[i].data[j]] = i;
  for (i = 0; i < 462; i++)
    for (j = 0; j < 8; j++)
      FINE_DES_NORMALE[i][j] = -1;
  for (i = 0; i < 462; i++)
    {
      int u = FINE[i];
      for (j = 0; FINE_DES_NORMALE[u][j] != -1; j++);
      FINE_DES_NORMALE[u][j] = i;
    }
}

void
iniz_vario ()
{
  iniz_raggio ();
  ammet_iniz ();
  iniz_fine_des ();
}
