
#include "RobboLito.h"
#include "RobboTotalBase.h"
#include "RobboTripleBase.h"

void
robbo_iniz ()
{
  int pez1, pez2, pez3, pez4;
  int i;
  iniz_robbo_utilita (FALSO);
  NUM_ROBBO_TOTAL = 0;
  for (pez1 = 0; pez1 < 16; pez1++)
    for (pez2 = 0; pez2 < 16; pez2++)
      for (pez3 = 0; pez3 < 16; pez3++)
	for (pez4 = 0; pez4 < 16; pez4++)
	  RTB_PILA[pez1][pez2][pez3][pez4] = -1;
  PILA_ROBBO_TOTAL = malloc (MASSIMO_PILA * sizeof (RobboTotalBase));
  for (i = 0; i < MASSIMO_PILA; i++)
    (PILA_ROBBO_TOTAL + i)->Fdata = NULL;
  iniz_total_cache (64);
  INIZ_ROBBO_TRIPLE ();
}

void
total_iniz ()
{
  char DIR[1024];
  robbo_iniz ();
  sprintf (DIR, "%s/3", ROBBO_TOTAL_DIR);
  robbo_total_directory (DIR);
  sprintf (DIR, "%s/4", ROBBO_TOTAL_DIR);
  robbo_total_directory (DIR);
  sprintf (DIR, "%s/5", ROBBO_TOTAL_DIR);
  robbo_total_directory (DIR);
  sprintf (DIR, "%s/6", ROBBO_TOTAL_DIR);
  robbo_total_directory (DIR);
  sprintf (DIR, "%s/2", TRIPLE_DIR);
  robbo_triple_directory (DIR);
  sprintf (DIR, "%s/3", TRIPLE_DIR);
  robbo_triple_directory (DIR);
  sprintf (DIR, "%s/4", TRIPLE_DIR);
  robbo_triple_directory (DIR);
  sprintf (DIR, "%s/5", TRIPLE_DIR);
  robbo_triple_directory (DIR);
  triple_statistica ();
}

#define scacco\
 ( POSIZIONE->bianco_en_mossa ?\
   (bitbordo_bianco_re & DINAMICO->attacco_nero) :\
   (bitbordo_nero_re & DINAMICO->attacco_bianco) )

#define illegale\
 ( !POSIZIONE->bianco_en_mossa ?\
   (bitbordo_bianco_re & DINAMICO->attacco_nero) :\
   (bitbordo_nero_re & DINAMICO->attacco_bianco) )

logico
Robbo_mossa (tipo_posizione *POSIZIONE, uint32 * am, int *v)
{
  int va, v2, av = 0xff, zv = 0x00;
  tipo_lista_mossa mossa_lista[256], *q;
  uint32 m;
  if (DINAMICO->arrocco || DINAMICO->en_passant) return FALSO;
  if (!RobboTotal_valu (POSIZIONE, &va) || va == dPERD0)
    return FALSO;
  chiamata_valu_piena(0);
  if (scacco)
    evasione_mossa (POSIZIONE, mossa_lista, 0xffffffffffffffff);
  else
    {
      q = cattura_mossa (POSIZIONE, mossa_lista, 0xffffffffffffffff);
      ordinaria_mossa (POSIZIONE, q);
    }
  for (q = mossa_lista; q->mossa; q++)
    {
      m = q->mossa;
      fare (POSIZIONE, m);
      chiamata_valu_piena (0);
      if (illegale)
	{
	  annullare (POSIZIONE, m);
	  continue;
	}
      if (!RobboTotal_valu (POSIZIONE, &v2))
	{
	  annullare (POSIZIONE, m);
	  return FALSO;
	}
      if (DISCO_PERDITA (va))
	{
	  uint32 m3;
	  int v3;
	  if (!Robbo_mossa (POSIZIONE, &m3, &v3))
	    {
	      annullare (POSIZIONE, m);
	      return FALSO;
	    }
	  if (v3 > zv)
	    {
	      *am = m;
	      *v = zv = v3;
	    }
	}
      annullare (POSIZIONE, m);
      if (DISCO_PATTA (va) && DISCO_PATTA (v2))
	{
	  *am = m;
	  *v = dPATT;
	  return VERO;
	}
      if (DISCO_VITTORIA (va) && DISCO_PERDITA (v2))
	{
	  if (POSIZIONE->qu[AI (m)] || (m & pietra_celare))
	    {
	      *am = m;
	      *v = v2;
	      return VERO;
	    }

	  if (v2 < av)
	    {
	      *am = m;
	      *v = av = v2;
	    }
	}
    }
  return VERO;
}

logico
RobboFare (tipo_posizione *POSIZIONE)
{
  int va, v2;
  uint32 m;
  if (POPCNT (POSIZIONE->occupato_nero_bianco) > 6 || !RobboTotal_valu (POSIZIONE, &va))
    return FALSO;
  if (!Robbo_mossa (POSIZIONE, &m, &v2))
    return FALSO;
  if (DISCO_PATTA (va))
    {
      TRASMISSIONE ("info depth 0 score cp 0 pv %s\n",
		    mossa_notazione (m, STRING1));
      TRASMISSIONE ("bestmove %s\n", mossa_notazione (m, STRING1));
      return VERO;
    }
  if (DISCO_PERDITA (va))
    {
      TRASMISSIONE ("info depth 0 score cp %d pv %s\n",
		    -28000 + 1000 * POPCNT (POSIZIONE->occupato_nero_bianco) +
		    v2, mossa_notazione (m, STRING1));
      TRASMISSIONE ("bestmove %s\n", mossa_notazione (m, STRING1));
      return VERO;
    }
  if (DISCO_VITTORIA (va))
    {
      TRASMISSIONE ("info depth 0 score cp %d pv %s\n",
		    28000 - 1000 * POPCNT (POSIZIONE->occupato_nero_bianco) -
		    v2, mossa_notazione (m, STRING1));
      TRASMISSIONE ("bestmove %s\n", mossa_notazione (m, STRING1));
      return VERO;
    }
  return FALSO;
}
