#include "RobboLito.h"

#define bitbordo_due(x,y) (((uint64) 1)<<(x))|(((uint64) 1)<<(y))

const uint64 en_passant_bianco[8] =
  { bitbordo_due (B4, B4), bitbordo_due (A4, C4),
  bitbordo_due (B4, D4), bitbordo_due (C4, E4),
  bitbordo_due (D4, F4), bitbordo_due (E4, G4),
  bitbordo_due (F4, H4), bitbordo_due (G4, G4)
};

const uint64 en_passant_nero[8] =
  { bitbordo_due (B5, B5), bitbordo_due (A5, C5),
  bitbordo_due (B5, D5), bitbordo_due (C5, E5),
  bitbordo_due (D5, F5), bitbordo_due (E5, G5),
  bitbordo_due (F5, H5), bitbordo_due (G5, G5)
};

#define occupato_libero(M, x) \
 { \
   POSIZIONE->occupato_nero_bianco&=M; \
   POSIZIONE->occupato_sinistro90&=sinistro90_reset[x]; \
   POSIZIONE->occupato_sinistro45&=sinistro45_reset[x]; \
   POSIZIONE->occupato_retto45&=retto45_reset[x]; \
 }
#define occupato_fisso(M, x) \
  { \
    POSIZIONE->occupato_nero_bianco|=M; \
    POSIZIONE->occupato_sinistro90|=sinistro90_fisso[x]; \
    POSIZIONE->occupato_sinistro45|=sinistro45_fisso[x]; \
    POSIZIONE->occupato_retto45|=retto45_fisso[x]; \
  }

const static int promozione_bianco[8] =
  { 0, 0, 0, 0, conto_cavallo_bianco, conto_chiaro_bianco,
  conto_torre_bianco, conto_donna_bianca
};

void
fare_bianco (tipo_posizione *POSIZIONE, uint32 mossa)
{
  int di, ai, pezzo, cattura, z;
  uint64 cel;
  memcpy (DINAMICO + 1, DINAMICO, 32);
  di = DI (mossa);
  ai = AI (mossa);
  pezzo = POSIZIONE->qu[di];
  DINAMICO++;
  DINAMICO->en_passant = 0;
  POSIZIONE->qu[di] = 0;
  cel = quadretto_libero[di];
  bitbordo_occupato_bianco &= cel;
  POSIZIONE->bitbordo[pezzo] &= cel;
  occupato_libero (cel, di);
  cattura = POSIZIONE->qu[ai];
  DINAMICO->cattura = cattura;
  POSIZIONE->bianco_en_mossa ^= 1;
  if (pezzo == conto_re_bianco)
    POSIZIONE->bianco_re_quadretto = ai;
  if (cattura)
    {
      cel = quadretto_libero[ai];
      bitbordo_occupato_nero &= cel;
      POSIZIONE->bitbordo[cattura] &= cel;
    }
  else
    {
      cel = quadretto_fisso[ai];
      occupato_fisso (cel, ai);
    }
  POSIZIONE->qu[ai] = pezzo;
  bitbordo_occupato_bianco |= quadretto_fisso[ai];
  POSIZIONE->bitbordo[pezzo] |= quadretto_fisso[ai];
  if (pezzo == conto_pedone_bianco)
    {
      if (mossa_en_passant (mossa))
	{
	  z = ai ^ 8;
	  cel = quadretto_libero[z];
	  bitbordo_occupato_nero &= cel;
	  bitbordo_nero_pedone &= cel;
	  occupato_libero (cel, z);
	  POSIZIONE->qu[z] = 0;
	}
      else if (mossa_promozione (mossa))
	{
	  pezzo = promozione_bianco[(mossa & pietra_celare) >> 12];
	  if (pezzo == conto_chiaro_bianco && quadretto_fisso[ai] & SCURO)
	    pezzo = conto_scuro_bianco;
	  POSIZIONE->qu[ai] = pezzo;
	  bitbordo_bianco_pedone &= quadretto_libero[ai];
	  POSIZIONE->bitbordo[pezzo] |= quadretto_fisso[ai];
	}
      else if ((ai ^ di) == 16)
	{
	  if (en_passant_bianco[ai & 7] & bitbordo_nero_pedone)
	    {
	      z = (di + ai) >> 1;
	      DINAMICO->en_passant = z;
	    }
	}
    }
}

void
annullare_bianco (tipo_posizione *POSIZIONE, uint32 mossa)
{
  int di, ai, pezzo, cattura, z;
  uint64 cel;
  di = DI (mossa);
  ai = AI (mossa);
  pezzo = POSIZIONE->qu[ai];
  POSIZIONE->bianco_en_mossa ^= 1;
  if (mossa_promozione (mossa))
    {
      POSIZIONE->bitbordo[pezzo] &= quadretto_libero[ai];
      pezzo = conto_pedone_bianco;
    }
  POSIZIONE->qu[di] = pezzo;
  POSIZIONE->qu[ai] = DINAMICO->cattura;
  if (pezzo == conto_re_bianco)
    POSIZIONE->bianco_re_quadretto = di;
  cel = quadretto_fisso[di];
  bitbordo_occupato_bianco |= cel;
  POSIZIONE->bitbordo[pezzo] |= cel;
  occupato_fisso (cel, di);
  cel = quadretto_libero[ai];
  bitbordo_occupato_bianco &= cel;
  POSIZIONE->bitbordo[pezzo] &= cel;
  cattura = DINAMICO->cattura;
  if (cattura)
    {
      cel = ~cel;
      bitbordo_occupato_nero |= cel;
      POSIZIONE->bitbordo[cattura] |= cel;
    }
  else
    {
      occupato_libero (cel, ai);
      if (mossa_en_passant (mossa))
	{
	  z = ai ^ 8;
	  POSIZIONE->qu[z] = conto_pedone_nero;
	  cel = quadretto_fisso[z];
	  bitbordo_occupato_nero |= cel;
	  bitbordo_nero_pedone |= cel;
	  occupato_fisso (cel, z);
	}
    }
  DINAMICO--;
}

const static int promozione_nero[8] =
  { 0, 0, 0, 0, conto_cavallo_nero, conto_chiaro_nero,
  conto_torre_nero, conto_donna_nera
};

void
fare_nero (tipo_posizione *POSIZIONE, uint32 mossa)
{
  int di, ai, pezzo, cattura, z;
  uint64 cel;
  memcpy (DINAMICO + 1, DINAMICO, 32);
  di = DI (mossa);
  ai = AI (mossa);
  pezzo = POSIZIONE->qu[di];
  DINAMICO++;
  DINAMICO->en_passant = 0;
  POSIZIONE->qu[di] = 0;
  cel = quadretto_libero[di];
  bitbordo_occupato_nero &= cel;
  POSIZIONE->bitbordo[pezzo] &= cel;
  occupato_libero (cel, di);
  cattura = POSIZIONE->qu[ai];
  DINAMICO->cattura = cattura;
  POSIZIONE->bianco_en_mossa ^= 1;
  if (pezzo == conto_re_nero)
    POSIZIONE->nero_re_quadretto = ai;
  if (cattura)
    {
      cel = quadretto_libero[ai];
      bitbordo_occupato_bianco &= cel;
      POSIZIONE->bitbordo[cattura] &= cel;
    }
  else
    {
      cel = quadretto_fisso[ai];
      occupato_fisso (cel, ai);
    }
  POSIZIONE->qu[ai] = pezzo;
  bitbordo_occupato_nero |= quadretto_fisso[ai];
  POSIZIONE->bitbordo[pezzo] |= quadretto_fisso[ai];
  if (pezzo == conto_pedone_nero)
    {
      if (mossa_en_passant (mossa))
	{
	  z = ai ^ 8;
	  cel = quadretto_libero[z];
	  bitbordo_occupato_bianco &= cel;
	  bitbordo_bianco_pedone &= cel;
	  occupato_libero (cel, z);
	  POSIZIONE->qu[z] = 0;
	}
      else if (mossa_promozione (mossa))
	{
	  pezzo = promozione_nero[(mossa & pietra_celare) >> 12];
	  if (pezzo == conto_chiaro_nero && quadretto_fisso[ai] & SCURO)
	    pezzo = conto_scuro_nero;
	  POSIZIONE->qu[ai] = pezzo;
	  bitbordo_nero_pedone &= quadretto_libero[ai];
	  POSIZIONE->bitbordo[pezzo] |= quadretto_fisso[ai];
	}
      else if ((ai ^ di) == 16)
	{
	  if (en_passant_nero[ai & 7] & bitbordo_bianco_pedone)
	    {
	      z = (di + ai) >> 1;
	      DINAMICO->en_passant = z;
	    }
	}
    }
}

void
annullare_nero (tipo_posizione *POSIZIONE, uint32 mossa)
{
  int di, ai, pezzo, cattura, z;
  uint64 cel;
  di = DI (mossa);
  ai = AI (mossa);
  pezzo = POSIZIONE->qu[ai];
  POSIZIONE->bianco_en_mossa ^= 1;
  if (mossa_promozione (mossa))
    {
      POSIZIONE->bitbordo[pezzo] &= quadretto_libero[ai];
      pezzo = conto_pedone_nero;
    }
  POSIZIONE->qu[di] = pezzo;
  POSIZIONE->qu[ai] = DINAMICO->cattura;
  if (pezzo == conto_re_nero)
    POSIZIONE->nero_re_quadretto = di;
  cel = quadretto_fisso[di];
  bitbordo_occupato_nero |= cel;
  POSIZIONE->bitbordo[pezzo] |= cel;
  occupato_fisso (cel, di);
  cel = quadretto_libero[ai];
  bitbordo_occupato_nero &= cel;
  POSIZIONE->bitbordo[pezzo] &= cel;
  cattura = DINAMICO->cattura;
  if (cattura)
    {
      cel = ~cel;
      bitbordo_occupato_bianco |= cel;
      POSIZIONE->bitbordo[cattura] |= cel;
    }
  else
    {
      occupato_libero (cel, ai);
      if (mossa_en_passant (mossa))
	{
	  z = ai ^ 8;
	  POSIZIONE->qu[z] = conto_pedone_bianco;
	  cel = quadretto_fisso[z];
	  bitbordo_occupato_bianco |= cel;
	  bitbordo_bianco_pedone |= cel;
	  occupato_fisso (cel, z);
	}
    }
  DINAMICO--;
}

void
fare (tipo_posizione *POSIZIONE, uint32 mossa)
{
  if (POSIZIONE->bianco_en_mossa)
    fare_bianco (POSIZIONE, mossa);
  else
    fare_nero (POSIZIONE, mossa);
}

void
annullare (tipo_posizione *POSIZIONE, uint32 mossa)
{
  if (!POSIZIONE->bianco_en_mossa)
    annullare_bianco (POSIZIONE, mossa);
  else
    annullare_nero (POSIZIONE, mossa);
}
