
#include "RobboLito.h"
#include "RobboTotalBase.h"

static char RIMAP[16] =
  { 0, conto_pedone_bianco, conto_cavallo_bianco, conto_re_bianco,
  conto_alfiere_bianco, conto_alfiere_bianco,
  conto_torre_bianco, conto_donna_bianca,
  0, conto_pedone_nero, conto_cavallo_nero, conto_re_nero,
  conto_alfiere_nero, conto_alfiere_nero,
  conto_torre_nero, conto_donna_nera
};

static void
BITBORDO_PQ (tipo_posizione *POSIZIONE, tipo_pezzo_quad * PQ)
{
  uint64 t;
  int n = 0, u;
  t = POSIZIONE->occupato_nero_bianco ^ (bitbordo_bianco_re | bitbordo_nero_re);
  PQ->bianco_en_mossa = POSIZIONE->bianco_en_mossa;
  PQ->br = POSIZIONE->bianco_re_quadretto;
  PQ->nr = POSIZIONE->nero_re_quadretto;
  PQ->pedone = FALSO;
  while (t)
    {
      u = BSF (t);
      PQ->pezzo[n] = RIMAP[POSIZIONE->qu[u]];
      if (PQ->pezzo[n] == conto_pedone_bianco ||
	  PQ->pezzo[n] == conto_pedone_nero)
	PQ->pedone = VERO;
      PQ->qu[n++] = u;
      bitLIBERO (u, t);
    }
}

#define LANCpez(u,x) (x) = lanc_pedone[u][x]
#define LANCnor(u,x) (x) = lanc_norm[u][x]

logico
tot_ind_ott
 (tipo_pezzo_quad * PQ, int *tb, uint64 * ind, uint64 * doppio, int *re_fetta)
{
  int r1, r2, rf;
  int i = 0, v, PEZZO[4], quad[4], x;
  RobboTotalBase *RTB;
  logico simm = FALSO;
  if (doppio != NULL) *doppio = -1;
  if (PQ->bianco_en_mossa)
    {
      r1 = PQ->br;
      r2 = PQ->nr;
    }
  else
    {
      r1 = PQ->nr;
      r2 = PQ->br;
      for (i = 0; i < 4; i++)
	PQ->pezzo[i] = col_scamb[PQ->pezzo[i]];
    }
  v = RTB_PILA[PQ->pezzo[0]][PQ->pezzo[1]][PQ->pezzo[2]][PQ->pezzo[3]];
  RTB = PILA_ROBBO_TOTAL + (v % 65536);

  if ((v % 65536) == -1)
    return FALSO;
  for (i = 0; i < 4; i++)
    {
      x = (v >> (16 + 2 * i)) & 3;
      quad[i] = PQ->qu[x];
      PEZZO[i] = PQ->pezzo[x];
    }
  if (PQ->pedone)
    {
      int w = (2 * (COLONNA (r2) >= CE)) + (!PQ->bianco_en_mossa);
      for (i = 0; i < 4; i++)
	LANCpez (w, quad[i]);
      LANCpez (w, r1);
      LANCpez (w, r2);
      rf = RE_pedone[64 * r1 + r2];
    }
  else
    {
      uint8 w = oLANC[r1][r2];
      for (i = 0; i < 4; i++)
	LANCnor (w, quad[i]);
      LANCnor (w, r1);
      LANCnor (w, r2);
      if (TRAVERSA (r1) == COLONNA (r1) && TRAVERSA (r2) == COLONNA (r2))
	simm = VERO;
      rf = RE_normale[64 * r1 + r2];
    }
  if (rf == -1)
    return FALSO;
  *re_fetta = rf;
  for (i = 0; i < 4; i++)
    {
      if (!PEZZO[i])
	quad[i] = 0;
      if (PEZZO[i] == conto_pedone_bianco || PEZZO[i] == conto_pedone_nero)
	quad[i] -= 8;
    }

  if (PEZZO[0] == PEZZO[3] && PEZZO[3])
    {
      /* quad[0] = STESSO4[quad[0]][quad[1]][quad[2]][quad[3]]; */
      int m0, m1, m2, m3, t0, t1, u0, u1;
      t0 = MASSIMO (quad[0], quad[1]);
      u0 = MINIMO (quad[0], quad[1]);
      t1 = MASSIMO (quad[2], quad[3]);
      u1 = MINIMO (quad[2], quad[3]);
      m0 = MASSIMO (t0, t1);
      m1 = MINIMO (t0, t1);
      m2 = MASSIMO (u0, u1);
      m3 = MINIMO (u0, u1);
      if (m1 < m2) SCAMB (m1, m2);
      quad[0]= (m0 * (m0 - 1) * (m0 - 2) * (m0 - 3)) / 24 +
	(m1 * (m1 - 1) * (m1 - 2)) / 6 + (m2 * (m2 - 1)) / 2 + m3;
      quad[1] = quad[2] = quad[3] = 0;
    }
  else if (PEZZO[0] == PEZZO[2] && PEZZO[2])
    {
      quad[0] = STESSO3[quad[0]][quad[1]][quad[2]];
      quad[1] = quad[2] = 0;
    }
  else if (PEZZO[1] == PEZZO[3] && PEZZO[3])
    {
      quad[1] = STESSO3[quad[1]][quad[2]][quad[3]];
      quad[2] = quad[3] = 0;
    }
  else
    {
      if (PEZZO[0] == PEZZO[1] && PEZZO[1])
	{
	  quad[0] = STESSO2[quad[0]][quad[1]];
	  quad[1] = 0;
	}
      if (PEZZO[1] == PEZZO[2] && PEZZO[2])
	{
	  quad[1] = STESSO2[quad[1]][quad[2]];
	  quad[2] = 0;
	}
      if (PEZZO[2] == PEZZO[3] && PEZZO[3])
	{
	  quad[2] = STESSO2[quad[2]][quad[3]];
	  quad[3] = 0;
	}
    }
  *ind =
    ((quad[0] * RTB->m[1] + quad[1]) * RTB->m[2] + quad[2]) * RTB->m[3]
    + quad[3];
  *tb = v % 65536;
#if 1
  if (doppio == NULL)
    return VERO;
#endif
  if (simm)
    {
      if (PEZZO[0] == PEZZO[3] && PEZZO[3])
	{
	  i = quad_quat_normale[quad[0]];
	  quad[0] = i & 63;
	  quad[1] = (i >> 6) & 63;
	  quad[2] = (i >> 12) & 63;
	  quad[3] = i >> 18;
	}
      else if (PEZZO[0] == PEZZO[2] && PEZZO[2])
	{
	  i = quad_tre_normale[quad[0]];
	  quad[0] = i & 63;
	  quad[1] = (i >> 6) & 63;
	  quad[2] = i >> 12;
	}
      else if (PEZZO[1] == PEZZO[3] && PEZZO[3])
	{
	  i = quad_tre_normale[quad[1]];
	  quad[1] = i & 63;
	  quad[2] = (i >> 6) & 63;
	  quad[3] = i >> 12;
	}
      else
	{
	  if (PEZZO[0] == PEZZO[1] && PEZZO[1])
	    {
	      i = quad_due_normale[quad[0]];
	      quad[0] = i & 63;
	      quad[1] = i >> 6;
	    }
	  if (PEZZO[1] == PEZZO[2] && PEZZO[2])
	    {
	      i = quad_due_normale[quad[1]];
	      quad[1] = i & 63;
	      quad[2] = i >> 6;
	    }
	  if (PEZZO[2] == PEZZO[3] && PEZZO[3])
	    {
	      i = quad_due_normale[quad[2]];
	      quad[2] = i & 63;
	      quad[3] = i >> 6;
	    }
	}
      for (i = 0; i < 4; i++)
	LANCnor (1, quad[i]);
      if (PEZZO[0] == PEZZO[3] && PEZZO[3])
	{
	  /* quad[0] = STESSO4[quad[0]][quad[1]][quad[2]][quad[3]]; */
	  int m0, m1, m2, m3, t0, t1, u0, u1;
	  t0 = MASSIMO (quad[0], quad[1]);
	  u0 = MINIMO (quad[0], quad[1]);
	  t1 = MASSIMO (quad[2], quad[3]);
	  u1 = MINIMO (quad[2], quad[3]);
	  m0 = MASSIMO (t0, t1);
	  m1 = MINIMO (t0, t1);
	  m2 = MASSIMO (u0, u1);
	  m3 = MINIMO (u0, u1);
	  if (m1 < m2) SCAMB (m1, m2);
	  quad[0]= (m0 * (m0 - 1) * (m0 - 2) * (m0 - 3)) / 24 +
	    (m1 * (m1 - 1) * (m1 - 2)) / 6 + (m2 * (m2 - 1)) / 2 + m3;
	  quad[1] = quad[2] = quad[3] = 0;
	}
      else if (PEZZO[0] == PEZZO[2] && PEZZO[2])
	{
	  quad[0] = STESSO3[quad[0]][quad[1]][quad[2]];
	  quad[1] = quad[2] = 0;
	}
      else if (PEZZO[1] == PEZZO[3] && PEZZO[3])
	{
	  quad[1] = STESSO3[quad[1]][quad[2]][quad[3]];
	  quad[2] = quad[3] = 0;
	}
      else
	{
	  if (PEZZO[0] == PEZZO[1] && PEZZO[1])
	    {
	      quad[0] = STESSO2[quad[0]][quad[1]];
	      quad[1] = 0;
	    }
	  if (PEZZO[1] == PEZZO[2] && PEZZO[2])
	    {
	      quad[1] = STESSO2[quad[1]][quad[2]];
	      quad[2] = 0;
	    }
	  if (PEZZO[2] == PEZZO[3] && PEZZO[3])
	    {
	      quad[2] = STESSO2[quad[2]][quad[3]];
	      quad[3] = 0;
	    }
	}
      *doppio =
	((quad[0] * RTB->m[1] + quad[1]) * RTB->m[2] + quad[2]) * RTB->m[3] +
	quad[3];
    }
  else
    *doppio = -1;
  return VERO;
}

logico
fare_PQ (tipo_pezzo_quad * PQ, int *valu, uint64 * ind, uint64 * doppio, int *rf)
{
  int tb;
  RobboTotalBase *RTB;
  *valu = 0;
  if (!tot_ind_ott (PQ, &tb, ind, doppio, rf))
    return FALSO;
  RTB = PILA_ROBBO_TOTAL + tb;
  *valu = tot_valu (RTB, (RTB->pezzo_molt) * (*rf) + (*ind));
  if ((*valu) != dROTT)
    return VERO;
  return FALSO;
}

static logico
total_valu (tipo_posizione *POSIZIONE, int *valu)
{
  uint64 ind;
  int rf;
  tipo_pezzo_quad PQ[1];
  PQ->pezzo[0] = PQ->pezzo[1] = PQ->pezzo[2] = PQ->pezzo[3] = 0;
  PQ->qu[0] = PQ->qu[1] = PQ->qu[2] = PQ->qu[3] = 0;
  BITBORDO_PQ (POSIZIONE, PQ);
  return fare_PQ (PQ, valu, &ind, NULL, &rf);
}

void
ott_indice (tipo_pezzo_quad * PQ, uint64 * ind, uint64 * doppio, int *rf)
{
  int tb;
  if (tot_ind_ott (PQ, &tb, ind, doppio, rf))
    return VERO;
  return FALSO;
}

logico
RobboTotal_valu (tipo_posizione *POSIZIONE, int *valu)
{
  int en_passant = DINAMICO->en_passant, mossa, w, vb = dVITT;
  logico b, b1, b2;
  if (!en_passant)
    return total_valu (POSIZIONE, valu);
  b = total_valu (POSIZIONE, valu);
  if (!b)
    return FALSO;
  if (POSIZIONE->bianco_en_mossa)
    {
      if (COLONNA (en_passant) != CH
	  && (bitbordo_bianco_pedone & quadretto_fisso[en_passant - 7]))
	{
	  mossa = ((en_passant - 7) << 6) | en_passant | pietra_en_passant;
	  fare (POSIZIONE, mossa);
	  mobilita (POSIZIONE);
	  if (!ILLEGALE)
	    {
	      b1 = total_valu (POSIZIONE, &w);
	      if (w > vb)
		vb = w;
	    }
	  annullare (POSIZIONE, mossa);
	}
      if (COLONNA (en_passant) != CA
	  && (bitbordo_bianco_pedone & quadretto_fisso[en_passant - 9]))
	{
	  mossa = ((en_passant - 9) << 6) | en_passant | pietra_en_passant;
	  fare (POSIZIONE, mossa);
	  mobilita (POSIZIONE);
	  if (!ILLEGALE)
	    {
	      b2 = total_valu (POSIZIONE, &w);
	      if (w > vb)
		vb = w;
	    }
	  annullare (POSIZIONE, mossa);
	}
    }
  else
    {
      if (COLONNA (en_passant) != CH
	  && (bitbordo_nero_pedone & quadretto_fisso[en_passant + 9]))
	{
	  mossa = ((en_passant + 9) << 6) | en_passant | pietra_en_passant;
	  fare (POSIZIONE, mossa);
	  mobilita (POSIZIONE);
	  if (!ILLEGALE)
	    {
	      b1 = total_valu (POSIZIONE, &w);
	      if (w > vb)
		vb = w;
	    }
	  annullare (POSIZIONE, mossa);
	}
      if (COLONNA (en_passant) != CA
	  && (bitbordo_nero_pedone & quadretto_fisso[en_passant + 7]))
	{
	  mossa = ((en_passant + 7) << 6) | en_passant | pietra_en_passant;
	  fare (POSIZIONE, mossa);
	  mobilita (POSIZIONE);
	  if (!ILLEGALE)
	    {
	      b2 = total_valu (POSIZIONE, &w);
	      if (w > vb)
		vb = w;
	    }
	  annullare (POSIZIONE, mossa);
	}
    }
  if (DISCO_PERDITA (vb))
    vb = dVITT;
  else if (vb == dVITT)
    vb = dPERD0;
  *valu = MASSIMO (*valu, vb);
  return VERO;
}
