#include "RobboLito.h"
#include <string.h>
#include "sorvegliare.h"

static void
opzione (char *string)
{
  char *v;
  int i, valu;
  if (!memcmp (string, "TranspositionalTabularSizing", 28))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  valu = inizializzazione_zobrist (valu);
	  TRASMISSIONE ("Optional TranspositionalTabularSizing %d\n", valu);
	}
    }
  if (!memcmp (string, "PawnsZobrist", 12))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  valu = pedone_zobrist_inizializzazione (valu);
	  TRASMISSIONE ("Optional PawnsZobrist %d\n", valu);
	}
    }
  if (!memcmp (string, "TitanicCPUsSizings", 18))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  if (valu <= 0)
	    valu = 1;
	  if (valu > 64)
	    valu = 64;
	  if (valu > MAX_CPUS)
	    valu = MAX_CPUS;
	  CPUS_SIZE = valu;
	  TRASMISSIONE ("Optional TitanicCPUsSizings (Capitalist!) %d\n", valu);
	}
    }
  if (!memcmp (string, "TitanicMode", 11))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    TITANIC_MODE = FALSO;
	  if (!strcmp (v + 6, "true"))
	    TITANIC_MODE = VERO;
	}
    }
}

static void
uci ()
{
  TRASMISSIONE ("id name %s verzione %s\n", EPONYM, VERSION);
  TRASMISSIONE ("id author Yakov Petrovich Golyadkin, ");
  TRASMISSIONE ("Igor Igorovich Igoronov, Roberto Pescatore, ");
  TRASMISSIONE ("Yusuf Ralf Weisskopf, ");
  TRASMISSIONE ("Ivan Skavinsky Skavar plus Decembrists (all)\n");
  TRASMISSIONE ("id copyright Yakov Petrovich Golyadkin, "
		"92th plus 93th year from Revolution, PUBLICDOMAIN (workers)\n");
  TRASMISSIONE ("id dedication To Vladimir Ilyich\n");
  TRASMISSIONE
    ("option name TranspositionalTabularSizing (Zobrist) in MegaBytes.");
  TRASMISSIONE (" Note: Only dyadic powers suffice terminally! ");
  TRASMISSIONE ("type spin min 1 max 16384 default 32\n");
  TRASMISSIONE ("option name PawnsZobrist in MegaBytes.");
  TRASMISSIONE (" Note: Only dyadic powers suffice terminally! ");
  TRASMISSIONE ("type spin min 1 max 1024 default 2\n");
  TRASMISSIONE ("option name TitanicMode (Capitalist!) type check default false\n");
  TRASMISSIONE ("option name TitanicCPUsSizings (Capitalist!) type spin min 1 max %d default 1\n", MAX_CPUS);
  TRASMISSIONE ("uciok\n");
}

static void
readyok ()
{
  TRASMISSIONE ("readyok\n");
}

static void
quit ()
{
  exit (0);
}

static void
ingresso_analizi (tipo_posizione *POSIZIONE, char *IN)
{
  if (!strcmp (IN, "quit"))
    quit ();
  if (!strcmp (IN, "stop"))
    cerca_alt (0);
  if (!strcmp (IN, "isready"))
    readyok ();
  if (!strcmp (IN, "ucinewgame"))
    {
      cerca_alt (0);
      partita_nuova (POSIZIONE, VERO);
    }
  if (salto_ok)
    return;
  if (!memcmp (IN, "go", 2))
    {
      cerca_inizializzazione (POSIZIONE, IN);
      if (bordo_legittimo)
	cerca (POSIZIONE);
    }
  if (!memcmp (IN, "position", 8))
    posizionale_inizializzazione (POSIZIONE, IN + 9);
  if (!memcmp (IN, "setoption name", 14))
    opzione (IN + 15);
  if (!strcmp (IN, "uci"))
    uci ();
}

void
ingresso (tipo_posizione *POSIZIONE)
{
  char IN[65536];
  fgets (IN, 65536, stdin);
  IN[strlen (IN) - 1] = 0;
  ingresso_analizi (POSIZIONE, IN);
}
